/**
 * @license
 * Copyright 2021 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
class e{constructor(e,t){this.backend=e,this.dataMover=t,this.data=new WeakMap,this.dataIdsCount=0}get(e){return this.data.has(e)||this.dataMover.moveData(this.backend,e),this.data.get(e)}set(e,t){this.dataIdsCount++,this.data.set(e,t)}has(e){return this.data.has(e)}delete(e){return this.dataIdsCount--,this.data.delete(e)}numDataIds(){return this.dataIdsCount}}class t{refCount(e){return n("refCount")}incRef(e){return n("incRef")}timerAvailable(){return!0}time(e){return n("time")}read(e){return n("read")}readSync(e){return n("readSync")}numDataIds(){return n("numDataIds")}disposeData(e,t){return n("disposeData")}write(e,t,r){return n("write")}move(e,t,r,s,o){return n("move")}memory(){return n("memory")}floatPrecision(){return n("floatPrecision")}epsilon(){return 32===this.floatPrecision()?1e-7:1e-4}dispose(){return n("dispose")}}function n(e){throw new Error(`'${e}' not yet implemented or not found in the registry. This kernel may not be supported by the tfjs backend you have chosen`)}function r(e){let t=e.length,n=0,r=0;for(;t>0;)r=Math.random()*t|0,t--,n=e[t],e[t]=e[r],e[r]=n}function s(e,t,n){return Math.max(e,Math.min(t,n))}function o(e,t){if(!e)throw new Error("string"==typeof t?t:t())}function a(e,t,n=""){o(c(e,t),()=>n+` Shapes ${e} and ${t} must match`)}function i(e){o(null!=e,()=>"The input to the tensor constructor must be a non-null value.")}function l(e,t=[],n=!1){if(null==t&&(t=[]),Array.isArray(e)||w(e)&&!n)for(let r=0;r<e.length;++r)l(e[r],t,n);else t.push(e);return t}function u(e){if(0===e.length)return 1;let t=e[0];for(let n=1;n<e.length;n++)t*=e[n];return t}function c(e,t){if(e===t)return!0;if(null==e||null==t)return!1;if(e.length!==t.length)return!1;for(let n=0;n<e.length;n++)if(e[n]!==t[n])return!1;return!0}function h(e){return e%1==0}function d(e,t){return t<=e.length?e:e+" ".repeat(t-e.length)}function p(e,t){const n=t.length;return o((e=null==e?t.map((e,t)=>t):[].concat(e)).every(e=>e>=-n&&e<n),()=>`All values in axis param must be in range [-${n}, ${n}) but got axis `+e),o(e.every(e=>h(e)),()=>"All values in axis param must be integers but got axis "+e),e.map(e=>e<0?n+e:e)}function f(e,t){const n=[],r=[],s=null!=t&&Array.isArray(t)&&0===t.length,o=null==t||s?null:p(t,e).sort();let a=0;for(let t=0;t<e.length;++t){if(null!=o){if(o[a]===t&&1!==e[t])throw new Error(`Can't squeeze axis ${t} since its dim '${e[t]}' is not 1`);(null==o[a]||o[a]>t)&&1===e[t]&&(n.push(e[t]),r.push(t)),o[a]<=t&&a++}1!==e[t]&&(n.push(e[t]),r.push(t))}return{newShape:n,keptDims:r}}function m(e,t){let n=null;if(null==e||"float32"===e)n=new Float32Array(t);else if("int32"===e)n=new Int32Array(t);else{if("bool"!==e)throw new Error("Unknown data type "+e);n=new Uint8Array(t)}return n}function g(e,t){let n=null;if(null==e||"float32"===e)n=new Float32Array(t);else if("int32"===e)n=new Int32Array(t);else if("bool"===e)n=new Uint8Array(t);else{if("string"!==e)throw new Error("Unknown data type "+e);n=new Array(t)}return n}function b(e,t){for(let n=0;n<e.length;n++){const r=e[n];if(isNaN(r)||!isFinite(r))throw Error(`A tensor of type ${t} being uploaded contains ${r}.`)}}function y(e){return"bool"===e||"complex64"===e||"float32"===e||"int32"===e||"string"===e}function w(e){return e instanceof Float32Array||e instanceof Int32Array||e instanceof Uint8Array}function k(e){if("float32"===e||"int32"===e)return 4;if("complex64"===e)return 8;if("bool"===e)return 1;throw new Error("Unknown dtype "+e)}function v(e){if(null==e)return 0;let t=0;return e.forEach(e=>t+=e.length),t}function x(e){return"string"==typeof e||e instanceof String}function E(e){return"boolean"==typeof e}function S(e){return"number"==typeof e}function A(e){return Array.isArray(e)?A(e[0]):e instanceof Float32Array?"float32":e instanceof Int32Array||e instanceof Uint8Array?"int32":S(e)?"float32":x(e)?"string":E(e)?"bool":"float32"}function I(e){return!!(e&&e.constructor&&e.call&&e.apply)}function $(e,t){for(let n=t;n<e;++n)if(e%n==0)return n;return e}function _(e){const t=e.length;if(t<2)return[];const n=new Array(t-1);n[t-2]=e[t-1];for(let r=t-3;r>=0;--r)n[r]=n[r+1]*e[r+1];return n}function M(e,t,n=!1){if(0===e.length)return t[0];const r=e.reduce((e,t)=>e*t)*(n?2:1);if(0===r)return[];if(r!==t.length)throw new Error(`[${e}] does not match the input size ${t.length}${n?" for a complex tensor":""}.`);return function e(t,n,r,s=!1){const o=new Array;if(1===n.length){const e=n[0]*(s?2:1);for(let n=0;n<e;n++)o[n]=r[t+n]}else{const a=n[0],i=n.slice(1),l=i.reduce((e,t)=>e*t)*(s?2:1);for(let n=0;n<a;n++)o[n]=e(t+n*l,i,r,s)}return o}(0,e,t,n)}function N(e,t){const n=T(e,t);for(let e=0;e<n.length;e++)n[e]=1;return n}function T(e,t){if(null==t||"float32"===t||"complex64"===t)return new Float32Array(e);if("int32"===t)return new Int32Array(e);if("bool"===t)return new Uint8Array(e);throw new Error("Unknown data type "+t)}function D(e){e.forEach(t=>{o(Number.isInteger(t)&&t>=0,()=>`Tensor must have a shape comprised of positive integers but got shape [${e}].`)})}function R(e){return e&&e.then&&"function"==typeof e.then}class F{constructor(e){this.global=e,this.flags={},this.flagRegistry={},this.urlFlags={},this.getQueryParams=C,this.populateURLFlags()}setPlatform(e,t){null!=this.platform&&console.warn(`Platform ${this.platformName} has already been set. Overwriting the platform with ${t}.`),this.platformName=e,this.platform=t}registerFlag(e,t,n){if(this.flagRegistry[e]={evaluationFn:t,setHook:n},null!=this.urlFlags[e]){const t=this.urlFlags[e];console.warn(`Setting feature override from URL ${e}: ${t}.`),this.set(e,t)}}async getAsync(e){return e in this.flags||(this.flags[e]=await this.evaluateFlag(e)),this.flags[e]}get(e){if(e in this.flags)return this.flags[e];const t=this.evaluateFlag(e);if(R(t))throw new Error(`Flag ${e} cannot be synchronously evaluated. Please use getAsync() instead.`);return this.flags[e]=t,this.flags[e]}getNumber(e){return this.get(e)}getBool(e){return this.get(e)}getFlags(){return this.flags}get features(){return this.flags}set(e,t){if(null==this.flagRegistry[e])throw new Error(`Cannot set flag ${e} as it has not been registered.`);this.flags[e]=t,null!=this.flagRegistry[e].setHook&&this.flagRegistry[e].setHook(t)}evaluateFlag(e){if(null==this.flagRegistry[e])throw new Error(`Cannot evaluate flag '${e}': no evaluation function found.`);return this.flagRegistry[e].evaluationFn()}setFlags(e){this.flags=Object.assign({},e)}reset(){this.flags={},this.urlFlags={},this.populateURLFlags()}populateURLFlags(){if(void 0===this.global||void 0===this.global.location||void 0===this.global.location.search)return;const e=this.getQueryParams(this.global.location.search);if("tfjsflags"in e){e.tfjsflags.split(",").forEach(e=>{const[t,n]=e.split(":");this.urlFlags[t]=function(e,t){if("true"===(t=t.toLowerCase())||"false"===t)return"true"===t;if(""+ +t===t)return+t;throw new Error(`Could not parse value flag value ${t} for flag ${e}.`)}(t,n)})}}}function C(e){const t={};return e.replace(/[?&]([^=?&]+)(?:=([^&]*))?/g,(e,...n)=>(function(e,t,n){e[decodeURIComponent(t)]=decodeURIComponent(n||"")}(t,n[0],n[1]),n.join("="))),t}function B(){return z}let P,z=null;function L(){if(null==P){let e;if("undefined"!=typeof window)e=window;else if("undefined"!=typeof global)e=global;else if("undefined"!=typeof process)e=process;else{if("undefined"==typeof self)throw new Error("Could not find a global object");e=self}P=e}return P}function O(e,t){const n=function(){const e=L();return null==e._tfGlobals&&(e._tfGlobals=new Map),e._tfGlobals}();if(n.has(e))return n.get(e);{const r=t();return n.set(e,r),n.get(e)}}const K="Abs",W="Acos",U="Acosh",q="Add",G="AddN",H="All",V="Any",j="ArgMax",J="ArgMin",Y="Asin",Z="Asinh",X="Atan",Q="Atanh",ee="Atan2",te="AvgPool",ne="AvgPoolGrad",re="AvgPool3D",se="AvgPool3DGrad",oe="BatchMatMul",ae="BatchToSpaceND",ie="Bincount",le="BroadcastTo",ue="Cast",ce="Ceil",he="ClipByValue",de="Complex",pe="ComplexAbs",fe="Concat",me="Conv2D",ge="Conv2DBackpropFilter",be="Conv2DBackpropInput",ye="Conv3D",we="Conv3DBackpropFilterV2",ke="Conv3DBackpropInputV2",ve="Cos",xe="Cosh",Ee="Cumsum",Se="CropAndResize",Ae="DenseBincount",Ie="DepthToSpace",$e="DepthwiseConv2dNative",_e="DepthwiseConv2dNativeBackpropFilter",Me="DepthwiseConv2dNativeBackpropInput",Ne="Diag",Te="Dilation2D",De="Dilation2DBackpropInput",Re="Dilation2DBackpropFilter",Fe="RealDiv",Ce="Einsum",Be="Elu",Pe="EluGrad",ze="Erf",Le="Equal",Oe="Exp",Ke="ExpandDims",We="Expm1",Ue="FFT",qe="Fill",Ge="FlipLeftRight",He="Floor",Ve="FloorDiv",je="FusedBatchNorm",Je="GatherV2",Ye="GatherNd",Ze="Greater",Xe="GreaterEqual",Qe="Identity",et="IFFT",tt="Imag",nt="IsFinite",rt="IsInf",st="IsNan",ot="LeakyRelu",at="Less",it="LessEqual",lt="LinSpace",ut="Log",ct="Log1p",ht="LogicalAnd",dt="LogicalNot",pt="LogicalOr",ft="LogSoftmax",mt="LRN",gt="LRNGrad",bt="Max",yt="Maximum",wt="MaxPool",kt="MaxPoolGrad",vt="MaxPool3D",xt="MaxPool3DGrad",Et="MaxPoolWithArgmax",St="Mean",At="Min",It="Minimum",$t="MirrorPad",_t="Mod",Mt="Multinomial",Nt="Multiply",Tt="Neg",Dt="NotEqual",Rt="NonMaxSuppressionV3",Ft="NonMaxSuppressionV4",Ct="NonMaxSuppressionV5",Bt="OnesLike",Pt="OneHot",zt="Pack",Lt="PadV2",Ot="Pool",Kt="Pow",Wt="Prelu",Ut="Prod",qt="Range",Gt="Real",Ht="Reciprocal",Vt="Relu",jt="Reshape",Jt="ResizeNearestNeighbor",Yt="ResizeNearestNeighborGrad",Zt="ResizeBilinear",Xt="ResizeBilinearGrad",Qt="Relu6",en="Reverse",tn="Round",nn="Rsqrt",rn="ScatterNd",sn="Select",on="Selu",an="Slice",ln="Sin",un="Sinh",cn="Sign",hn="Sigmoid",dn="Softplus",pn="Sqrt",fn="Sum",mn="SpaceToBatchND",gn="SplitV",bn="Softmax",yn="SparseReshape",wn="SparseToDense",kn="SquaredDifference",vn="Square",xn="StridedSlice",En="Sub",Sn="Tan",An="Tanh",In="Tile",$n="TopK",_n="Transform",Mn="Transpose",Nn="Unique",Tn="Unpack",Dn="UnsortedSegmentSum",Rn="ZerosLike",Fn="Step",Cn="FromPixels",Bn="RotateWithOffset",Pn="_FusedMatMul",zn="FusedConv2D",Ln="FusedDepthwiseConv2D",On=O("kernelRegistry",()=>new Map),Kn=O("gradRegistry",()=>new Map);function Wn(e,t){const n=Yn(e,t);return On.get(n)}function Un(e){return Kn.get(e)}function qn(e){const t=On.entries(),n=[];for(;;){const{done:r,value:s}=t.next();if(r)break;const[o,a]=s,[i]=o.split("_");i===e&&n.push(a)}return n}function Gn(e){const{kernelName:t,backendName:n}=e,r=Yn(t,n);On.has(r)&&console.warn(`The kernel '${t}' for backend '${n}' is already registered`),On.set(r,e)}function Hn(e){const{kernelName:t}=e;Kn.has(t)&&B().getBool("DEBUG")&&console.warn(`Overriding the gradient for '${t}'`),Kn.set(t,e)}function Vn(e,t){const n=Yn(e,t);if(!On.has(n))throw new Error(`The kernel '${e}' for backend '${t}' is not registered`);On.delete(n)}function jn(e){if(!Kn.has(e))throw new Error(`The gradient '${e}' for backend is not registered`);Kn.delete(e)}function Jn(e,t){qn(e).forEach(e=>{Gn(Object.assign({},e,{backendName:t}))})}function Yn(e,t){return`${t}_${e}`}function Zn(e,t){if("string"===t)throw new Error("Cannot convert a string[] to a TypedArray");if(Array.isArray(e)&&(e=l(e)),B().getBool("DEBUG")&&b(e,t),function(e,t){return e instanceof Float32Array&&"float32"===t||e instanceof Int32Array&&"int32"===t||e instanceof Uint8Array&&"bool"===t}(e,t))return e;if(null==t||"float32"===t||"complex64"===t)return new Float32Array(e);if("int32"===t)return new Int32Array(e);if("bool"===t){const t=new Uint8Array(e.length);for(let n=0;n<t.length;++n)0!==Math.round(e[n])&&(t[n]=1);return t}throw new Error("Unknown data type "+t)}function Xn(){return B().platform.now()}function Qn(e,t="utf-8"){return t=t||"utf-8",B().platform.encode(e,t)}function er(e,t="utf-8"){return t=t||"utf-8",B().platform.decode(e,t)}var tr=Object.freeze({__proto__:null,createScalarValue:function(e,t){return"string"===t?Qn(e):Zn([e],t)},toTypedArray:Zn,now:Xn,fetch:function(e,t){return B().platform.fetch(e,t)},encodeString:Qn,decodeString:er,shuffle:r,shuffleCombo:function(e,t){if(e.length!==t.length)throw new Error("Array sizes must match to be shuffled together First array length was "+e.length+"Second array length was "+t.length);let n,r,s=e.length,o=0;for(;s>0;)o=Math.random()*s|0,s--,n=e[s],r=t[s],e[s]=e[o],t[s]=t[o],e[o]=n,t[o]=r},clamp:s,nearestLargerEven:function(e){return e%2==0?e:e+1},sum:function(e){let t=0;for(let n=0;n<e.length;n++)t+=e[n];return t},randUniform:function(e,t){const n=Math.random();return t*n+(1-n)*e},distSquared:function(e,t){let n=0;for(let r=0;r<e.length;r++){const s=Number(e[r])-Number(t[r]);n+=s*s}return n},assert:o,assertShapesMatch:a,assertNonNull:i,flatten:l,sizeFromShape:u,isScalarShape:function(e){return 0===e.length},arraysEqual:c,isInt:h,tanh:function(e){if(null!=Math.tanh)return Math.tanh(e);if(e===1/0)return 1;if(e===-1/0)return-1;{const t=Math.exp(2*e);return(t-1)/(t+1)}},sizeToSquarishShape:function(e){const t=Math.ceil(Math.sqrt(e));return[t,Math.ceil(e/t)]},createShuffledIndices:function(e){const t=new Uint32Array(e);for(let n=0;n<e;++n)t[n]=n;return r(t),t},rightPad:d,repeatedTry:function(e,t=(e=>0),n){return new Promise((r,s)=>{let o=0;const a=()=>{if(e())return void r();o++;const i=t(o);null!=n&&o>=n?s():setTimeout(a,i)};a()})},inferFromImplicitShape:function(e,t){let n=1,r=-1;for(let t=0;t<e.length;++t)if(e[t]>=0)n*=e[t];else if(-1===e[t]){if(-1!==r)throw Error(`Shapes can only have 1 implicit size. Found -1 at dim ${r} and dim ${t}`);r=t}else if(e[t]<0)throw Error(`Shapes can not be < 0. Found ${e[t]} at dim ${t}`);if(-1===r){if(t>0&&t!==n)throw Error(`Size(${t}) must match the product of shape ${e}`);return e}if(0===n)throw Error(`Cannot infer the missing size in [${e}] when there are 0 elements`);if(t%n!=0)throw Error(`The implicit shape can't be a fractional number. Got ${t} / ${n}`);const s=e.slice();return s[r]=t/n,s},parseAxisParam:p,squeezeShape:f,getTypedArrayFromDType:m,getArrayFromDType:g,checkConversionForErrors:b,isValidDtype:y,hasEncodingLoss:function(e,t){return"complex64"!==t&&(("float32"!==t||"complex64"===e)&&(("int32"!==t||"float32"===e||"complex64"===e)&&("bool"!==t||"bool"!==e)))},isTypedArray:w,bytesPerElement:k,bytesFromStringArray:v,isString:x,isBoolean:E,isNumber:S,inferDtype:A,isFunction:I,nearestDivisor:$,computeStrides:_,toNestedArray:M,makeOnesTypedArray:N,makeZerosTypedArray:T,makeZerosNestedTypedArray:function(e,t){const n=e.reduce((e,t)=>e*t,1);if(null==t||"float32"===t)return M(e,new Float32Array(n));if("int32"===t)return M(e,new Int32Array(n));if("bool"===t)return M(e,new Uint8Array(n));throw new Error("Unknown data type "+t)},assertNonNegativeIntegerDimensions:D,locToIndex:function(e,t,n){if(0===t)return 0;if(1===t)return e[0];let r=e[e.length-1];for(let t=0;t<e.length-1;++t)r+=n[t]*e[t];return r},indexToLoc:function(e,t,n){if(0===t)return[];if(1===t)return[e];const r=new Array(t);for(let t=0;t<r.length-1;++t)r[t]=Math.floor(e/n[t]),e-=r[t]*n[t];return r[r.length-1]=e,r},isPromise:R});class nr{constructor(e,t){this.backendTimer=e,this.logger=t,null==t&&(this.logger=new sr)}profileKernel(e,t,n){let r;const s=()=>{r=n()};let o;const a=Xn();if(this.backendTimer.timerAvailable())o=this.backendTimer.time(s);else{s();for(const e of r)e.dataSync();o=Promise.resolve({kernelMs:Xn()-a})}if(B().getBool("CHECK_COMPUTATION_FOR_ERRORS"))for(let t=0;t<r.length;t++){const n=r[t];n.data().then(t=>{rr(t,n.dtype,e)})}return{kernelName:e,outputs:r,inputs:t,timeMs:o.then(e=>e.kernelMs),extraInfo:o.then(e=>null!=e.getExtraProfileInfo?e.getExtraProfileInfo():"")}}logKernelProfile(e){const{kernelName:t,outputs:n,timeMs:r,inputs:s,extraInfo:o}=e;n.forEach(e=>{Promise.all([e.data(),r,o]).then(n=>{this.logger.logKernelProfile(t,e,n[0],n[1],s,n[2])})})}}function rr(e,t,n){if("float32"!==t)return!1;for(let t=0;t<e.length;t++){const r=e[t];if(isNaN(r)||!isFinite(r))return console.warn(`Found ${r} in the result of '${n}'`),!0}return!1}class sr{logKernelProfile(e,t,n,r,s,o){const a="number"==typeof r?d(r+"ms",9):r.error,i=d(e,25),l=t.rank,u=t.size,c=d(t.shape.toString(),14);let h="";for(const e in s){const n=s[e];if(null!=n){const r=n.shape||t.shape,s=r.length;h+=`${e}: ${s}D ${s>0?r:""} `}}console.log(`%c${i}\t%c${a}\t%c${l}D ${c}\t%c${u}\t%c${h}\t%c${o}`,"font-weight:bold","color:red","color:blue","color: orange","color: green","color: steelblue")}}function or(e,t,n,r){const s=_(t),o=function(e,t,n,r){const s=u(t),o=r[r.length-1],a=new Array(o).fill(0),i=t.length,l="complex64"===n?lr(e):e;if(i>1)for(let e=0;e<s/o;e++){const t=e*o;for(let e=0;e<o;e++)a[e]=Math.max(a[e],ar(l[t+e],0,n).length)}return a}(e,t,n,s),a=t.length,i=function e(t,n,r,s,o,a=!0){const i="complex64"===r?2:1,l=n[0],u=n.length;if(0===u){if("complex64"===r){return[ar(lr(t)[0],0,r)]}return"bool"===r?[ir(t[0])]:[t[0].toString()]}if(1===u){if(l>20){const e=3*i;let n=Array.from(t.slice(0,e)),s=Array.from(t.slice((l-3)*i,l*i));return"complex64"===r&&(n=lr(n),s=lr(s)),["["+n.map((e,t)=>ar(e,o[t],r)).join(", ")+", ..., "+s.map((e,t)=>ar(e,o[l-3+t],r)).join(", ")+"]"]}return["["+("complex64"===r?lr(t):Array.from(t)).map((e,t)=>ar(e,o[t],r)).join(", ")+"]"]}const c=n.slice(1),h=s.slice(1),d=s[0]*i,p=[];if(l>20){for(let n=0;n<3;n++){const s=n*d,a=s+d;p.push(...e(t.slice(s,a),c,r,h,o,!1))}p.push("...");for(let n=l-3;n<l;n++){const s=n*d,a=s+d;p.push(...e(t.slice(s,a),c,r,h,o,n===l-1))}}else for(let n=0;n<l;n++){const s=n*d,a=s+d;p.push(...e(t.slice(s,a),c,r,h,o,n===l-1))}const f=2===u?",":"";p[0]="["+p[0]+f;for(let e=1;e<p.length-1;e++)p[e]=" "+p[e]+f;let m=",\n";for(let e=2;e<u;e++)m+="\n";return p[p.length-1]=" "+p[p.length-1]+"]"+(a?"":m),p}(e,t,n,s,o),l=["Tensor"];return r&&(l.push("  dtype: "+n),l.push("  rank: "+a),l.push(`  shape: [${t}]`),l.push("  values:")),l.push(i.map(e=>"    "+e).join("\n")),l.join("\n")}function ar(e,t,n){let r;return r=Array.isArray(e)?parseFloat(e[0].toFixed(7))+" + "+parseFloat(e[1].toFixed(7))+"j":x(e)?`'${e}'`:"bool"===n?ir(e):parseFloat(e.toFixed(7)).toString(),d(r,t)}function ir(e){return 0===e?"false":"true"}function lr(e){const t=[];for(let n=0;n<e.length;n+=2)t.push([e[n],e[n+1]]);return t}class ur{constructor(e,t,n){if(this.dtype=t,this.shape=e.slice(),this.size=u(e),null!=n){const e=n.length;o(e===this.size,()=>`Length of values '${e}' does not match the size inferred by the shape '${this.size}'.`)}if("complex64"===t)throw new Error("complex64 dtype TensorBuffers are not supported. Please create a TensorBuffer for the real and imaginary parts separately and call tf.complex(real, imag).");this.values=n||g(t,this.size),this.strides=_(e)}set(e,...t){0===t.length&&(t=[0]),o(t.length===this.rank,()=>`The number of provided coordinates (${t.length}) must match the rank (${this.rank})`);const n=this.locToIndex(t);this.values[n]=e}get(...e){0===e.length&&(e=[0]);let t=0;for(const n of e){if(n<0||n>=this.shape[t]){const t=`Requested out of range element at ${e}.   Buffer shape=`+this.shape;throw new Error(t)}t++}let n=e[e.length-1];for(let t=0;t<e.length-1;++t)n+=this.strides[t]*e[t];return this.values[n]}locToIndex(e){if(0===this.rank)return 0;if(1===this.rank)return e[0];let t=e[e.length-1];for(let n=0;n<e.length-1;++n)t+=this.strides[n]*e[n];return t}indexToLoc(e){if(0===this.rank)return[];if(1===this.rank)return[e];const t=new Array(this.shape.length);for(let n=0;n<t.length-1;++n)t[n]=Math.floor(e/this.strides[n]),e-=t[n]*this.strides[n];return t[t.length-1]=e,t}get rank(){return this.shape.length}toTensor(){return cr().makeTensor(this.values,this.shape,this.dtype)}}let cr=null,hr=null;class dr{constructor(e,t,n,r){this.kept=!1,this.isDisposedInternal=!1,this.shape=e.slice(),this.dtype=t||"float32",this.size=u(e),this.strides=_(e),this.dataId=n,this.id=r,this.rankType=this.rank<5?this.rank.toString():"higher"}get rank(){return this.shape.length}async buffer(){const e=await this.data();return hr.buffer(this.shape,this.dtype,e)}bufferSync(){return hr.buffer(this.shape,this.dtype,this.dataSync())}async array(){const e=await this.data();return M(this.shape,e,"complex64"===this.dtype)}arraySync(){return M(this.shape,this.dataSync(),"complex64"===this.dtype)}async data(){this.throwIfDisposed();const e=cr().read(this.dataId);if("string"===this.dtype){const t=await e;try{return t.map(e=>er(e))}catch(e){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}}return e}dataSync(){this.throwIfDisposed();const e=cr().readSync(this.dataId);if("string"===this.dtype)try{return e.map(e=>er(e))}catch(e){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}return e}async bytes(){this.throwIfDisposed();const e=await cr().read(this.dataId);return"string"===this.dtype?e:new Uint8Array(e.buffer)}dispose(){this.isDisposed||(cr().disposeTensor(this),this.isDisposedInternal=!0)}get isDisposed(){return this.isDisposedInternal}throwIfDisposed(){if(this.isDisposed)throw new Error("Tensor is disposed.")}print(e=!1){return hr.print(this,e)}clone(){return this.throwIfDisposed(),hr.clone(this)}toString(e=!1){return or(this.dataSync(),this.shape,this.dtype,e)}cast(e){return this.throwIfDisposed(),hr.cast(this,e)}variable(e=!0,t,n){return this.throwIfDisposed(),cr().makeVariable(this,e,t,n)}}Object.defineProperty(dr,Symbol.hasInstance,{value:e=>!!e&&null!=e.data&&null!=e.dataSync&&null!=e.throwIfDisposed}),O("Tensor",()=>dr);class pr extends dr{constructor(e,t,n,r){super(e.shape,e.dtype,e.dataId,r),this.trainable=t,this.name=n}assign(e){if(e.dtype!==this.dtype)throw new Error(`dtype of the new value (${e.dtype}) and previous value (${this.dtype}) must match`);if(!c(e.shape,this.shape))throw new Error(`shape of the new value (${e.shape}) and previous value (${this.shape}) must match`);cr().disposeTensor(this),this.dataId=e.dataId,cr().incRef(this,null)}dispose(){cr().disposeVariable(this),this.isDisposedInternal=!0}}var fr,mr,gr,br,yr;Object.defineProperty(pr,Symbol.hasInstance,{value:e=>e instanceof dr&&null!=e.assign&&e.assign instanceof Function}),function(e){e.R0="R0",e.R1="R1",e.R2="R2",e.R3="R3",e.R4="R4",e.R5="R5",e.R6="R6"}(fr||(fr={})),function(e){e.float32="float32",e.int32="int32",e.bool="int32",e.complex64="complex64"}(mr||(mr={})),function(e){e.float32="float32",e.int32="int32",e.bool="bool",e.complex64="complex64"}(gr||(gr={})),function(e){e.float32="float32",e.int32="float32",e.bool="float32",e.complex64="complex64"}(br||(br={})),function(e){e.float32="complex64",e.int32="complex64",e.bool="complex64",e.complex64="complex64"}(yr||(yr={}));const wr={float32:br,int32:mr,bool:gr,complex64:yr};function kr(e,t){if("string"===e||"string"===t){if("string"===e&&"string"===t)return"string";throw new Error(`Can not upcast ${e} with ${t}`)}return wr[e][t]}function vr(e){return kr(e,"int32")}function xr(e,t){if(e.dtype===t.dtype)return[e,t];const n=kr(e.dtype,t.dtype);return[e.cast(n),t.cast(n)]}function Er(e,t){o(e.dtype===t.dtype,()=>`The dtypes of the first(${e.dtype}) and second(${t.dtype}) input must match`)}function Sr(e){const t=[];return function e(t,n,r){if(null==t)return;if(t instanceof dr)return void n.push(t);if(s=t,!Array.isArray(s)&&"object"!=typeof s)return;var s;const o=t;for(const t in o){const s=o[t];r.has(s)||(r.add(s),e(s,n,r))}}(e,t,new Set),t}var Ar=Object.freeze({__proto__:null,makeTypesMatch:xr,assertTypesMatch:Er,isTensorInList:function(e,t){return t.some(t=>t.id===e.id)},getTensorsInContainer:Sr});function Ir(e){return null!=e.kernelName}class $r{constructor(){this.registeredVariables={},this.nextTapeNodeId=0,this.numBytes=0,this.numTensors=0,this.numStringTensors=0,this.numDataBuffers=0,this.gradientDepth=0,this.kernelDepth=0,this.scopeStack=[],this.numDataMovesStack=[],this.nextScopeId=0,this.tensorInfo=new WeakMap,this.profiling=!1,this.activeProfile={newBytes:0,newTensors:0,peakBytes:0,kernels:[],result:null,get kernelNames(){return Array.from(new Set(this.kernels.map(e=>e.name)))}}}dispose(){for(const e in this.registeredVariables)this.registeredVariables[e].dispose()}}class _r{constructor(e){this.ENV=e,this.registry={},this.registryFactory={},this.pendingBackendInitId=0,this.state=new $r}async ready(){if(null!=this.pendingBackendInit)return this.pendingBackendInit.then(()=>{});if(null!=this.backendInstance)return;const e=this.getSortedBackends();for(let t=0;t<e.length;t++){const n=e[t];if(await this.initializeBackend(n).success)return void await this.setBackend(n)}throw new Error("Could not initialize any backends, all backend initializations failed.")}get backend(){if(null!=this.pendingBackendInit)throw new Error(`Backend '${this.backendName}' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods`);if(null==this.backendInstance){const{name:e,asyncInit:t}=this.initializeBackendsAndReturnBest();if(t)throw new Error(`The highest priority backend '${e}' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods`);this.setBackend(e)}return this.backendInstance}backendNames(){return Object.keys(this.registryFactory)}findBackend(e){if(!(e in this.registry)){if(!(e in this.registryFactory))return null;{const{asyncInit:t}=this.initializeBackend(e);if(t)return null}}return this.registry[e]}findBackendFactory(e){return e in this.registryFactory?this.registryFactory[e].factory:null}registerBackend(e,t,n=1){return e in this.registryFactory?(console.warn(e+" backend was already registered. Reusing existing backend factory."),!1):(this.registryFactory[e]={factory:t,priority:n},!0)}async setBackend(e){if(null==this.registryFactory[e])throw new Error(`Backend name '${e}' not found in registry`);if(this.backendName=e,null==this.registry[e]){this.backendInstance=null;const{success:t,asyncInit:n}=this.initializeBackend(e);if(!(n?await t:t))return!1}return this.backendInstance=this.registry[e],this.setupRegisteredKernels(),this.profiler=new nr(this.backendInstance),!0}setupRegisteredKernels(){qn(this.backendName).forEach(e=>{null!=e.setupFunc&&e.setupFunc(this.backendInstance)})}disposeRegisteredKernels(e){qn(e).forEach(t=>{null!=t.disposeFunc&&t.disposeFunc(this.registry[e])})}initializeBackend(e){const n=this.registryFactory[e];if(null==n)throw new Error(`Cannot initialize backend ${e}, no registration found.`);try{const r=n.factory();if(!r||r instanceof t||"function"!=typeof r.then)return this.registry[e]=r,{success:!0,asyncInit:!1};{const t=++this.pendingBackendInitId,n=r.then(n=>!(t<this.pendingBackendInitId)&&(this.registry[e]=n,this.pendingBackendInit=null,!0)).catch(n=>(t<this.pendingBackendInitId||(this.pendingBackendInit=null,console.warn(`Initialization of backend ${e} failed`),console.warn(n.stack||n.message)),!1));return this.pendingBackendInit=n,{success:n,asyncInit:!0}}}catch(t){return console.warn(`Initialization of backend ${e} failed`),console.warn(t.stack||t.message),{success:!1,asyncInit:!1}}}removeBackend(e){if(!(e in this.registryFactory))throw new Error(e+" backend not found in registry");this.backendName===e&&null!=this.pendingBackendInit&&this.pendingBackendInitId++,e in this.registry&&(this.disposeRegisteredKernels(e),this.registry[e].dispose(),delete this.registry[e]),delete this.registryFactory[e],this.backendName===e&&(this.pendingBackendInit=null,this.backendName=null,this.backendInstance=null)}getSortedBackends(){if(0===Object.keys(this.registryFactory).length)throw new Error("No backend found in registry.");return Object.keys(this.registryFactory).sort((e,t)=>this.registryFactory[t].priority-this.registryFactory[e].priority)}initializeBackendsAndReturnBest(){const e=this.getSortedBackends();for(let t=0;t<e.length;t++){const n=e[t],{success:r,asyncInit:s}=this.initializeBackend(n);if(s||r)return{name:n,asyncInit:s}}throw new Error("Could not initialize any backends, all backend initializations failed.")}moveData(e,t){const n=this.state.tensorInfo.get(t),r=n.backend,s=this.readSync(t),o=r.refCount(t);r.disposeData(t,!0),n.backend=e,e.move(t,s,n.shape,n.dtype,o),this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack[this.state.numDataMovesStack.length-1]++}tidy(e,t){let n,r=null;if(null==t){if("function"!=typeof e)throw new Error("Please provide a function to tidy()");t=e}else{if("string"!=typeof e&&!(e instanceof String))throw new Error("When calling with two arguments, the first argument to tidy() must be a string");if("function"!=typeof t)throw new Error("When calling with two arguments, the 2nd argument to tidy() must be a function");r=e}return this.scopedRun(()=>this.startScope(r),()=>this.endScope(n),()=>(n=t(),n instanceof Promise&&console.error("Cannot return a Promise inside of tidy."),n))}scopedRun(e,t,n){e();try{const e=n();return t(),e}catch(e){throw t(),e}}nextTensorId(){return _r.nextTensorId++}nextVariableId(){return _r.nextVariableId++}clone(e){const t=Nr.runKernel("Identity",{x:e}),n={x:e};return this.addTapeNode(this.state.activeScope.name,n,[t],e=>({x:()=>{const t={x:e},n={dtype:"float32"};return Nr.runKernel("Cast",t,n)}}),[],{}),t}runKernel(e,t,n){if(!(null!=Wn(e,this.backendName)))throw new Error(`Kernel '${e}' not registered for backend '${this.backendName}'`);return this.runKernelFunc({kernelName:e,inputs:t,attrs:n})}shouldCheckForMemLeaks(){return this.ENV.getBool("IS_TEST")}checkKernelForMemLeak(e,t,n){const r=this.backend.numDataIds();let s=0;n.forEach(e=>{s+="complex64"===e.dtype?3:1});const o=this.state.numDataMovesStack[this.state.numDataMovesStack.length-1],a=r-t-s-o;if(a>0)throw new Error(`Backend '${this.backendName}' has an internal memory leak (${a} data ids) after running '${e}'`)}runKernelFunc(e){let t,n=[];const r=this.isTapeOn(),s=this.state.numBytes,a=this.state.numTensors;let i,l;this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack.push(0),null==this.backendName&&this.backend;const u=Ir(e)?e.kernelName:null!=this.state.activeScope?this.state.activeScope.name:"";if(Ir(e)){const{kernelName:t,inputs:s,attrs:a}=e;null==this.backendName&&this.backend;const u=Wn(t,this.backendName);o(null!=u,()=>`Cannot find registered kernel '${t}' for backend '${this.backendName}'`),i=()=>{const e=this.backend.numDataIds();l=u.kernelFunc({inputs:s,attrs:a,backend:this.backend});const o=Array.isArray(l)?l:[l];this.shouldCheckForMemLeaks()&&this.checkKernelForMemLeak(t,e,o);const i=o.map(e=>{if(null!=e.rank)return e;const{dataId:t,shape:n,dtype:r}=e;return this.makeTensorFromDataId(t,n,r)});if(r){const e=this.getTensorsForGradient(t,s,i);n=this.saveTensorsForBackwardMode(e)}return i}}else{const{forwardFunc:t}=e,s=e=>{r&&(n=e.map(e=>this.keep(this.clone(e))))};i=()=>{const e=this.backend.numDataIds();l=this.tidy(()=>t(this.backend,s));const n=Array.isArray(l)?l:[l];return this.shouldCheckForMemLeaks()&&this.checkKernelForMemLeak(u,e,n),n}}const{inputs:c,attrs:h}=e,d=Ir(e)?null:e.backwardsFunc;let p;return this.scopedRun(()=>this.state.kernelDepth++,()=>this.state.kernelDepth--,()=>{this.ENV.getBool("DEBUG")||this.state.profiling?(p=this.profiler.profileKernel(u,c,()=>i()),this.ENV.getBool("DEBUG")&&this.profiler.logKernelProfile(p),t=p.outputs):t=i()}),r&&this.addTapeNode(u,c,t,d,n,h),this.state.profiling&&this.state.activeProfile.kernels.push({name:u,bytesAdded:this.state.numBytes-s,totalBytesSnapshot:this.state.numBytes,tensorsAdded:this.state.numTensors-a,totalTensorsSnapshot:this.state.numTensors,inputShapes:Object.keys(c).map(e=>null!=c[e]?c[e].shape:null),outputShapes:t.map(e=>e.shape),kernelTimeMs:p.timeMs,extraInfo:p.extraInfo}),Array.isArray(l)?t:t[0]}saveTensorsForBackwardMode(e){return e.map(e=>this.keep(this.clone(e)))}getTensorsForGradient(e,t,n){const r=Un(e);if(null!=r){const e=r.inputsToSave||[],s=r.outputsToSave||[];let a;r.saveAllInputs?(o(Array.isArray(t),()=>"saveAllInputs is true, expected inputs to be an array."),a=Object.keys(t).map(e=>t[e])):a=e.map(e=>t[e]);const i=n.filter((e,t)=>s[t]);return a.concat(i)}return[]}makeTensor(e,t,n,r){if(null==e)throw new Error("Values passed to engine.makeTensor() are null");n=n||"float32",r=r||this.backend;let s=e;"string"===n&&x(e[0])&&(s=e.map(e=>Qn(e)));const o=r.write(s,t,n),a=new dr(t,n,o,this.nextTensorId());if(this.trackTensor(a,r),"string"===n){const e=this.state.tensorInfo.get(o),t=v(s);this.state.numBytes+=t-e.bytes,e.bytes=t}return a}makeTensorFromDataId(e,t,n,r){const s=new dr(t,n=n||"float32",e,this.nextTensorId());return this.trackTensor(s,r),s}makeVariable(e,t=!0,n,r){n=n||this.nextVariableId().toString(),null!=r&&r!==e.dtype&&(e=e.cast(r));const s=new pr(e,t,n,this.nextTensorId());if(null!=this.state.registeredVariables[s.name])throw new Error(`Variable with name ${s.name} was already registered`);return this.state.registeredVariables[s.name]=s,this.incRef(s,this.backend),s}trackTensor(e,t){this.state.numTensors++,"string"===e.dtype&&this.state.numStringTensors++;let n=0;"complex64"!==e.dtype&&"string"!==e.dtype&&(n=e.size*k(e.dtype)),this.state.numBytes+=n,this.state.tensorInfo.has(e.dataId)||(this.state.numDataBuffers++,this.state.tensorInfo.set(e.dataId,{backend:t||this.backend,dtype:e.dtype,shape:e.shape,bytes:n})),e instanceof pr||this.track(e)}incRef(e,t){this.trackTensor(e,t),this.backend.incRef(e.dataId)}removeDataId(e,t){this.state.tensorInfo.has(e)&&this.state.tensorInfo.get(e).backend===t&&(this.state.tensorInfo.delete(e),this.state.numDataBuffers--)}disposeTensor(e){if(!this.state.tensorInfo.has(e.dataId))return;const t=this.state.tensorInfo.get(e.dataId);if(this.state.numTensors--,"string"===e.dtype&&(this.state.numStringTensors--,this.state.numBytes-=t.bytes),"complex64"!==e.dtype&&"string"!==e.dtype){const t=e.size*k(e.dtype);this.state.numBytes-=t}t.backend.disposeData(e.dataId)&&this.removeDataId(e.dataId,t.backend)}disposeVariables(){for(const e in this.state.registeredVariables){const t=this.state.registeredVariables[e];this.disposeVariable(t)}}disposeVariable(e){this.disposeTensor(e),null!=this.state.registeredVariables[e.name]&&delete this.state.registeredVariables[e.name]}memory(){const e=this.backend.memory();return e.numTensors=this.state.numTensors,e.numDataBuffers=this.state.numDataBuffers,e.numBytes=this.state.numBytes,this.state.numStringTensors>0&&(e.unreliable=!0,null==e.reasons&&(e.reasons=[]),e.reasons.push("Memory usage by string tensors is approximate (2 bytes per character)")),e}async profile(e){this.state.profiling=!0;const t=this.state.numBytes,n=this.state.numTensors;this.state.activeProfile.kernels=[],this.state.activeProfile.result=await e(),this.state.profiling=!1,this.state.activeProfile.peakBytes=Math.max(...this.state.activeProfile.kernels.map(e=>e.totalBytesSnapshot)),this.state.activeProfile.newBytes=this.state.numBytes-t,this.state.activeProfile.newTensors=this.state.numTensors-n;for(const e of this.state.activeProfile.kernels)e.kernelTimeMs=await e.kernelTimeMs,e.extraInfo=await e.extraInfo;return this.state.activeProfile}isTapeOn(){return this.state.gradientDepth>0&&0===this.state.kernelDepth}addTapeNode(e,t,n,r,s,o){const a={id:this.state.nextTapeNodeId++,kernelName:e,inputs:t,outputs:n,saved:s},i=Un(e);null!=i&&(r=i.gradFunc),null!=r&&(a.gradient=e=>(e=e.map((e,t)=>{if(null==e){const e=n[t],r=T(e.size,e.dtype);return this.makeTensor(r,e.shape,e.dtype)}return e}),r(e.length>1?e:e[0],s,o))),this.state.activeTape.push(a)}keep(e){return e.kept=!0,e}startTape(){0===this.state.gradientDepth&&(this.state.activeTape=[]),this.state.gradientDepth++}endTape(){this.state.gradientDepth--}startScope(e){const t={track:[],name:"unnamed scope",id:this.state.nextScopeId++};e&&(t.name=e),this.state.scopeStack.push(t),this.state.activeScope=t}endScope(e){const t=Sr(e),n=new Set(t.map(e=>e.id));for(let e=0;e<this.state.activeScope.track.length;e++){const t=this.state.activeScope.track[e];t.kept||n.has(t.id)||t.dispose()}const r=this.state.scopeStack.pop();this.state.activeScope=0===this.state.scopeStack.length?null:this.state.scopeStack[this.state.scopeStack.length-1],t.forEach(e=>{e.kept||e.scopeId!==r.id||this.track(e)})}gradients(e,t,n,r=!1){if(o(t.length>0,()=>"gradients() received an empty list of xs."),null!=n&&"float32"!==n.dtype)throw new Error(`dy must have 'float32' dtype, but has '${n.dtype}'`);const s=this.scopedRun(()=>this.startTape(),()=>this.endTape(),()=>this.tidy("forward",e));o(s instanceof dr,()=>"The result y returned by f() must be a tensor.");const a=function(e,t,n){const r={},s={};for(let e=0;e<t.length;e++)r[t[e].id]=!0;for(let n=0;n<e.length;n++){const o=e[n],a=o.inputs;for(const e in a){const n=a[e];let i=!1;for(let e=0;e<t.length;e++)if(r[n.id]){o.outputs.forEach(e=>r[e.id]=!0),i=!0,s[o.id]=!0;break}if(i)break}}const o={};o[n.id]=!0;const a={};for(let t=e.length-1;t>=0;t--){const n=e[t],r=n.inputs;for(let e=0;e<n.outputs.length;e++)if(o[n.outputs[e].id]){for(const e in r)o[r[e].id]=!0,a[n.id]=!0;break}}const i=[];for(let t=0;t<e.length;t++){const n=e[t];if(s[n.id]&&a[n.id]){const e={};for(const t in n.inputs){const s=n.inputs[t];r[s.id]&&(e[t]=s)}const t=Object.assign({},n);t.inputs=e,t.outputs=n.outputs,i.push(t)}}return i}(this.state.activeTape,t,s);if(!r&&0===a.length&&t.length>0)throw new Error("Cannot compute gradient of y=f(x) with respect to x. Make sure that the f you passed encloses all operations that lead from x to y.");return this.tidy("backward",()=>{const e={};e[s.id]=null==n?function(e){const t=N(u(e),"float32");return Nr.makeTensor(t,e,"float32")}(s.shape):n,function(e,t,n,r){for(let s=t.length-1;s>=0;s--){const o=t[s],a=[];if(o.outputs.forEach(t=>{const n=e[t.id];null!=n?a.push(n):a.push(null)}),null==o.gradient)throw new Error(`Cannot compute gradient: gradient function not found for ${o.kernelName}.`);const i=o.gradient(a);for(const t in o.inputs){if(!(t in i))throw new Error(`Cannot backprop through input ${t}. Available gradients found: ${Object.keys(i)}.`);const s=n(()=>i[t]());if("float32"!==s.dtype)throw new Error(`Error in gradient for op ${o.kernelName}. The gradient of input ${t} must have 'float32' dtype, but has '${s.dtype}'`);const a=o.inputs[t];if(!c(s.shape,a.shape))throw new Error(`Error in gradient for op ${o.kernelName}. The gradient of input '${t}' has shape '${s.shape}', which does not match the shape of the input '${a.shape}'`);if(null==e[a.id])e[a.id]=s;else{const t=e[a.id];e[a.id]=r(t,s),t.dispose()}}}}(e,a,e=>this.tidy(e),Tr);const r=t.map(t=>e[t.id]);return 0===this.state.gradientDepth&&(this.state.activeTape.forEach(e=>{for(const t of e.saved)t.dispose()}),this.state.activeTape=null),{value:s,grads:r}})}customGrad(e){return o(I(e),()=>"The f passed in customGrad(f) must be a function."),(...t)=>{let n;o(t.every(e=>e instanceof dr),()=>"The args passed in customGrad(f)(x1, x2,...) must all be tensors");const r={};t.forEach((e,t)=>{r[t]=e});return this.runKernelFunc({forwardFunc:(r,s)=>(n=e(...t,s),o(n.value instanceof dr,()=>"The function f passed in customGrad(f) must return an object where `obj.value` is a tensor"),o(I(n.gradFunc),()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function."),n.value),backwardsFunc:(e,r)=>{const s=n.gradFunc(e,r),a=Array.isArray(s)?s:[s];o(a.length===t.length,()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns the same number of tensors as inputs passed to f(...)."),o(a.every(e=>e instanceof dr),()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns a list of only tensors.");const i={};return a.forEach((e,t)=>{i[t]=()=>e}),i},inputs:r})}}readSync(e){return this.state.tensorInfo.get(e).backend.readSync(e)}read(e){return this.state.tensorInfo.get(e).backend.read(e)}async time(e){const t=Xn(),n=await this.backend.time(e);return n.wallMs=Xn()-t,n}track(e){return null!=this.state.activeScope&&(e.scopeId=this.state.activeScope.id,this.state.activeScope.track.push(e)),e}get registeredVariables(){return this.state.registeredVariables}reset(){this.pendingBackendInitId++,this.state.dispose(),this.ENV.reset(),this.state=new $r;for(const e in this.registry)this.disposeRegisteredKernels(e),this.registry[e].dispose(),delete this.registry[e];this.backendName=null,this.backendInstance=null,this.pendingBackendInit=null}}function Mr(){const e=L();if(null==e._tfengine){const t=new F(e);e._tfengine=new _r(t)}var t;return t=e._tfengine.ENV,z=t,cr=()=>e._tfengine,e._tfengine}_r.nextTensorId=0,_r.nextVariableId=0;const Nr=Mr();function Tr(e,t){const n={a:e,b:t};return Nr.runKernel("Add",n)}function Dr(){return"undefined"!=typeof window&&null!=window.document||"undefined"!=typeof WorkerGlobalScope}var Rr=Object.freeze({__proto__:null,isMobile:function(e){if(e||"undefined"!=typeof navigator&&null!=navigator){if(e||(e=navigator),"ReactNative"===e.product)return!0;const t=e.userAgent||e.vendor||window.opera;return/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(t)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(t.substr(0,4))}return!1},isBrowser:Dr});const Fr=B();function Cr(e,t){let n=e;if(w(e))return"string"===t?[]:[e.length];if(!Array.isArray(e))return[];const r=[];for(;Array.isArray(n)||w(n)&&"string"!==t;)r.push(n.length),n=n[0];return Array.isArray(e)&&B().getBool("TENSORLIKE_CHECK_SHAPE_CONSISTENCY")&&function e(t,n,r){if(r=r||[],!Array.isArray(t)&&!w(t))return void o(0===n.length,()=>`Element arr[${r.join("][")}] is a primitive, but should be an array/TypedArray of ${n[0]} elements`);o(n.length>0,()=>`Element arr[${r.join("][")}] should be a primitive, but is an array of ${t.length} elements`),o(t.length===n[0],()=>`Element arr[${r.join("][")}] should have ${n[0]} elements, but has ${t.length} elements`);const s=n.slice(1);for(let n=0;n<t.length;++n)e(t[n],s,r.concat(n))}(e,r,[]),r}function Br(e,t,n,r){if("string_or_numeric"!==e){if(null==e)throw new Error("Expected dtype cannot be null.");if("numeric"!==e&&e!==t||"numeric"===e&&"string"===t)throw new Error(`Argument '${n}' passed to '${r}' must be ${e} tensor, but got ${t} tensor`)}}function Pr(e,t,n,r="numeric"){if(e instanceof dr)return Br(r,e.dtype,t,n),e;let s=A(e);if("string"!==s&&["bool","int32","float32"].indexOf(r)>=0&&(s=r),Br(r,s,t,n),null==e||!w(e)&&!Array.isArray(e)&&"number"!=typeof e&&"boolean"!=typeof e&&"string"!=typeof e){const r=null==e?"null":e.constructor.name;throw new Error(`Argument '${t}' passed to '${n}' must be a Tensor or TensorLike, but got '${r}'`)}const o=Cr(e,s);w(e)||Array.isArray(e)||(e=[e]);const a="string"!==s?Zn(e,s):l(e,[],!0);return Nr.makeTensor(a,o,s)}function zr(e,t,n,r="numeric"){if(!Array.isArray(e))throw new Error(`Argument ${t} passed to ${n} must be a \`Tensor[]\` or \`TensorLike[]\``);return e.map((e,s)=>Pr(e,`${t}[${s}]`,n,r))}Fr.registerFlag("DEBUG",()=>!1,e=>{e&&console.warn("Debugging mode is ON. The output of every math call will be downloaded to CPU and checked for NaNs. This significantly impacts performance.")}),Fr.registerFlag("IS_BROWSER",()=>Dr()),Fr.registerFlag("IS_NODE",()=>"undefined"!=typeof process&&void 0!==process.versions&&void 0!==process.versions.node),Fr.registerFlag("IS_CHROME",()=>"undefined"!=typeof navigator&&null!=navigator&&null!=navigator.userAgent&&/Chrome/.test(navigator.userAgent)&&/Google Inc/.test(navigator.vendor)),Fr.registerFlag("PROD",()=>!1),Fr.registerFlag("TENSORLIKE_CHECK_SHAPE_CONSISTENCY",()=>Fr.getBool("DEBUG")),Fr.registerFlag("DEPRECATION_WARNINGS_ENABLED",()=>!0),Fr.registerFlag("IS_TEST",()=>!1),Fr.registerFlag("CHECK_COMPUTATION_FOR_ERRORS",()=>!0),Fr.registerFlag("WRAP_TO_IMAGEBITMAP",()=>!1);const Lr="__op";function Or(e){const t=Object.keys(e);if(1!==t.length)throw new Error("Please provide an object with a single key (operation name) mapping to a function. Got an object with "+t.length+" keys.");let n=t[0];const r=e[n];n.endsWith("_")&&(n=n.substring(0,n.length-1)),n+="__op";const s=(...e)=>{Nr.startScope(n);try{const t=r(...e);return R(t)&&console.error("Cannot return a Promise inside of tidy."),Nr.endScope(t),t}catch(e){throw Nr.endScope(null),e}};return Object.defineProperty(s,"name",{value:n,configurable:!0}),s}const Kr=Or({complex_:function(e,t){const n=Pr(e,"real","complex"),r=Pr(t,"imag","complex");a(n.shape,r.shape,`real and imag shapes, ${n.shape} and ${r.shape}, must match in call to tf.complex().`);const s={real:n,imag:r};return Nr.runKernel("Complex",s)}});function Wr(e,t,n,r){if(null==r&&(r=A(e)),"complex64"===r)throw new Error("Cannot construct a complex64 tensor directly. Please use tf.complex(real, imag).");if(!w(e)&&!Array.isArray(e)&&"number"!=typeof e&&"boolean"!=typeof e&&"string"!=typeof e)throw new Error("values passed to tensor(values) must be a number/boolean/string or an array of numbers/booleans/strings, or a TypedArray");if(null!=t){D(t);const e=u(t),r=u(n);o(e===r,()=>`Based on the provided shape, [${t}], the tensor should have ${e} values but has ${r}`);for(let e=0;e<n.length;++e){const r=n[e],s=e!==n.length-1||r!==u(t.slice(e));o(n[e]===t[e]||!s,()=>`Error creating a new Tensor. Inferred shape (${n}) does not match the provided shape (${t}). `)}}return w(e)||Array.isArray(e)||(e=[e]),t=t||n,e="string"!==r?Zn(e,r):l(e,[],!0),Nr.makeTensor(e,t,r)}function Ur(e,t,n){return Wr(e,t,Cr(e,n),n)}const qr={float32:4,float16:2,int32:4,uint16:2,uint8:1,bool:1,complex64:8};function Gr(e,t){const n={};let r,s=0;for(const o of t){const t=o.name,a=o.dtype,i=o.shape,l=u(i);let c;if("quantization"in o){const n=o.quantization;if("uint8"===n.dtype||"uint16"===n.dtype){if(!("min"in n)||!("scale"in n))throw new Error(`Weight ${o.name} with quantization ${n.dtype} doesn't have corresponding metadata min and scale.`)}else{if("float16"!==n.dtype)throw new Error(`Weight ${o.name} has unknown quantization dtype ${n.dtype}. Supported quantization dtypes are: 'uint8', 'uint16', and 'float16'.`);if("float32"!==a)throw new Error(`Weight ${o.name} is quantized with ${n.dtype} which only supports weights of type float32 not ${a}.`)}const i=qr[n.dtype],u=e.slice(s,s+l*i),h="uint8"===n.dtype?new Uint8Array(u):new Uint16Array(u);if("float32"===a)if("uint8"===n.dtype||"uint16"===n.dtype){c=new Float32Array(h.length);for(let e=0;e<h.length;e++){const t=h[e];c[e]=t*n.scale+n.min}}else{if("float16"!==n.dtype)throw new Error(`Unsupported quantization type ${n.dtype} for weight type float32.`);void 0===r&&(r=Xr()),c=r(h)}else{if("int32"!==a)throw new Error(`Unsupported dtype in weight '${t}': ${a}`);if("uint8"!==n.dtype&&"uint16"!==n.dtype)throw new Error(`Unsupported quantization type ${n.dtype} for weight type int32.`);c=new Int32Array(h.length);for(let e=0;e<h.length;e++){const t=h[e];c[e]=Math.round(t*n.scale+n.min)}}s+=l*i}else if("string"===a){const t=u(o.shape);c=[];for(let n=0;n<t;n++){const t=new Uint32Array(e.slice(s,s+4))[0];s+=4;const n=new Uint8Array(e.slice(s,s+t));c.push(n),s+=t}}else{const r=qr[a],o=e.slice(s,s+l*r);if("float32"===a)c=new Float32Array(o);else if("int32"===a)c=new Int32Array(o);else if("bool"===a)c=new Uint8Array(o);else{if("complex64"!==a)throw new Error(`Unsupported dtype in weight '${t}': ${a}`);{c=new Float32Array(o);const e=new Float32Array(c.length/2),r=new Float32Array(c.length/2);for(let t=0;t<e.length;t++)e[t]=c[2*t],r[t]=c[2*t+1];const s=Ur(e,i,"float32"),a=Ur(r,i,"float32");n[t]=Kr(s,a),s.dispose(),a.dispose()}}s+=l*r}"complex64"!==a&&(n[t]=Ur(c,i,a))}return n}function Hr(e){if(null===e)throw new Error("Invalid input value: "+JSON.stringify(e));let t=0;const n=[];e.forEach(e=>{if(t+=e.byteLength,n.push(e.byteLength===e.buffer.byteLength?e:new e.constructor(e)),!(e instanceof Float32Array||e instanceof Int32Array||e instanceof Uint8Array))throw new Error("Unsupported TypedArray subtype: "+e.constructor.name)});const r=new Uint8Array(t);let s=0;return n.forEach(e=>{r.set(new Uint8Array(e.buffer),s),s+=e.byteLength}),r.buffer}const Vr="undefined"!=typeof Buffer&&("undefined"==typeof Blob||"undefined"==typeof atob||"undefined"==typeof btoa);function jr(e){return Vr?Buffer.byteLength(e):new Blob([e]).size}function Jr(e){if(1===e.length)return e[0];let t=0;e.forEach(e=>{t+=e.byteLength});const n=new Uint8Array(t);let r=0;return e.forEach(e=>{n.set(new Uint8Array(e),r),r+=e.byteLength}),n.buffer}function Yr(e){for(e=e.trim();e.endsWith("/");)e=e.slice(0,e.length-1);const t=e.split("/");return t[t.length-1]}function Zr(e){if(e.modelTopology instanceof ArrayBuffer)throw new Error("Expected JSON model topology, received ArrayBuffer.");return{dateSaved:new Date,modelTopologyType:"JSON",modelTopologyBytes:null==e.modelTopology?0:jr(JSON.stringify(e.modelTopology)),weightSpecsBytes:null==e.weightSpecs?0:jr(JSON.stringify(e.weightSpecs)),weightDataBytes:null==e.weightData?0:e.weightData.byteLength}}function Xr(){const e=function(){const e=e=>{let t=e<<13,n=0;for(;0==(8388608&t);)n-=8388608,t<<=1;return t&=-8388609,n+=947912704,t|n},t=new Uint32Array(2048);t[0]=0;for(let n=1;n<1024;n++)t[n]=e(n);for(let e=1024;e<2048;e++)t[e]=939524096+(e-1024<<13);return t}(),t=function(){const e=new Uint32Array(64);e[0]=0,e[31]=1199570944,e[32]=2147483648,e[63]=3347054592;for(let t=1;t<31;t++)e[t]=t<<23;for(let t=33;t<63;t++)e[t]=2147483648+(t-32<<23);return e}(),n=function(){const e=new Uint32Array(64);for(let t=0;t<64;t++)e[t]=1024;return e[0]=e[32]=0,e}();return r=>{const s=new ArrayBuffer(4*r.length),o=new Uint32Array(s);for(let s=0;s<r.length;s++){const a=r[s],i=e[n[a>>10]+(1023&a)]+t[a>>10];o[s]=i}return new Float32Array(s)}}class Qr{constructor(){this.saveRouters=[],this.loadRouters=[]}static getInstance(){return null==Qr.instance&&(Qr.instance=new Qr),Qr.instance}static registerSaveRouter(e){Qr.getInstance().saveRouters.push(e)}static registerLoadRouter(e){Qr.getInstance().loadRouters.push(e)}static getSaveHandlers(e){return Qr.getHandlers(e,"save")}static getLoadHandlers(e,t){return Qr.getHandlers(e,"load",t)}static getHandlers(e,t,n){const r=[];return("load"===t?Qr.getInstance().loadRouters:Qr.getInstance().saveRouters).forEach(t=>{const s=t(e,n);null!==s&&r.push(s)}),r}}function es(){if(!B().getBool("IS_BROWSER"))throw new Error("Failed to obtain IndexedDB factory because the current environmentis not a web browser.");const e="undefined"==typeof window?self:window,t=e.indexedDB||e.mozIndexedDB||e.webkitIndexedDB||e.msIndexedDB||e.shimIndexedDB;if(null==t)throw new Error("The current browser does not appear to support IndexedDB.");return t}function ts(e){const t=e.result;t.createObjectStore("models_store",{keyPath:"modelPath"}),t.createObjectStore("model_info_store",{keyPath:"modelPath"})}class ns{constructor(e){if(this.indexedDB=es(),null==e||!e)throw new Error("For IndexedDB, modelPath must not be null, undefined or empty.");this.modelPath=e}async save(e){if(e.modelTopology instanceof ArrayBuffer)throw new Error("BrowserLocalStorage.save() does not support saving model topology in binary formats yet.");return this.databaseAction(this.modelPath,e)}async load(){return this.databaseAction(this.modelPath)}databaseAction(e,t){return new Promise((e,n)=>{const r=this.indexedDB.open("tensorflowjs",1);r.onupgradeneeded=()=>ts(r),r.onsuccess=()=>{const s=r.result;if(null==t){const t=s.transaction("models_store","readonly"),r=t.objectStore("models_store").get(this.modelPath);r.onsuccess=()=>{if(null==r.result)return s.close(),n(new Error(`Cannot find model with path '${this.modelPath}' in IndexedDB.`));e(r.result.modelArtifacts)},r.onerror=e=>(s.close(),n(r.error)),t.oncomplete=()=>s.close()}else{const r=Zr(t),o=s.transaction("model_info_store","readwrite");let a=o.objectStore("model_info_store");const i=a.put({modelPath:this.modelPath,modelArtifactsInfo:r});let l;i.onsuccess=()=>{l=s.transaction("models_store","readwrite");const i=l.objectStore("models_store").put({modelPath:this.modelPath,modelArtifacts:t,modelArtifactsInfo:r});i.onsuccess=()=>e({modelArtifactsInfo:r}),i.onerror=e=>{a=o.objectStore("model_info_store");const t=a.delete(this.modelPath);t.onsuccess=()=>(s.close(),n(i.error)),t.onerror=e=>(s.close(),n(i.error))}},i.onerror=e=>(s.close(),n(i.error)),o.oncomplete=()=>{null==l?s.close():l.oncomplete=()=>s.close()}}},r.onerror=e=>n(r.error)})}}ns.URL_SCHEME="indexeddb://";const rs=e=>{return B().getBool("IS_BROWSER")&&!Array.isArray(e)&&e.startsWith(ns.URL_SCHEME)?(t=e.slice(ns.URL_SCHEME.length),new ns(t)):null;var t};Qr.registerSaveRouter(rs),Qr.registerLoadRouter(rs);class ss{constructor(){this.indexedDB=es()}async listModels(){return new Promise((e,t)=>{const n=this.indexedDB.open("tensorflowjs",1);n.onupgradeneeded=()=>ts(n),n.onsuccess=()=>{const r=n.result,s=r.transaction("model_info_store","readonly"),o=s.objectStore("model_info_store").getAll();o.onsuccess=()=>{const t={};for(const e of o.result)t[e.modelPath]=e.modelArtifactsInfo;e(t)},o.onerror=e=>(r.close(),t(o.error)),s.oncomplete=()=>r.close()},n.onerror=e=>t(n.error)})}async removeModel(e){var t;return e=(t=e).startsWith(ns.URL_SCHEME)?t.slice(ns.URL_SCHEME.length):t,new Promise((t,n)=>{const r=this.indexedDB.open("tensorflowjs",1);r.onupgradeneeded=()=>ts(r),r.onsuccess=()=>{const s=r.result,o=s.transaction("model_info_store","readwrite"),a=o.objectStore("model_info_store"),i=a.get(e);let l;i.onsuccess=()=>{if(null==i.result)return s.close(),n(new Error(`Cannot find model with path '${e}' in IndexedDB.`));{const r=a.delete(e),o=()=>{l=s.transaction("models_store","readwrite");const r=l.objectStore("models_store").delete(e);r.onsuccess=()=>t(i.result.modelArtifactsInfo),r.onerror=e=>n(i.error)};r.onsuccess=o,r.onerror=e=>(o(),s.close(),n(i.error))}},i.onerror=e=>(s.close(),n(i.error)),o.oncomplete=()=>{null==l?s.close():l.oncomplete=()=>s.close()}},r.onerror=e=>n(r.error)})}}const os="tensorflowjs_models",as="info",is="model_topology",ls="weight_specs",us="weight_data",cs="model_metadata";function hs(e){return{info:[os,e,as].join("/"),topology:[os,e,is].join("/"),weightSpecs:[os,e,ls].join("/"),weightData:[os,e,us].join("/"),modelMetadata:[os,e,cs].join("/")}}function ds(e){const t=e.split("/");if(t.length<3)throw new Error("Invalid key format: "+e);return t.slice(1,t.length-1).join("/")}class ps{constructor(e){if(!B().getBool("IS_BROWSER")||"undefined"==typeof window||void 0===window.localStorage)throw new Error("The current environment does not support local storage.");if(this.LS=window.localStorage,null==e||!e)throw new Error("For local storage, modelPath must not be null, undefined or empty.");this.modelPath=e,this.keys=hs(this.modelPath)}async save(e){if(e.modelTopology instanceof ArrayBuffer)throw new Error("BrowserLocalStorage.save() does not support saving model topology in binary formats yet.");{const t=JSON.stringify(e.modelTopology),n=JSON.stringify(e.weightSpecs),r=Zr(e);try{this.LS.setItem(this.keys.info,JSON.stringify(r)),this.LS.setItem(this.keys.topology,t),this.LS.setItem(this.keys.weightSpecs,n),this.LS.setItem(this.keys.weightData,function(e){if(Vr)return Buffer.from(e).toString("base64");const t=new Uint8Array(e);let n="";for(let e=0,r=t.length;e<r;e++)n+=String.fromCharCode(t[e]);return btoa(n)}(e.weightData));const s={format:e.format,generatedBy:e.generatedBy,convertedBy:e.convertedBy};return null!=e.signature&&(s.signature=e.signature),null!=e.userDefinedMetadata&&(s.userDefinedMetadata=e.userDefinedMetadata),null!=e.modelInitializer&&(s.modelInitializer=e.modelInitializer),this.LS.setItem(this.keys.modelMetadata,JSON.stringify(s)),{modelArtifactsInfo:r}}catch(e){throw this.LS.removeItem(this.keys.info),this.LS.removeItem(this.keys.topology),this.LS.removeItem(this.keys.weightSpecs),this.LS.removeItem(this.keys.weightData),this.LS.removeItem(this.keys.modelMetadata),new Error(`Failed to save model '${this.modelPath}' to local storage: size quota being exceeded is a possible cause of this failure: modelTopologyBytes=${r.modelTopologyBytes}, weightSpecsBytes=${r.weightSpecsBytes}, weightDataBytes=${r.weightDataBytes}.`)}}}async load(){const e=JSON.parse(this.LS.getItem(this.keys.info));if(null==e)throw new Error(`In local storage, there is no model with name '${this.modelPath}'`);if("JSON"!==e.modelTopologyType)throw new Error("BrowserLocalStorage does not support loading non-JSON model topology yet.");const t={},n=JSON.parse(this.LS.getItem(this.keys.topology));if(null==n)throw new Error(`In local storage, the topology of model '${this.modelPath}' is missing.`);t.modelTopology=n;const r=JSON.parse(this.LS.getItem(this.keys.weightSpecs));if(null==r)throw new Error(`In local storage, the weight specs of model '${this.modelPath}' are missing.`);t.weightSpecs=r;const s=this.LS.getItem(this.keys.modelMetadata);if(null!=s){const e=JSON.parse(s);t.format=e.format,t.generatedBy=e.generatedBy,t.convertedBy=e.convertedBy,null!=e.signature&&(t.signature=e.signature),null!=e.userDefinedMetadata&&(t.userDefinedMetadata=e.userDefinedMetadata),null!=e.modelInitializer&&(t.modelInitializer=e.modelInitializer)}const o=this.LS.getItem(this.keys.weightData);if(null==o)throw new Error(`In local storage, the binary weight values of model '${this.modelPath}' are missing.`);return t.weightData=function(e){if(Vr){const t=Buffer.from(e,"base64");return t.buffer.slice(t.byteOffset,t.byteOffset+t.byteLength)}const t=atob(e),n=new Uint8Array(t.length);for(let e=0;e<t.length;++e)n.set([t.charCodeAt(e)],e);return n.buffer}(o),t}}ps.URL_SCHEME="localstorage://";const fs=e=>{return B().getBool("IS_BROWSER")&&!Array.isArray(e)&&e.startsWith(ps.URL_SCHEME)?(t=e.slice(ps.URL_SCHEME.length),new ps(t)):null;var t};Qr.registerSaveRouter(fs),Qr.registerLoadRouter(fs);class ms{constructor(){o(B().getBool("IS_BROWSER"),()=>"Current environment is not a web browser"),o("undefined"==typeof window||void 0!==window.localStorage,()=>"Current browser does not appear to support localStorage"),this.LS=window.localStorage}async listModels(){const e={},t=os+"/",n="/"+as;for(let r=0;r<this.LS.length;++r){const s=this.LS.key(r);if(s.startsWith(t)&&s.endsWith(n)){e[ds(s)]=JSON.parse(this.LS.getItem(s))}}return e}async removeModel(e){var t;const n=hs(e=(t=e).startsWith(ps.URL_SCHEME)?t.slice(ps.URL_SCHEME.length):t);if(null==this.LS.getItem(n.info))throw new Error(`Cannot find model at path '${e}'`);const r=JSON.parse(this.LS.getItem(n.info));return this.LS.removeItem(n.info),this.LS.removeItem(n.topology),this.LS.removeItem(n.weightSpecs),this.LS.removeItem(n.weightData),r}}class gs{constructor(){this.managers={}}static getInstance(){return null==gs.instance&&(gs.instance=new gs),gs.instance}static registerManager(e,t){o(null!=e,()=>"scheme must not be undefined or null."),e.endsWith("://")&&(e=e.slice(0,e.indexOf("://"))),o(e.length>0,()=>"scheme must not be an empty string.");const n=gs.getInstance();o(null==n.managers[e],()=>`A model store manager is already registered for scheme '${e}'.`),n.managers[e]=t}static getManager(e){const t=this.getInstance().managers[e];if(null==t)throw new Error(`Cannot find model manager for scheme '${e}'`);return t}static getSchemes(){return Object.keys(this.getInstance().managers)}}function bs(e){if(-1===e.indexOf("://"))throw new Error("The url string provided does not contain a scheme. Supported schemes are: "+gs.getSchemes().join(","));return{scheme:e.split("://")[0],path:e.split("://")[1]}}async function ys(e,t,n=!1){o(e!==t,()=>`Old path and new path are the same: '${e}'`);const r=Qr.getLoadHandlers(e);o(r.length>0,()=>`Copying failed because no load handler is found for source URL ${e}.`),o(r.length<2,()=>`Copying failed because more than one (${r.length}) load handlers for source URL ${e}.`);const s=r[0],a=Qr.getSaveHandlers(t);o(a.length>0,()=>`Copying failed because no save handler is found for destination URL ${t}.`),o(a.length<2,()=>`Copying failed because more than one (${r.length}) save handlers for destination URL ${t}.`);const i=a[0],l=bs(e).scheme,u=bs(e).path,c=l===bs(e).scheme,h=await s.load();n&&c&&await gs.getManager(l).removeModel(u);const d=await i.save(h);return n&&!c&&await gs.getManager(l).removeModel(u),d.modelArtifactsInfo}class ws{fetch(e,t){return fetch(e,t)}now(){return performance.now()}encode(e,t){if("utf-8"!==t&&"utf8"!==t)throw new Error("Browser's encoder only supports utf-8, but got "+t);return null==this.textEncoder&&(this.textEncoder=new TextEncoder),this.textEncoder.encode(e)}decode(e,t){return new TextDecoder(t).decode(e)}}if(B().get("IS_BROWSER")){B().setPlatform("browser",new ws);try{gs.registerManager(ps.URL_SCHEME,new ms)}catch(e){}try{gs.registerManager(ns.URL_SCHEME,new ss)}catch(e){}}const ks=()=>require("node-fetch");let vs;class xs{constructor(){this.util=require("util"),this.textEncoder=new this.util.TextEncoder}fetch(e,t){return null!=B().global.fetch?B().global.fetch(e,t):(null==vs&&(vs=ks()),vs(e,t))}now(){const e=process.hrtime();return 1e3*e[0]+e[1]/1e6}encode(e,t){if("utf-8"!==t&&"utf8"!==t)throw new Error("Node built-in encoder only supports utf-8, but got "+t);return this.textEncoder.encode(e)}decode(e,t){return 0===e.length?"":new this.util.TextDecoder(t).decode(e)}}function Es(e,t="float32",n){return t=t||"float32",D(e),new ur(e,t,n)}B().get("IS_NODE")&&B().setPlatform("node",new xs);const Ss=Or({cast_:function(e,t){const n=Pr(e,"x","cast");if(!y(t))throw new Error("Failed to cast to unknown dtype "+t);if("string"===t&&"string"!==n.dtype||"string"!==t&&"string"===n.dtype)throw new Error("Only strings can be casted to strings");const r={x:n},s={dtype:t};return Nr.runKernel("Cast",r,s)}});const As=Or({clone_:function(e){const t={x:Pr(e,"x","clone","string_or_numeric")};return Nr.runKernel("Identity",t)}});function Is(e,t=!1){console.log(e.toString(t))}Mr();hr={buffer:Es,cast:Ss,clone:As,print:Is};function $s(e){return new Promise(e=>setTimeout(e)).then(e)}class _s{constructor(e){if(!B().getBool("IS_BROWSER"))throw new Error("browserDownloads() cannot proceed because the current environment is not a browser.");e.startsWith(_s.URL_SCHEME)&&(e=e.slice(_s.URL_SCHEME.length)),null!=e&&0!==e.length||(e="model"),this.modelTopologyFileName=e+".json",this.weightDataFileName=e+".weights.bin"}async save(e){if("undefined"==typeof document)throw new Error("Browser downloads are not supported in this environment since `document` is not present");const t=window.URL.createObjectURL(new Blob([e.weightData],{type:"application/octet-stream"}));if(e.modelTopology instanceof ArrayBuffer)throw new Error("BrowserDownloads.save() does not support saving model topology in binary formats yet.");{const n=[{paths:["./"+this.weightDataFileName],weights:e.weightSpecs}],r={modelTopology:e.modelTopology,format:e.format,generatedBy:e.generatedBy,convertedBy:e.convertedBy,weightsManifest:n};null!=e.signature&&(r.signature=e.signature),null!=e.userDefinedMetadata&&(r.userDefinedMetadata=e.userDefinedMetadata),null!=e.modelInitializer&&(r.modelInitializer=e.modelInitializer);const s=window.URL.createObjectURL(new Blob([JSON.stringify(r)],{type:"application/json"})),o=null==this.jsonAnchor?document.createElement("a"):this.jsonAnchor;if(o.download=this.modelTopologyFileName,o.href=s,await $s(()=>o.dispatchEvent(new MouseEvent("click"))),null!=e.weightData){const e=null==this.weightDataAnchor?document.createElement("a"):this.weightDataAnchor;e.download=this.weightDataFileName,e.href=t,await $s(()=>e.dispatchEvent(new MouseEvent("click")))}return{modelArtifactsInfo:Zr(e)}}}}_s.URL_SCHEME="downloads://";class Ms{constructor(e){if(null==e||e.length<1)throw new Error("When calling browserFiles, at least 1 file is required, but received "+e);this.files=e}async load(){const e=this.files[0],t=this.files.slice(1);return new Promise((n,r)=>{const s=new FileReader;s.onload=s=>{const o=JSON.parse(s.target.result),a=o.modelTopology;if(null==a)return void r(new Error("modelTopology field is missing from file "+e.name));0===t.length&&n({modelTopology:a});const i=o.weightsManifest;if(null==i)return void r(new Error("weightManifest field is missing from file "+e.name));let l;try{l=this.checkManifestAndWeightFiles(i,t)}catch(e){return void r(e)}const u=[],c=[],h=[];i.forEach(e=>{e.paths.forEach(e=>{c.push(e),h.push(null)}),u.push(...e.weights)}),i.forEach(e=>{e.paths.forEach(e=>{const t=new FileReader;t.onload=t=>{const r=t.target.result,s=c.indexOf(e);if(h[s]=r,-1===h.indexOf(null)){const e={modelTopology:a,weightSpecs:u,weightData:Jr(h),format:o.format,generatedBy:o.generatedBy,convertedBy:o.convertedBy};null!=o.signature&&(e.signature=o.signature),null!=o.userDefinedMetadata&&(e.userDefinedMetadata=o.userDefinedMetadata),null!=o.modelInitializer&&(e.modelInitializer=o.modelInitializer),n(e)}},t.onerror=t=>r(`Failed to weights data from file of path '${e}'.`),t.readAsArrayBuffer(l[e])})})},s.onerror=t=>r(`Failed to read model topology and weights manifest JSON from file '${e.name}'. BrowserFiles supports loading Keras-style tf.Model artifacts only.`),s.readAsText(e)})}checkManifestAndWeightFiles(e,t){const n=[],r=t.map(e=>Yr(e.name)),s={};for(const o of e)o.paths.forEach(e=>{const o=Yr(e);if(-1!==n.indexOf(o))throw new Error(`Duplicate file basename found in weights manifest: '${o}'`);if(n.push(o),-1===r.indexOf(o))throw new Error(`Weight file with basename '${o}' is not provided.`);s[e]=t[r.indexOf(o)]});if(n.length!==t.length)throw new Error(`Mismatch in the number of files in weights manifest (${n.length}) and the number of weight files provided (${t.length}).`);return s}}function Ns(e,t,n,r){!function(e){o(null!=e&&Array.isArray(e)&&e.length>0,()=>"promises must be a none empty array")}(e),function(e,t){o(e>=0&&e<=1,()=>"Progress fraction must be in range [0, 1], but got startFraction "+e),o(t>=0&&t<=1,()=>"Progress fraction must be in range [0, 1], but got endFraction "+t),o(t>=e,()=>`startFraction must be no more than endFraction, but got startFraction ${e} and endFraction `+t)}(n=null==n?0:n,r=null==r?1:r);let s=0;return Promise.all(e.map(o=>(o.then(o=>{const a=n+ ++s/e.length*(r-n);return t(a),o}),o)))}async function Ts(e,t){null==t&&(t={});const n=null==t.fetchFunc?B().platform.fetch:t.fetchFunc,r=e.map(e=>n(e,t.requestInit,{isBinary:!0})),s=(null==t.onProgress?await Promise.all(r):await Ns(r,t.onProgress,0,.5)).map(e=>e.arrayBuffer());return null==t.onProgress?await Promise.all(s):await Ns(s,t.onProgress,.5,1)}function Ds(e){return async(t,n="",r)=>{const s=t.map(()=>!1),o={},a=null!=r?r.map(()=>!1):[],i=[];if(t.forEach((e,t)=>{let n=0;e.weights.forEach(e=>{const l="quantization"in e?e.quantization.dtype:e.dtype,c=qr[l]*u(e.shape),h=()=>{s[t]=!0,null==o[t]&&(o[t]=[]),o[t].push({manifestEntry:e,groupOffset:n,sizeBytes:c})};null!=r?r.forEach((t,n)=>{t===e.name&&(h(),a[n]=!0)}):h(),i.push(e.name),n+=c})}),!a.every(e=>e)){const e=r.filter((e,t)=>!a[t]);throw new Error("Could not find weights in manifest with names: "+e.join(", ")+". \nManifest JSON has weights with names: "+i.join(", ")+".")}const l=s.reduce((e,t,n)=>(t&&e.push(n),e),[]),c=[];l.forEach(e=>{t[e].paths.forEach(e=>{const t=n+(n.endsWith("/")?"":"/")+e;c.push(t)})});const h=await e(c),d={};let p=0;return l.forEach(e=>{const n=t[e].paths.length;let r=0;for(let e=0;e<n;e++)r+=h[p+e].byteLength;const s=new ArrayBuffer(r),a=new Uint8Array(s);let i=0;for(let e=0;e<n;e++){const t=new Uint8Array(h[p+e]);a.set(t,i),i+=t.byteLength}o[e].forEach(e=>{const t=Gr(s.slice(e.groupOffset,e.groupOffset+e.sizeBytes),[e.manifestEntry]);for(const e in t)d[e]=t[e]}),p+=n}),d}}Qr.registerSaveRouter(e=>B().getBool("IS_BROWSER")&&!Array.isArray(e)&&e.startsWith(_s.URL_SCHEME)?function(e="model"){return new _s(e)}(e.slice(_s.URL_SCHEME.length)):null);class Rs{constructor(e,t){if(this.DEFAULT_METHOD="POST",null==t&&(t={}),this.weightPathPrefix=t.weightPathPrefix,this.onProgress=t.onProgress,this.weightUrlConverter=t.weightUrlConverter,null!=t.fetchFunc?(o("function"==typeof t.fetchFunc,()=>"Must pass a function that matches the signature of `fetch` (see https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API)"),this.fetch=t.fetchFunc):this.fetch=B().platform.fetch,o(null!=e&&e.length>0,()=>"URL path for http must not be null, undefined or empty."),Array.isArray(e)&&o(2===e.length,()=>`URL paths for http must have a length of 2, (actual length is ${e.length}).`),this.path=e,null!=t.requestInit&&null!=t.requestInit.body)throw new Error("requestInit is expected to have no pre-existing body, but has one.");this.requestInit=t.requestInit||{}}async save(e){if(e.modelTopology instanceof ArrayBuffer)throw new Error("BrowserHTTPRequest.save() does not support saving model topology in binary formats yet.");const t=Object.assign({method:this.DEFAULT_METHOD},this.requestInit);t.body=new FormData;const n=[{paths:["./model.weights.bin"],weights:e.weightSpecs}],r={modelTopology:e.modelTopology,format:e.format,generatedBy:e.generatedBy,convertedBy:e.convertedBy,weightsManifest:n};null!=e.signature&&(r.signature=e.signature),null!=e.userDefinedMetadata&&(r.userDefinedMetadata=e.userDefinedMetadata),null!=e.modelInitializer&&(r.modelInitializer=e.modelInitializer),t.body.append("model.json",new Blob([JSON.stringify(r)],{type:"application/json"}),"model.json"),null!=e.weightData&&t.body.append("model.weights.bin",new Blob([e.weightData],{type:"application/octet-stream"}),"model.weights.bin");const s=await this.fetch(this.path,t);if(s.ok)return{modelArtifactsInfo:Zr(e),responses:[s]};throw new Error("BrowserHTTPRequest.save() failed due to HTTP response status "+s.status+".")}async load(){const e=await this.fetch(this.path,this.requestInit);if(!e.ok)throw new Error(`Request to ${this.path} failed with status code `+e.status+". Please verify this URL points to the model JSON of the model to load.");let t;try{t=await e.json()}catch(e){let t=`Failed to parse model JSON of response from ${this.path}.`;throw this.path.endsWith(".pb")?t+=" Your path contains a .pb file extension. Support for .pb models have been removed in TensorFlow.js 1.0 in favor of .json models. You can re-convert your Python TensorFlow model using the TensorFlow.js 1.0 conversion scripts or you can convert your.pb models with the 'pb2json'NPM script in the tensorflow/tfjs-converter repository.":t+=" Please make sure the server is serving valid JSON for this request.",new Error(t)}const n=t.modelTopology,r=t.weightsManifest,s=t.generatedBy,o=t.convertedBy,a=t.format,i=t.signature,l=t.userDefinedMetadata;if(null==n&&null==r)throw new Error(`The JSON from HTTP path ${this.path} contains neither model topology or manifest for weights.`);let u,c;if(null!=r){const e=await this.loadWeights(r);[u,c]=e}const h={modelTopology:n,weightSpecs:u,weightData:c,generatedBy:s,convertedBy:o,format:a};null!=i&&(h.signature=i),null!=l&&(h.userDefinedMetadata=l);const d=t.modelInitializer;return d&&(h.modelInitializer=d),h}async loadWeights(e){const t=Array.isArray(this.path)?this.path[1]:this.path,[n,r]=function(e){const t=e.lastIndexOf("/"),n=e.lastIndexOf("?"),r=e.substring(0,t),s=n>t?e.substring(n):"";return[r+"/",s]}(t),s=this.weightPathPrefix||n,o=[];for(const t of e)o.push(...t.weights);const a=[],i=[];for(const t of e)for(const e of t.paths)null!=this.weightUrlConverter?i.push(this.weightUrlConverter(e)):a.push(s+e+r);this.weightUrlConverter&&a.push(...await Promise.all(i));return[o,Jr(await Ts(a,{requestInit:this.requestInit,fetchFunc:this.fetch,onProgress:this.onProgress}))]}}function Fs(e){return null!=e.match(Rs.URL_SCHEME_REGEX)}Rs.URL_SCHEME_REGEX=/^https?:\/\//;const Cs=(e,t)=>{if("undefined"==typeof fetch&&(null==t||null==t.fetchFunc))return null;{let n=!0;if(n=Array.isArray(e)?e.every(e=>Fs(e)):Fs(e),n)return Bs(e,t)}return null};function Bs(e,t){return new Rs(e,t)}Qr.registerSaveRouter(Cs),Qr.registerLoadRouter(Cs);class Ps{constructor(e){this.modelArtifacts=e}async load(){return this.modelArtifacts}}class zs{constructor(e){this.saveHandler=e}async save(e){return this.saveHandler(e)}}var Ls=Object.freeze({__proto__:null,browserFiles:function(e){return new Ms(e)},browserHTTPRequest:function(e,t){return Bs(e,t)},concatenateArrayBuffers:Jr,decodeWeights:Gr,encodeWeights:async function(e,t){const n=[],r=[],s=Array.isArray(e)?e.map(e=>e.name):Object.keys(e);for(let o=0;o<s.length;++o){const a=s[o],i=Array.isArray(e)?e[o].tensor:e[a];if("float32"!==i.dtype&&"int32"!==i.dtype&&"bool"!==i.dtype&&"string"!==i.dtype&&"complex64"!==i.dtype)throw new Error(`Unsupported dtype in weight '${a}': ${i.dtype}`);const l={name:a,shape:i.shape,dtype:i.dtype};if("string"===i.dtype){const e=new Promise(async e=>{const t=await i.bytes(),n=t.reduce((e,t)=>e+t.length,0)+4*t.length,r=new Uint8Array(n);let s=0;for(let e=0;e<t.length;e++){const n=t[e],o=new Uint8Array(new Uint32Array([n.length]).buffer);r.set(o,s),s+=4,r.set(n,s),s+=n.length}e(r)});r.push(e)}else r.push(i.data());null!=t&&(l.group=t),n.push(l)}return{data:Hr(await Promise.all(r)),specs:n}},fromMemory:function(e,t,n,r){if(1===arguments.length){return null!=e.modelTopology||null!=e.weightSpecs?new Ps(e):(console.warn("Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release."),new Ps({modelTopology:e}))}return console.warn("Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release."),new Ps({modelTopology:e,weightSpecs:t,weightData:n,trainingConfig:r})},getLoadHandlers:(e,t)=>Qr.getLoadHandlers(e,t),getModelArtifactsInfoForJSON:Zr,getSaveHandlers:e=>Qr.getSaveHandlers(e),http:Bs,isHTTPScheme:Fs,loadWeights:async function(e,t="",n,r){return Ds(e=>Ts(e,{requestInit:r}))(e,t,n)},registerLoadRouter:e=>Qr.registerLoadRouter(e),registerSaveRouter:e=>Qr.registerSaveRouter(e),weightsLoaderFactory:Ds,withSaveHandler:function(e){return new zs(e)},copyModel:async function(e,t){return ys(e,t,!1)},listModels:async function(){const e=gs.getSchemes(),t={};for(const n of e){const e=await gs.getManager(n).listModels();for(const r in e){t[n+"://"+r]=e[r]}}return t},moveModel:async function(e,t){return ys(e,t,!0)},removeModel:async function(e){const t=bs(e);return gs.getManager(t.scheme).removeModel(t.path)}});const Os=Or({matMul_:function(e,t,n=!1,r=!1){let s=Pr(e,"a","matMul"),o=Pr(t,"b","matMul");[s,o]=xr(s,o);const a={a:s,b:o},i={transposeA:n,transposeB:r};return Nr.runKernel("BatchMatMul",a,i)}});const Ks=Or({oneHot_:function(e,t,n=1,r=0){if(t<2)throw new Error("Error in oneHot: depth must be >=2, but it is "+t);const s={indices:Pr(e,"indices","oneHot","int32")},o={depth:t,onValue:n,offValue:r};return Nr.runKernel("OneHot",s,o)}});const Ws=Or({transpose_:function(e,t){const n=Pr(e,"x","transpose");if(null==t&&(t=n.shape.map((e,t)=>t).reverse()),o(n.rank===t.length,()=>`Error in transpose: rank of input ${n.rank} must match length of perm ${t}.`),t.forEach(e=>{o(e>=0&&e<n.rank,()=>"All entries in 'perm' must be between 0 and "+(n.rank-1)+" but got "+t)}),n.rank<=1)return n.clone();const r={x:n},s={perm:t};return Nr.runKernel("Transpose",r,s)}});const Us=Or({confusionMatrix_:function(e,t,n){const r=Pr(e,"labels","confusionMatrix"),s=Pr(t,"predictions","confusionMatrix");o(null==n||n>0&&Number.isInteger(n),()=>"If provided, numClasses must be a positive integer, but got "+n),o(1===r.rank,()=>"Expected the rank of labels to be 1, but got "+r.rank),o(1===s.rank,()=>"Expected the rank of predictions to be 1, but got "+s.rank),o(r.shape[0]===s.shape[0],()=>`Mismatch in the number of examples: ${r.shape[0]} vs. ${s.shape[0]}. Labels and predictions should have the same number of elements.`),o(n>0&&Number.isInteger(n),()=>"numClasses is required to be a positive integer, but got "+n);const a=Ks(Ss(r,"int32"),n),i=Ks(Ss(s,"int32"),n),l=Ws(a),u=Os(l,i);return Ss(u,"int32")}});var qs=Object.freeze({__proto__:null,confusionMatrix:Us});function Gs(e,t,n){if(i(e),null!=t&&3!==t.length)throw new Error("tensor3d() requires shape to have three numbers");const r=Cr(e,n);if(3!==r.length&&1!==r.length)throw new Error("tensor3d() requires values to be number[][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor3d() requires shape to be provided when `values` are a flat array");return Wr(e,t,r,n)}let Hs;function Vs(e,t=3){if(t>4)throw new Error("Cannot construct Tensor with more than 4 channels from pixels.");if(null==e)throw new Error("pixels passed to tf.browser.fromPixels() can not be null");let n=!1,r=!1,s=!1,o=!1,a=!1,i=!1;if(e.data instanceof Uint8Array)n=!0;else if("undefined"!=typeof ImageData&&e instanceof ImageData)r=!0;else if("undefined"!=typeof HTMLVideoElement&&e instanceof HTMLVideoElement)s=!0;else if("undefined"!=typeof HTMLImageElement&&e instanceof HTMLImageElement)o=!0;else if(null!=e.getContext)a=!0;else{if(!("undefined"!=typeof ImageBitmap&&e instanceof ImageBitmap))throw new Error("pixels passed to tf.browser.fromPixels() must be either an HTMLVideoElement, HTMLImageElement, HTMLCanvasElement, ImageData in browser, or OffscreenCanvas, ImageData in webworker or {data: Uint32Array, width: number, height: number}, but was "+e.constructor.name);i=!0}if(s){const t=2;if(s&&e.readyState<t)throw new Error("The video element has not loaded data yet. Please wait for `loadeddata` event on the <video> element.")}if(null!=Wn("FromPixels",Nr.backendName)){const n={pixels:e},r={numChannels:t};return Nr.runKernel("FromPixels",n,r)}const[l,u]=s?[e.videoWidth,e.videoHeight]:[e.width,e.height];let c,h;if(a?c=e.getContext("2d").getImageData(0,0,l,u).data:r||n?c=e.data:(o||s||i)&&(null==Hs&&(Hs=document.createElement("canvas").getContext("2d")),Hs.canvas.width=l,Hs.canvas.height=u,Hs.drawImage(e,0,0,l,u),c=Hs.getImageData(0,0,l,u).data),4===t)h=new Int32Array(c);else{const e=l*u;h=new Int32Array(e*t);for(let n=0;n<e;n++)for(let e=0;e<t;++e)h[n*t+e]=c[4*n+e]}return Gs(h,[u,l,t],"int32")}function js(e){return"undefined"!=typeof window&&"undefined"!=typeof ImageBitmap&&window.hasOwnProperty("createImageBitmap")&&!(e instanceof ImageBitmap)&&function(e){return null!=e&&0!==e.width&&0!==e.height}(e)&&!function(e){return null!=e&&e.data instanceof Uint8Array}(e)}const Js=Or({fromPixels_:Vs});var Ys=Object.freeze({__proto__:null,fromPixelsAsync:async function(e,t=3){let n=null;if(B().getBool("WRAP_TO_IMAGEBITMAP")&&js(e)){let t;try{t=await createImageBitmap(e,{premultiplyAlpha:"none"})}catch(e){t=null}n=null!=t&&t.width===e.width&&t.height===e.height?t:e}else n=e;return Vs(n,t)},toPixels:async function(e,t){let n=Pr(e,"img","toPixels");if(!(e instanceof dr)){const e=n;n=Ss(e,"int32"),e.dispose()}if(2!==n.rank&&3!==n.rank)throw new Error(`toPixels only supports rank 2 or 3 tensors, got rank ${n.rank}.`);const[r,s]=n.shape.slice(0,2),o=2===n.rank?1:n.shape[2];if(o>4||2===o)throw new Error("toPixels only supports depth of size 1, 3 or 4 but got "+o);if("float32"!==n.dtype&&"int32"!==n.dtype)throw new Error(`Unsupported type for toPixels: ${n.dtype}. Please use float32 or int32 tensors.`);const a=await n.data(),i="float32"===n.dtype?255:1,l=new Uint8ClampedArray(s*r*4);for(let e=0;e<r*s;++e){const t=[0,0,0,255];for(let r=0;r<o;r++){const s=a[e*o+r];if("float32"===n.dtype){if(s<0||s>1)throw new Error(`Tensor values for a float32 Tensor must be in the range [0 - 1] but encountered ${s}.`)}else if("int32"===n.dtype&&(s<0||s>255))throw new Error(`Tensor values for a int32 Tensor must be in the range [0 - 255] but encountered ${s}.`);1===o?(t[0]=s*i,t[1]=s*i,t[2]=s*i):t[r]=s*i}const r=4*e;l[r+0]=Math.round(t[0]),l[r+1]=Math.round(t[1]),l[r+2]=Math.round(t[2]),l[r+3]=Math.round(t[3])}if(null!=t){t.width=s,t.height=r;const e=t.getContext("2d"),n=new ImageData(l,s,r);e.putImageData(n,0,0)}return n!==e&&n.dispose(),l},fromPixels:Js});function Zs(e,t){const n=e.shape.length,r=t.shape.length;if(n<1)throw new Error(`tf.gatherND() expects the input to be rank 1 or higher, but the rank was ${n}.`);if(r<1)throw new Error(`tf.gatherND() expects the indices to be rank 1 or higher, but the rank was ${r}.`);if("int32"!==t.dtype)throw new Error(`tf.gatherND() expects the indices to be int32 type, but the dtype was ${t.dtype}.`);if(t.shape[r-1]>n)throw new Error(`index innermost dimension length must be <= tensor rank; saw: ${t.shape[r-1]} vs. ${n}`);if(0===u(e.shape))throw new Error(`Requested more than 0 entries, but input is empty. Input shape: ${e.shape}.`);const s=t.shape,o=s[s.length-1];let a=1;for(let e=0;e<s.length-1;++e)a*=s[e];const i=e.shape,l=s.slice();l.pop();let c=1;for(let e=o;e<n;++e)c*=i[e],l.push(i[e]);const h=[..._(e.shape).map(e=>e/c),1].slice(0,o);return[l,a,c,h]}var Xs=Object.freeze({__proto__:null,prepareAndValidate:Zs});function Qs(e,t,n){const r=t.rank>1?t.shape[t.rank-1]:1,s=t.rank>1?t.rank-1:1,o="Must have updates.shape = indices.shape[:batchDim] + shape[sliceDim:], got updates.shape: "+n.shape+`, indices.shape: ${t.shape}, shape: ${e}`+`, sliceDim: ${r}, and batchDim: ${s}.`;if(n.rank<s)throw new Error(o+` update.rank < ${s}. `);if(e.length<r+(n.rank-s))throw new Error(o+" Output shape length < "+(r+(n.rank-s)));if(n.rank!==s+e.length-r)throw new Error(o+" update.rank != "+(s+e.length-r));for(let e=0;e<s;++e)if(n.shape[e]!==t.shape[e])throw new Error(o+` updates.shape[${e}] (${n.shape[e]}) != indices.shape[${e}] (${t.shape[e]}).`);for(let t=0;t<n.rank-s;++t)if(n.shape[t+s]!==e[t+r])throw new Error(o+` updates.shape[${t+s}] (${n.shape[t+s]}) != shape[${t+s}] (${e[t+s]})`)}function eo(e,t,n){if(t.rank<1)throw new Error(`tf.scatterND() expects the indices to be rank 1 or higher, but the rank was ${t.rank}.`);if(e.rank<1)throw new Error(`tf.scatterND() expects the updates to be rank 1 or higher, but the rank was ${e.rank}.`);if("int32"!==t.dtype)throw new Error("The dtype of 'indices' should be int32, but got dtype: "+t.dtype);if(n.length<1)throw new Error("Output rank must be greater or equal to 1, but got shape: "+n);if(0===n.length){if(0===t.size)throw new Error("Indices specified for empty output. indices shape: "+t.shape);if(0===e.size)throw new Error("Updates specified for empty output. updates shape: "+e.shape)}Qs(n,t,e)}function to(e,t,n){const r=t.shape.length,s=r>1?t.shape[r-1]:1,o=n.length;let a=1;for(let e=s;e<o;++e)a*=n[e];const i=s<1?1:s;return{sliceRank:s,numUpdates:u(t.shape)/i,sliceSize:a,strides:[..._(n.slice(0,s)),1],outputSize:u(n)}}var no=Object.freeze({__proto__:null,validateUpdateShape:Qs,validateInput:eo,calculateShapes:to});function ro(e){const t=[];let n=0;for(;e>0;)1&e&&t.push(n),e/=2,n++;return t}function so(e,t,n){const r=[];for(let s=0;s<e.length;s++)r[s]=Math.ceil((t[s]-e[s])/n[s]);return r}function oo(e,t,n,r){const s=[...e];for(let e=s.length;e<r.length;e++)s.push(1);for(let e=0;e<n;e++)0===e?s[t]=1:(s.splice(t,0,1),s.pop());return s}function ao(e,t,n){return n<=e?n:n-(t-1)}function io(e,t){const n=[];for(let r=0;r<e;r++)n.push(t+r);return n}function lo(e,t,n,r,s,o,a,i,l){const u=e.length;let c=new Array(u),h=new Array(u),d=new Array(u);if(t.length&&n>0){const l=t[0],u=n+1;c=uo(a,l,u,r,e),h=co(i,l,u,s,e),d=oo(o,l,u,e)}else for(let t=0;t<u;t++)c[t]=po(a,r,o,e,t,l),h[t]=fo(i,s,o,e,t,l),d[t]=ho(o,t,l);return{begin:c,end:h,strides:d}}function uo(e,t,n,r,s){const o=[...s],a=io(n,t);for(let s=0;s<o.length;s++)if(a.indexOf(s)>-1)o[s]=0;else{const a=ao(t,n,s);let i=r[a];e&1<<a&&(i=0),o[s]=i}return o}function co(e,t,n,r,o){const a=[...o],i=io(n,t);for(let s=0;s<a.length;s++)if(i.indexOf(s)>-1)a[s]=Number.MAX_SAFE_INTEGER;else{const o=ao(t,n,s);let i=r[o];e&1<<o&&(i=Number.MAX_SAFE_INTEGER),a[s]=i}for(let e=0;e<a.length;e++){const t=o[e];a[e]<0&&(a[e]+=t),a[e]=s(0,a[e],o[e])}return a}function ho(e,t,n){let r=e[t];return(n&1<<t||null==r)&&(r=1),r}function po(e,t,n,r,o,a){let i=t[o];const l=n[o]||1;(e&1<<o||a&1<<o||null==i)&&(i=l>0?Number.MIN_SAFE_INTEGER:Number.MAX_SAFE_INTEGER);const u=r[o];return i<0&&(i+=u),i=s(0,i,u-1),i}function fo(e,t,n,r,o,a){let i=t[o];const l=n[o]||1;(e&1<<o||a&1<<o||null==i)&&(i=l>0?Number.MAX_SAFE_INTEGER:Number.MIN_SAFE_INTEGER);const u=r[o];return i<0&&(i+=u),i=l>0?s(0,i,u):s(-1,i,u-1),i}var mo=Object.freeze({__proto__:null,assertParamsValid:function(e,t,n){const r=e.shape.length;o(r===t.length,()=>`Error in slice${r}D: Length of begin ${t} must match the rank of the array (${r}).`),o(r===n.length,()=>`Error in slice${r}D: Length of size ${n} must match the rank of the array (${r}).`);for(let s=0;s<r;++s)o(t[s]+n[s]<=e.shape[s],()=>`Error in slice${r}D: begin[${s}] + size[${s}] (${t[s]+n[s]}) would overflow input.shape[${s}] (${e.shape[s]})`)},maskToAxes:ro,computeOutShape:so,stridesWithElidedDims:oo,getNormalizedAxes:lo,startIndicesWithElidedDims:uo,stopIndicesWithElidedDims:co,stridesForAxis:ho,startForAxis:po,stopForAxis:fo,isSliceContinous:function(e,t,n){let r=n.length;for(let e=0;e<n.length;e++)if(n[e]>1){r=e;break}for(let s=r+1;s<n.length;s++)if(t[s]>0||n[s]!==e[s])return!1;return!0},computeFlatOffset:function(e,t){let n=e.length>0?e[e.length-1]:1;for(let r=0;r<e.length-1;r++)n+=e[r]*t[r];return n},parseSliceParams:function(e,t,n){let r;const s=e.shape.length;let a;return r="number"==typeof t?[t,...new Array(s-1).fill(0)]:t.length<s?t.concat(new Array(s-t.length).fill(0)):t.slice(),r.forEach(e=>{o(-1!==e,()=>"slice() does not support negative begin indexing.")}),a=null==n?new Array(s).fill(-1):"number"==typeof n?[n,...new Array(s-1).fill(-1)]:n.length<s?n.concat(new Array(s-n.length).fill(-1)):n,a=a.map((t,n)=>t>=0?t:(o(-1===t,()=>`Negative size values should be exactly -1 but got ${t} for the slice() size at index ${n}.`),e.shape[n]-r[n])),[r,a]},sliceInfo:function(e,t,n,r,s,o,a,i,l){let u=t.slice(),c=n.slice(),h=r;null==r&&(h=new Array(u.length));const d=ro(a);if(d.length>1)throw new Error("Multiple ellipses in slice is not allowed.");if(0!==a&&0!==i)throw new Error("Using both ellipsisMask and newAxisMask is not yet supported.");if(0!==a&&0!==l)throw new Error("Using both ellipsisMask and shrinkAxisMask is not yet supported.");const p=e.length-u.length,f=ro(i),m=e.slice();f.forEach(e=>{u[e]=0,c[e]=1,m.splice(e,0,1)});const{begin:g,end:b,strides:y}=lo(m,d,p,u,c,h,s,o,a);u=g,c=b,h=y;const w=ro(l);w.forEach(e=>{c[e]=u[e]+1,h[e]=1});const k=so(u,c,h),v=k.filter((e,t)=>-1===w.indexOf(t));return{nonStrided:h.every(e=>1===e),$begin:u,$end:c,$strides:h,size:k,newShape:m,outShape:v}}});class go{getClassName(){return this.constructor.className}static fromConfig(e,t){return new e(t)}}class bo{constructor(){this.classNameMap={}}static getMap(){return null==bo.instance&&(bo.instance=new bo),bo.instance}static register(e){bo.getMap().classNameMap[e.className]=[e,e.fromConfig]}}function yo(e){o(null!=e.className,()=>"Class being registered does not have the static className property defined."),o("string"==typeof e.className,()=>"className is required to be a string, but got type "+typeof e.className),o(e.className.length>0,()=>"Class being registered has an empty-string as its className, which is disallowed."),bo.register(e)}var wo=Object.freeze({__proto__:null,Serializable:go,SerializationMap:bo,registerClass:yo});function ko(){return 32===Nr.backend.floatPrecision()?.001:.1}function vo(e,t,n){let r=!0;if((w(e)||w(t))&&(r=!1),w(e)&&w(t)&&(r=!0),r){const n=e.constructor.name,r=t.constructor.name;if(n!==r)throw new Error(`Arrays are of different type. Actual: ${n}. Expected: `+r)}if(Array.isArray(e)&&Array.isArray(t)){const n=Cr(e),r=Cr(t);if(!c(n,r))throw new Error(`Arrays have different shapes. Actual: [${n}]. Expected: [${r}]`)}const s=w(e)?e:l(e),o=w(t)?t:l(t);if(s.length!==o.length)throw new Error(`Arrays have different lengths actual: ${s.length} vs expected: ${o.length}.\nActual:   ${s}.\nExpected: ${o}.`);for(let e=0;e<o.length;++e){const t=s[e],r=o[e];if(!n(t,r))throw new Error(`Arrays differ: actual[${e}] = ${t}, expected[${e}] = ${r}.\nActual:   ${s}.\nExpected: ${o}.`)}}function xo(e,t,n){return!isFinite(e)&&!isFinite(t)||!(isNaN(e)||isNaN(t)||Math.abs(e-t)>n)}var Eo=Object.freeze({__proto__:null,TEST_EPSILON_FLOAT16:.1,expectArraysClose:function(e,t,n){return null==n&&(n=ko()),vo(e,t,(e,t)=>xo(e,t,n))},testEpsilon:ko,expectPromiseToFail:function(e,t){e().then(()=>t.fail(),()=>t())},expectArraysEqual:function(e,t){const n="string"==typeof t||"number"==typeof t||"boolean"==typeof t?[t]:t;return x(e)||x(e[0])||x(t)||x(t[0])?vo(e,n,(e,t)=>e==t):vo(e,t,(e,t)=>xo(e,t,0))},expectNumbersClose:function(e,t,n){if(null==n&&(n=ko()),!xo(e,t,n))throw new Error(`Numbers differ: actual === ${e}, expected === ${t}`)},expectValuesInRange:function(e,t,n){for(let r=0;r<e.length;r++)if(e[r]<t||e[r]>n)throw new Error(`Value out of range:${e[r]} low: ${t}, high: ${n}`)},expectArrayBuffersEqual:function(e,t){expect(new Float32Array(e)).toEqual(new Float32Array(t))},encodeStrings:function e(t){for(let n=0;n<t.length;n++){const r=t[n];Array.isArray(r)?e(r):t[n]=Qn(r)}return t}});const So="3.5.0";function Ao(){B().set("PROD",!0)}function Io(){B().set("DEBUG",!0)}function $o(){B().set("DEPRECATION_WARNINGS_ENABLED",!1),console.warn("TensorFlow.js deprecation warnings have been disabled.")}function _o(e){B().getBool("DEPRECATION_WARNINGS_ENABLED")&&console.warn(e+" You can disable deprecation warnings with tf.disableDeprecationWarnings().")}function Mo(){Nr.disposeVariables()}function No(){return Nr}function To(){return Nr.memory()}function Do(e){return Nr.profile(e)}function Ro(e,t){return Nr.tidy(e,t)}function Fo(e){Sr(e).forEach(e=>e.dispose())}function Co(e){return Nr.keep(e)}function Bo(e){return Nr.time(e)}function Po(e){return Nr.setBackend(e)}function zo(){return Nr.ready()}function Lo(){return Nr.backendName}function Oo(e){Nr.removeBackend(e)}function Ko(e){return Nr.findBackend(e)}function Wo(e){return Nr.findBackendFactory(e)}function Uo(e,t,n=1){return Nr.registerBackend(e,t,n)}function qo(){return Nr.backend}function Go(e,t){B().setPlatform(e,t)}const Ho=Or({add_:function(e,t){let n=Pr(e,"a","add"),r=Pr(t,"b","add");[n,r]=xr(n,r);const s={a:n,b:r};return Nr.runKernel("Add",s)}});const Vo=Or({floorDiv_:function(e,t){let n=Pr(e,"a","floorDiv"),r=Pr(t,"b","floorDiv");[n,r]=xr(n,r);const s={a:n,b:r};return Nr.runKernel("FloorDiv",s)}});const jo=Or({div_:function(e,t){let n=Pr(e,"a","div"),r=Pr(t,"b","div");if([n,r]=xr(n,r),"int32"===n.dtype&&"int32"===r.dtype)return Vo(n,r);const s={a:n,b:r};return Nr.runKernel("RealDiv",s,{})}});const Jo=Or({mul_:function(e,t){let n=Pr(e,"a","mul"),r=Pr(t,"b","mul");[n,r]=xr(n,r);const s={a:n,b:r};return Nr.runKernel("Multiply",s)}});const Yo=Or({abs_:function(e){const t=Pr(e,"x","abs");if("complex64"===t.dtype){const e={x:t};return Nr.runKernel("ComplexAbs",e)}{const e={x:t};return Nr.runKernel("Abs",e)}}});const Zo=Or({acos_:function(e){const t={x:Pr(e,"x","acos")};return Nr.runKernel("Acos",t)}});const Xo=Or({acosh_:function(e){const t={x:Pr(e,"x","acosh")};return Nr.runKernel("Acosh",t)}});const Qo=Or({addN_:function(e){o(Array.isArray(e),()=>"The argument passed to tf.addN() must be a list of tensors"),o(e.length>=1,()=>"Must pass at least one tensor to tf.addN(), but got "+e.length);const t=e.map((e,t)=>Pr(e,"tensors"+t,"addN")),n=t[0];t.forEach(e=>{if(e.dtype!==n.dtype)throw new Error("All tensors passed to tf.addN() must have the same dtype")}),t.forEach(e=>{if(!c(e.shape,n.shape))throw new Error("All tensors passed to tf.addN() must have the same shape")});const r=t;return Nr.runKernel("AddN",r)}});const ea=Or({all_:function(e,t=null,n=!1){const r={x:Pr(e,"x","all","bool")},s={axis:t,keepDims:n};return Nr.runKernel("All",r,s)}});const ta=Or({any_:function(e,t=null,n=!1){const r={x:Pr(e,"x","any","bool")},s={axis:t,keepDims:n};return Nr.runKernel("Any",r,s)}});const na=Or({argMax_:function(e,t=0){const n={x:Pr(e,"x","argMax")},r={axis:t};return Nr.runKernel("ArgMax",n,r)}});const ra=Or({argMin_:function(e,t=0){const n={x:Pr(e,"x","argMin")},r={axis:t};return Nr.runKernel("ArgMin",n,r)}});const sa=Or({asin_:function(e){const t={x:Pr(e,"x","asin")};return Nr.runKernel("Asin",t)}});const oa=Or({asinh_:function(e){const t={x:Pr(e,"x","asinh")};return Nr.runKernel("Asinh",t)}});const aa=Or({atan_:function(e){const t={x:Pr(e,"x","atan")};return Nr.runKernel("Atan",t)}});const ia=Or({atan2_:function(e,t){let n=Pr(e,"a","atan2"),r=Pr(t,"b","atan2");[n,r]=xr(n,r);const s={a:n,b:r};return Nr.runKernel("Atan2",s)}});const la=Or({atanh_:function(e){const t={x:Pr(e,"x","atanh")};return Nr.runKernel("Atanh",t)}});function ua(e,t,n,r,s,o,a="channelsLast"){const[i,l]=pa(t);let u;if("channelsLast"===a)u=[i,l,e[3],e[3]];else{if("channelsFirst"!==a)throw new Error("Unknown dataFormat "+a);u=[i,l,e[1],e[1]]}return ca(e,u,n,r,s,o,!1,a)}function ca(e,t,n,r,s,o,a=!1,i="channelsLast"){let[l,u,c,h]=[-1,-1,-1,-1];if("channelsLast"===i)[l,u,c,h]=e;else{if("channelsFirst"!==i)throw new Error("Unknown dataFormat "+i);[l,h,u,c]=e}const[d,p,,f]=t,[m,g]=pa(n),[b,y]=pa(r),w=ma(d,b),k=ma(p,y),{padInfo:v,outHeight:x,outWidth:E}=function(e,t,n,r,s,o,a,i,l){let u,c,h;if("number"==typeof e){u={top:e,bottom:e,left:e,right:e,type:0===e?"VALID":"NUMBER"};const s=function(e,t,n,r,s){null==r&&(r=da(e,t,n));const o=e[0],a=e[1],i=ga((o-t+2*r)/n+1,s),l=ga((a-t+2*r)/n+1,s);return[i,l]}([t,n],o,r,e,i);c=s[0],h=s[1]}else if("same"===e){c=Math.ceil(t/r),h=Math.ceil(n/s);const e=Math.max(0,(c-1)*r+o-t),i=Math.max(0,(h-1)*s+a-n),l=Math.floor(e/2),d=e-l,p=Math.floor(i/2);u={top:l,bottom:d,left:p,right:i-p,type:"SAME"}}else if("valid"===e)u={top:0,bottom:0,left:0,right:0,type:"VALID"},c=Math.ceil((t-o+1)/r),h=Math.ceil((n-a+1)/s);else{if("object"!=typeof e)throw Error("Unknown padding parameter: "+e);{const d="channelsLast"===l?e[1][0]:e[2][0],p="channelsLast"===l?e[1][1]:e[2][1],f="channelsLast"===l?e[2][0]:e[3][0],m="channelsLast"===l?e[2][1]:e[3][1];u={top:d,bottom:p,left:f,right:m,type:0===d&&0===p&&0===f&&0===m?"VALID":"EXPLICIT"},c=ga((t-o+d+p)/r+1,i),h=ga((n-a+f+m)/s+1,i)}}return{padInfo:u,outHeight:c,outWidth:h}}(s,u,c,m,g,w,k,o,i),S=a?f*h:f;let A;return"channelsFirst"===i?A=[l,S,x,E]:"channelsLast"===i&&(A=[l,x,E,S]),{batchSize:l,dataFormat:i,inHeight:u,inWidth:c,inChannels:h,outHeight:x,outWidth:E,outChannels:S,padInfo:v,strideHeight:m,strideWidth:g,filterHeight:d,filterWidth:p,effectiveFilterHeight:w,effectiveFilterWidth:k,dilationHeight:b,dilationWidth:y,inShape:e,outShape:A,filterShape:t}}function ha(e,t,n,r,s,o=!1,a="channelsLast",i){let[l,u,c,h,d]=[-1,-1,-1,-1,-1];if("channelsLast"===a)[l,u,c,h,d]=e;else{if("channelsFirst"!==a)throw new Error("Unknown dataFormat "+a);[l,d,u,c,h]=e}const[p,f,m,,g]=t,[b,y,w]=fa(n),[k,v,x]=fa(r),E=ma(p,k),S=ma(f,v),A=ma(m,x),{padInfo:I,outDepth:$,outHeight:_,outWidth:M}=function(e,t,n,r,s,o,a,i,l,u,c){let h,d,p,f;if("number"==typeof e){h={top:e,bottom:e,left:e,right:e,front:e,back:e,type:0===e?"VALID":"NUMBER"};const o=function(e,t,n,r,s,o){null==s&&(s=da(e,t,r));const a=e[0],i=e[1],l=e[2],u=ga((a-t+2*s)/r+1,o),c=ga((i-t+2*s)/r+1,o),h=ga((l-t+2*s)/r+1,o);return[u,c,h,n]}([t,n,r,1],i,1,s,e,c);d=o[0],p=o[1],f=o[2]}else if("same"===e){d=Math.ceil(t/s),p=Math.ceil(n/o),f=Math.ceil(r/a);const e=(d-1)*s+i-t,c=(p-1)*o+l-n,m=(f-1)*a+u-r,g=Math.floor(e/2),b=e-g,y=Math.floor(c/2),w=c-y,k=Math.floor(m/2);h={top:y,bottom:w,left:k,right:m-k,front:g,back:b,type:"SAME"}}else{if("valid"!==e)throw Error("Unknown padding parameter: "+e);h={top:0,bottom:0,left:0,right:0,front:0,back:0,type:"VALID"},d=Math.ceil((t-i+1)/s),p=Math.ceil((n-l+1)/o),f=Math.ceil((r-u+1)/a)}return{padInfo:h,outDepth:d,outHeight:p,outWidth:f}}(s,u,c,h,b,y,w,E,S,A,i),N=o?g*d:g;let T;return"channelsFirst"===a?T=[l,N,$,_,M]:"channelsLast"===a&&(T=[l,$,_,M,N]),{batchSize:l,dataFormat:a,inDepth:u,inHeight:c,inWidth:h,inChannels:d,outDepth:$,outHeight:_,outWidth:M,outChannels:N,padInfo:I,strideDepth:b,strideHeight:y,strideWidth:w,filterDepth:p,filterHeight:f,filterWidth:m,effectiveFilterDepth:E,effectiveFilterHeight:S,effectiveFilterWidth:A,dilationDepth:k,dilationHeight:v,dilationWidth:x,inShape:e,outShape:T,filterShape:t}}function da(e,t,n,r=1){const s=ma(t,r);return Math.floor((e[0]*(n-1)-n+s)/2)}function pa(e){return"number"==typeof e?[e,e,e]:2===e.length?[e[0],e[1],1]:e}function fa(e){return"number"==typeof e?[e,e,e]:e}function ma(e,t){return t<=1?e:e+(e-1)*(t-1)}function ga(e,t){if(!t)return Math.trunc(e);switch(t){case"round":return Math.round(e);case"ceil":return Math.ceil(e);case"floor":return Math.floor(e);default:throw new Error("Unknown roundingMode "+t)}}function ba(e){const[t,n,r]=pa(e);return 1===t&&1===n&&1===r}function ya(e,t){return ba(e)||ba(t)}function wa(e){if("NHWC"===e)return"channelsLast";if("NCHW"===e)return"channelsFirst";throw new Error("Unknown dataFormat "+e)}const ka=Or({reshape_:function(e,t){const n={x:Pr(e,"x","reshape","string_or_numeric")},r={shape:t};return Nr.runKernel("Reshape",n,r)}});const va=Or({avgPool_:function(e,t,n,r,s){const a=Pr(e,"x","avgPool","float32");o(ya(n,1),()=>`Error in avgPool: Either strides or dilations must be 1. Got strides ${n} and dilations '1'`);let i=a,l=!1;3===a.rank&&(l=!0,i=ka(a,[1,a.shape[0],a.shape[1],a.shape[2]])),o(4===i.rank,()=>`Error in avgPool: x must be rank 4 but got rank ${i.rank}.`),null!=s&&o(h(r),()=>`Error in avgPool: pad must be an integer when using, dimRoundingMode ${s} but got pad ${r}.`);const u={x:i},c={filterSize:t,strides:n,pad:r,dimRoundingMode:s};let d=Nr.runKernel("AvgPool",u,c);return d=Ss(d,a.dtype),l?ka(d,[d.shape[1],d.shape[2],d.shape[3]]):d}});const xa=Or({avgPool3d_:function(e,t,n,r,s,a="NDHWC"){const i=Pr(e,"x","avgPool3d","float32");let l=i,u=!1;4===i.rank&&(u=!0,l=ka(i,[1,i.shape[0],i.shape[1],i.shape[2],i.shape[3]])),o(5===l.rank,()=>`Error in avgPool3d: x must be rank 5 but got rank ${l.rank}.`),o("NDHWC"===a,()=>"Error in avgPool3d: Only NDHWC is currently supported, but got dataFormat of "+a),null!=s&&o(h(r),()=>`Error in avgPool3d: pad must be an integer when using, dimRoundingMode ${s} but got pad ${r}.`);const c={x:l},d={filterSize:t,strides:n,pad:r,dimRoundingMode:s,dataFormat:a};let p=Nr.runKernel("AvgPool3D",c,d);return p=Ss(p,l.dtype),u?ka(p,[p.shape[1],p.shape[2],p.shape[3],p.shape[4]]):p}});const Ea=Or({concat_:function(e,t=0){o(e.length>=1,()=>"Pass at least one tensor to concat");const n=zr(e,"tensors","concat","string_or_numeric");if("complex64"===n[0].dtype&&n.forEach(e=>{if("complex64"!==e.dtype)throw new Error(`Cannot concatenate complex64 tensors with a tensor\n          with dtype ${e.dtype}. `)}),1===n.length)return As(n[0]);const r=n,s={axis:t};return Nr.runKernel("Concat",r,s)}});const Sa=Or({sigmoid_:function(e){const t={x:Pr(e,"x","sigmoid")};return Nr.runKernel("Sigmoid",t)}});const Aa=Or({slice_:function(e,t,n){const r=Pr(e,"x","slice","string_or_numeric");if(0===r.rank)throw new Error("Slicing scalar is not possible");const s={x:r},o={begin:t,size:n};return Nr.runKernel("Slice",s,o)}});const Ia=Or({tanh_:function(e){const t={x:Pr(e,"x","tanh")};return Nr.runKernel("Tanh",t)}});const $a=Or({basicLSTMCell_:function(e,t,n,r,s,o){const a=Pr(e,"forgetBias","basicLSTMCell"),i=Pr(t,"lstmKernel","basicLSTMCell"),l=Pr(n,"lstmBias","basicLSTMCell"),u=Pr(r,"data","basicLSTMCell"),c=Pr(s,"c","basicLSTMCell"),h=Pr(o,"h","basicLSTMCell"),d=Ea([u,h],1),p=Os(d,i),f=Ho(p,l),m=f.shape[0],g=f.shape[1]/4,b=[m,g],y=Aa(f,[0,0],b),w=Aa(f,[0,g],b),k=Aa(f,[0,2*g],b),v=Aa(f,[0,3*g],b),x=Ho(Jo(Sa(y),Ia(w)),Jo(c,Sa(Ho(a,k))));return[x,Jo(Ia(x),Sa(v))]}});const _a=Or({batchToSpaceND_:function(e,t,n){const r=Pr(e,"x","batchToSpaceND"),s=t.reduce((e,t)=>e*t);o(r.rank>=1+t.length,()=>`input rank is ${r.rank} but should be > than blockShape.length ${t.length}`),o(n.length===t.length,()=>`crops.length is ${n.length} but should be equal to blockShape.length  ${t.length}`),o(r.shape[0]%s==0,()=>`input tensor batch is ${r.shape[0]} but is not divisible by the product of the elements of blockShape ${t.join(" * ")} === ${s}`);const a={x:r},i={blockShape:t,crops:n};return Nr.runKernel("BatchToSpaceND",a,i)}});const Ma=Or({batchNorm_:function(e,t,n,r,s,a){null==a&&(a=.001);const i=Pr(e,"x","batchNorm"),l=Pr(t,"mean","batchNorm"),u=Pr(n,"variance","batchNorm");let c,h;null!=s&&(c=Pr(s,"scale","batchNorm")),null!=r&&(h=Pr(r,"offset","batchNorm")),o(l.rank===u.rank,()=>"Batch normalization gradient requires mean and variance to have equal ranks."),o(null==h||l.rank===h.rank,()=>"Batch normalization gradient requires mean and offset to have equal ranks."),o(null==c||l.rank===c.rank,()=>"Batch normalization gradient requires mean and scale to have equal ranks.");const d={x:function(e){let t;return t=0===e.rank||1===e.rank?ka(e,[1,1,1,e.size]):2===e.rank?ka(e,[1,1,e.shape[0],e.shape[1]]):3===e.rank?ka(e,[1,e.shape[0],e.shape[1],e.shape[2]]):e,t}(i),scale:c,offset:h,mean:l,variance:u},p={varianceEpsilon:a},f=Nr.runKernel("FusedBatchNorm",d,p);return ka(f,i.shape)}});const Na=Or({batchNorm2d_:function(e,t,n,r,s,a){const i=Pr(e,"x","batchNorm"),l=Pr(t,"mean","batchNorm"),u=Pr(n,"variance","batchNorm");let c,h;return null!=s&&(c=Pr(s,"scale","batchNorm")),null!=r&&(h=Pr(r,"offset","batchNorm")),o(2===i.rank,()=>"Error in batchNorm2D: x must be rank 2 but got rank "+i.rank+"."),o(2===l.rank||1===l.rank,()=>`Error in batchNorm2D: mean must be rank 2 or rank 1 but got rank ${l.rank}.`),o(2===u.rank||1===u.rank,()=>`Error in batchNorm2D: variance must be rank 2 or rank 1 but got rank ${u.rank}.`),null!=c&&o(2===c.rank||1===c.rank,()=>`Error in batchNorm2D: scale must be rank 2 or rank 1 but got rank ${c.rank}.`),null!=h&&o(2===h.rank||1===h.rank,()=>`Error in batchNorm2D: offset must be rank 2 or rank 1 but got rank ${h.rank}.`),Ma(i,l,u,h,c,a)}});const Ta=Or({batchNorm3d_:function(e,t,n,r,s,a){const i=Pr(e,"x","batchNorm"),l=Pr(t,"mean","batchNorm"),u=Pr(n,"variance","batchNorm");let c,h;return null!=s&&(c=Pr(s,"scale","batchNorm")),null!=r&&(h=Pr(r,"offset","batchNorm")),o(3===i.rank,()=>"Error in batchNorm3D: x must be rank 3 but got rank "+i.rank+"."),o(3===l.rank||1===l.rank,()=>`Error in batchNorm3D: mean must be rank 3 or rank 1 but got rank ${l.rank}.`),o(3===u.rank||1===u.rank,()=>`Error in batchNorm3D: variance must be rank 3 or rank 1 but got rank ${u.rank}.`),null!=c&&o(3===c.rank||1===c.rank,()=>`Error in batchNorm3D: scale must be rank 3 or rank 1 but got rank ${c.rank}.`),null!=h&&o(3===h.rank||1===h.rank,()=>`Error in batchNorm3D: offset must be rank 3 or rank 1 but got rank ${h.rank}.`),Ma(i,l,u,h,c,a)}});const Da=Or({batchNorm4d_:function(e,t,n,r,s,a){const i=Pr(e,"x","batchNorm"),l=Pr(t,"mean","batchNorm"),u=Pr(n,"variance","batchNorm");let c,h;return null!=s&&(c=Pr(s,"scale","batchNorm")),null!=r&&(h=Pr(r,"offset","batchNorm")),o(4===i.rank,()=>"Error in batchNorm4D: x must be rank 4 but got rank "+i.rank+"."),o(4===l.rank||1===l.rank,()=>`Error in batchNorm4D: mean must be rank 4 or rank 1 but got rank ${l.rank}.`),o(4===u.rank||1===u.rank,()=>`Error in batchNorm4D: variance must be rank 4 or rank 1 but got rank ${u.rank}.`),null!=c&&o(4===c.rank||1===c.rank,()=>`Error in batchNorm4D: scale must be rank 4 or rank 1 but got rank ${c.rank}.`),null!=h&&o(4===h.rank||1===h.rank,()=>`Error in batchNorm4D: offset must be rank 4 or rank 1 but got rank ${h.rank}.`),Ma(i,l,u,h,c,a)}});const Ra=Or({bincount_:function(e,t,n){const r=Pr(e,"x","bincount"),s=Pr(t,"weights","bincount");o("int32"===r.dtype,()=>"Error in bincount: input dtype must be int32, but got "+r.dtype),o(n>=0,()=>`size must be non-negative, but got ${n}.`),o(s.size===r.size||0===s.size,()=>`Error in bincount: weights must have the same size as input or0-length, but got input shape: ${r.shape}, weights shape: `+s.shape+".");const a={x:r,weights:s},i={size:n};return Nr.runKernel("Bincount",a,i)}});const Fa=Or({broadcastTo_:function(e,t){let n=Pr(e,"broadcastTo","x");const r=n.shape;if(t.some(e=>!(e>0)||e%1!=0))throw new Error(`broadcastTo(): Invalid broadcast shape [${t}].`);if(t.length<n.rank)throw new Error(`broadcastTo(): shape.length=${t.length} < input.rank=${n.rank}.`);if(t.length>n.rank){const e=n.shape.slice();for(;e.length<t.length;)e.unshift(1);n=ka(n,e)}const s=n.shape,o=Array.from(t);for(let e=t.length-1;e>=0;e--)if(s[e]===t[e])o[e]=1;else if(1!==n.shape[e])throw new Error(`broadcastTo(): [${r}] cannot be broadcast to [${t}].`);if(0===o.map((e,t)=>e>1?t:-1).filter(e=>e>=0).length)return As(n);const a={x:n},i={reps:o};return Nr.runKernel("Tile",a,i)}});const Ca=Or({ceil_:function(e){const t={x:Pr(e,"x","ceil")};return Nr.runKernel("Ceil",t)}});const Ba=Or({clipByValue_:function(e,t,n){const r=Pr(e,"x","clipByValue");o(t<=n,()=>`Error in clip: min (${t}) must be less than or equal to max (${n}).`);const s={x:r},a={clipValueMin:t,clipValueMax:n};return Nr.runKernel("ClipByValue",s,a)}});const Pa=Or({concat1d_:function(e){return Ea(e,0)}});const za=Or({concat2d_:function(e,t){return Ea(e,t)}});const La=Or({concat3d_:function(e,t){return Ea(e,t)}});const Oa=Or({concat4d_:function(e,t){return Ea(e,t)}});const Ka=Or({conv2d_:function(e,t,n,r,s="NHWC",a=[1,1],i){const l=Pr(e,"x","conv2d"),u=Pr(t,"filter","conv2d");let c=l,d=!1;3===l.rank&&(d=!0,c=ka(l,[1,l.shape[0],l.shape[1],l.shape[2]])),o(4===c.rank,()=>`Error in conv2d: input must be rank 4, but got rank ${c.rank}.`),o(4===u.rank,()=>"Error in conv2d: filter must be rank 4, but got rank "+u.rank+"."),null!=i&&o(h(r),()=>`Error in conv2d: pad must be an integer when using, dimRoundingMode ${i} but got pad ${r}.`);const p="NHWC"===s?c.shape[3]:c.shape[1];o(p===u.shape[2],()=>`Error in conv2d: depth of input (${p}) must match input depth for filter ${u.shape[2]}.`),o(ya(n,a),()=>`Error in conv2D: Either strides or dilations must be 1. Got strides ${n} and dilations '${a}'`);const f={x:c,filter:u},m={strides:n,pad:r,dataFormat:s,dilations:a,dimRoundingMode:i},g=Nr.runKernel("Conv2D",f,m);return d?ka(g,[g.shape[1],g.shape[2],g.shape[3]]):g}});const Wa=Or({conv1d_:function(e,t,n,r,s="NWC",a=1,i){const l=Pr(e,"x","conv1d"),u=Pr(t,"filter","conv1d");let c=l,d=!1;2===l.rank&&(d=!0,c=ka(l,[1,l.shape[0],l.shape[1]])),o(3===c.rank,()=>`Error in conv1d: input must be rank 3, but got rank ${c.rank}.`),o(3===u.rank,()=>"Error in conv1d: filter must be rank 3, but got rank "+u.rank+"."),null!=i&&o(h(r),()=>`Error in conv1d: pad must be an integer when using, dimRoundingMode ${i} but got pad ${r}.`),o(c.shape[2]===u.shape[1],()=>`Error in conv1d: depth of input (${c.shape[2]}) must match input depth for filter ${u.shape[1]}.`),o(ya(n,a),()=>`Error in conv1D: Either stride or dilation must be 1. Got stride ${n} and dilation '${a}'`),o("NWC"===s,()=>`Error in conv1d: got dataFormat of ${s} but only NWC is currently supported.`);const p=ka(u,[1,u.shape[0],u.shape[1],u.shape[2]]),f=ka(c,[c.shape[0],1,c.shape[1],c.shape[2]]),m=Ka(f,p,[1,n],r,"NHWC",[1,a],i);return ka(m,d?[m.shape[2],m.shape[3]]:[m.shape[0],m.shape[2],m.shape[3]])}});const Ua=Or({conv2DBackpropInput_:function(e,t,n,r,s,a="NHWC",i){o(e.length===t.rank,()=>`Length of inShape (${e.length}) and rank of dy (${t.rank}) must match`);let l=e,u=t,c=!1;3===t.rank&&(c=!0,u=ka(t,[1,t.shape[0],t.shape[1],t.shape[2]]),l=[1,e[0],e[1],e[2]]),o(4===l.length,()=>"Error in conv2dDerInput: inShape must be length 4, but got length "+l.length+"."),o(4===u.rank,()=>"Error in conv2dDerInput: dy must be rank 4, but got rank "+u.rank),o(4===n.rank,()=>"Error in conv2dDerInput: filter must be rank 4, but got rank "+n.rank);const d="NHWC"===a?l[3]:l[1],p="NHWC"===a?u.shape[3]:u.shape[1];o(d===n.shape[2],()=>`Error in conv2dDerInput: depth of input (${d}) must match input depth for filter ${n.shape[2]}.`),o(p===n.shape[3],()=>`Error in conv2dDerInput: depth of output (${p}) must match output depth for filter ${n.shape[3]}.`),null!=i&&o(h(s),()=>`Error in conv2dDerInput: pad must be an integer when using, dimRoundingMode ${i} but got pad ${s}.`);const f={dy:u,filter:n},m={strides:r,pad:s,dataFormat:a,dimRoundingMode:i,inputShape:l},g=Nr.runKernel("Conv2DBackpropInput",f,m);return c?ka(g,[g.shape[1],g.shape[2],g.shape[3]]):g}});const qa=Or({conv2dTranspose_:function(e,t,n,r,s,o){const a=Pr(e,"x","conv2dTranspose"),i=Pr(t,"filter","conv2dTranspose");return Ua(n,a,i,r,s,"NHWC",o)}});const Ga=Or({conv3d_:function(e,t,n,r,s="NDHWC",a=[1,1,1]){const i=Pr(e,"x","conv3d"),l=Pr(t,"filter","conv3d");let u=i,c=!1;4===i.rank&&(c=!0,u=ka(i,[1,i.shape[0],i.shape[1],i.shape[2],i.shape[3]])),o(5===u.rank,()=>`Error in conv3d: input must be rank 5, but got rank ${u.rank}.`),o(5===l.rank,()=>"Error in conv3d: filter must be rank 5, but got rank "+l.rank+"."),o(u.shape[4]===l.shape[3],()=>`Error in conv3d: depth of input (${u.shape[4]}) must match input depth for filter ${l.shape[3]}.`),o(ya(n,a),()=>`Error in conv3D: Either strides or dilations must be 1. Got strides ${n} and dilations '${a}'`),o("NDHWC"===s,()=>`Error in conv3d: got dataFormat of ${s} but only NDHWC is currently supported.`);const h={x:u,filter:l},d={strides:n,pad:r,dataFormat:s,dilations:a},p=Nr.runKernel("Conv3D",h,d);return c?ka(p,[p.shape[1],p.shape[2],p.shape[3],p.shape[4]]):p}});const Ha=Or({conv3DBackpropInput_:function(e,t,n,r,s){o(e.length===t.rank,()=>`Length of inShape (${e.length}) and rank of dy (${t.rank}) must match`);let a=e,i=t,l=!1;4===t.rank&&(l=!0,i=ka(t,[1,t.shape[0],t.shape[1],t.shape[2],t.shape[3]]),a=[1,e[0],e[1],e[2],e[3]]);const u=a[4],c=i.shape[4];o(5===a.length,()=>"Error in conv3dDerInput: inShape must be length 5, but got length "+a.length+"."),o(5===i.rank,()=>"Error in conv3dDerInput: dy must be rank 5, but got rank "+i.rank),o(5===n.rank,()=>"Error in conv3dDerInput: filter must be rank 5, but got rank "+n.rank),o(u===n.shape[3],()=>`Error in conv3dDerInput: depth of input (${u}) must match input depth for filter ${n.shape[3]}.`),o(c===n.shape[4],()=>`Error in conv3dDerInput: depth of output (${c}) must match output depth for filter ${n.shape[4]}.`);const h={dy:i,filter:n},d={pad:s,strides:r,inputShape:a},p=Nr.runKernel("Conv3DBackpropInputV2",h,d);return l?ka(p,[p.shape[1],p.shape[2],p.shape[3],p.shape[4]]):p}});const Va=Or({conv3dTranspose_:function(e,t,n,r,s){const o=Pr(e,"x","conv3dTranspose"),a=Pr(t,"filter","conv3dTranspose");return Ha(n,o,a,r,s)}});const ja=Or({cos_:function(e){const t={x:Pr(e,"x","cos")};return Nr.runKernel("Cos",t)}});const Ja=Or({cosh_:function(e){const t={x:Pr(e,"x","cosh")};return Nr.runKernel("Cosh",t)}});const Ya=Or({cumsum_:function(e,t=0,n=!1,r=!1){const s={x:Pr(e,"x","cumsum")},o={axis:t,exclusive:n,reverse:r};return Nr.runKernel("Cumsum",s,o)}});const Za=Or({denseBincount_:function(e,t,n,r=!1){const s=Pr(e,"x","denseBincount"),a=Pr(t,"weights","denseBincount");o("int32"===s.dtype,()=>"Error in denseBincount: input dtype must be int32, but got "+s.dtype),o(s.rank<=2,()=>`Error in denseBincount: input must be at most rank 2, but got rank ${s.rank}.`),o(n>=0,()=>`size must be non-negative, but got ${n}.`),o(a.size===s.size||0===a.size,()=>`Error in denseBincount: weights must have the same shape as x or 0-length, but got x shape: ${s.shape}, weights shape: `+a.shape+".");const i={x:s,weights:a},l={size:n,binaryOutput:r};return Nr.runKernel("DenseBincount",i,l)}});const Xa=Or({depthToSpace_:function(e,t,n="NHWC"){const r=Pr(e,"x","depthToSpace"),s="NHWC"===n?r.shape[1]:r.shape[2],a="NHWC"===n?r.shape[2]:r.shape[3],i="NHWC"===n?r.shape[3]:r.shape[1];o(s*t>=0,()=>`Negative dimension size caused by overflow when multiplying\n    ${s} and ${t}  for depthToSpace with input shape\n    ${r.shape}`),o(a*t>=0,()=>`Negative dimension size caused by overflow when multiplying\n    ${a} and ${t} for depthToSpace with input shape\n        ${r.shape}`),o(i%(t*t)==0,()=>`Dimension size must be evenly divisible by ${t*t} but is ${i} for depthToSpace with input shape ${r.shape}`);const l={x:r},u={blockSize:t,dataFormat:n};return Nr.runKernel("DepthToSpace",l,u)}});const Qa=Or({depthwiseConv2d_:function(e,t,n,r,s="NHWC",a=[1,1],i){const l=Pr(e,"x","depthwiseConv2d"),u=Pr(t,"filter","depthwiseConv2d");let c=l,d=!1;3===l.rank&&(d=!0,c=ka(l,[1,l.shape[0],l.shape[1],l.shape[2]])),o(4===c.rank,()=>`Error in depthwiseConv2d: input must be rank 4, but got rank ${c.rank}.`),o(4===u.rank,()=>"Error in depthwiseConv2d: filter must be rank 4, but got rank "+u.rank+"."),o(c.shape[3]===u.shape[2],()=>`Error in depthwiseConv2d: number of input channels (${c.shape[3]}) must match the inChannels dimension in filter ${u.shape[2]}.`),null!=i&&o(h(r),()=>`Error in depthwiseConv2d: pad must be an integer when using, dimRoundingMode ${i} but got pad ${r}.`);const p={x:c,filter:u},f={strides:n,pad:r,dataFormat:s,dilations:a,dimRoundingMode:i},m=Nr.runKernel("DepthwiseConv2dNative",p,f);return d?ka(m,[m.shape[1],m.shape[2],m.shape[3]]):m}});const ei=Or({diag_:function(e){const t={x:Pr(e,"x","diag")};return Nr.runKernel("Diag",t)}});const ti=Or({dilation2d_:function(e,t,n,r,s=[1,1],a="NHWC"){const i=Pr(e,"x","dilation2d"),l=Pr(t,"filter","dilation2d");o(3===i.rank||4===i.rank,()=>"Error in dilation2d: input must be rank 3 or 4, but got rank "+i.rank+"."),o(3===l.rank,()=>"Error in dilation2d: filter must be rank 3, but got rank "+l.rank+"."),o("NHWC"===a,()=>"Error in dilation2d: Only NHWC is currently supported, but got dataFormat of "+a);let u=i,c=!1;3===i.rank&&(u=ka(i,[1,i.shape[0],i.shape[1],i.shape[2]]),c=!0);const h={x:u,filter:l},d={strides:n,pad:r,dilations:s},p=Nr.runKernel("Dilation2D",h,d);return c?ka(p,[p.shape[1],p.shape[2],p.shape[3]]):p}});function ni(e,t){const n=[];for(let r=0;r<t.length;r++){const s=e[e.length-r-1],o=t.length-r-1,a=t[o];(null==s||1===s&&a>1)&&n.unshift(o)}return n}function ri(e,t){const n=[],r=Math.max(e.length,t.length);for(let s=0;s<r;s++){let r=e[e.length-s-1];null==r&&(r=1);let o=t[t.length-s-1];if(null==o&&(o=1),1===r)n.unshift(o);else if(1===o)n.unshift(r);else{if(r!==o){throw Error(`Operands could not be broadcast together with shapes ${e} and ${t}.`)}n.unshift(r)}}return n}const si=Or({equal_:function(e,t){let n=Pr(e,"a","equal"),r=Pr(t,"b","equal");[n,r]=xr(n,r),ri(n.shape,r.shape);const s={a:n,b:r};return Nr.runKernel("Equal",s)}});const oi=Or({where_:function(e,t,n){const r=Pr(t,"a","where"),s=Pr(n,"b","where"),o=Pr(e,"condition","where","bool"),a=ri(ri(o.shape,r.shape),s.shape),i={condition:Fa(o,a),t:Fa(r,a),e:Fa(s,a)};return Nr.runKernel("Select",i)}});const ai=Or({zerosLike_:function(e){const t={x:Pr(e,"x","zerosLike")};return Nr.runKernel("ZerosLike",t)}});const ii=Or({divNoNan_:function(e,t){let n=Pr(e,"a","div"),r=Pr(t,"b","div");[n,r]=xr(n,r);const s=jo(n,r),o=ai(s),a=si(r,o);return oi(a,o,s)}});const li=Or({dot_:function(e,t){const n=Pr(e,"t1","dot"),r=Pr(t,"t2","dot");o(!(1!==n.rank&&2!==n.rank||1!==r.rank&&2!==r.rank),()=>`Error in dot: inputs must all be rank 1 or 2, but got ranks ${n.rank} and ${r.rank}.`);const s=1===n.rank?n.size:n.shape[1],a=1===r.rank?r.size:r.shape[0];if(o(s===a,()=>`Error in dot: inner dimensions of inputs must match, but got ${s} and ${a}.`),1===n.rank&&1===r.rank){const e=ka(n,[1,-1]),t=ka(r,[-1,1]),s=Os(e,t);return ka(s,[])}if(1===n.rank&&2===r.rank){const e=ka(n,[1,-1]),t=ka(r,[r.shape[0],r.shape[1]]),s=Os(e,t);return ka(s,[s.size])}if(2===n.rank&&1===r.rank){const e=ka(r,[-1,1]),t=Os(n,e);return ka(t,[t.size])}{const e=ka(r,[r.shape[0],r.shape[1]]);return Os(n,e)}}});const ui=Or({einsum_:function(e,...t){const n=t.map((e,t)=>Pr(e,"tensors"+t,"einsum")),r={equation:e};return Nr.runKernel("Einsum",n,r)}});const ci=Or({elu_:function(e){const t={x:Pr(e,"x","elu")};return Nr.runKernel("Elu",t)}});const hi=Or({erf_:function(e){let t=Pr(e,"x","erf");o("int32"===t.dtype||"float32"===t.dtype,()=>"Input dtype must be `int32` or `float32`."),"int32"===t.dtype&&(t=Ss(t,"float32"));const n={x:t};return Nr.runKernel("Erf",n)}});const di=Or({exp_:function(e){const t={x:Pr(e,"x","exp")};return Nr.runKernel("Exp",t)}});const pi=Or({expandDims_:function(e,t=0){const n=Pr(e,"x","expandDims","string_or_numeric");o(t<=n.rank,()=>"Axis must be <= rank of the tensor");const r={input:n},s={dim:t};return Nr.runKernel("ExpandDims",r,s)}});const fi=Or({expm1_:function(e){const t={x:Pr(e,"x","expm1")};return Nr.runKernel("Expm1",t)}});const mi=Or({tile_:function(e,t){const n=Pr(e,"x","tile","string_or_numeric");o(n.rank===t.length,()=>`Error in transpose: rank of input ${n.rank} must match length of reps ${t}.`);const r={x:n},s={reps:t};return Nr.runKernel("Tile",r,s)}});const gi=Or({eye_:function(e,t,n,r="float32"){null==t&&(t=e);const s=Es([e,t],r),o=e<=t?e:t;for(let e=0;e<o;++e)s.set(1,e,e);const a=ka(s.toTensor(),[e,t]);if(null==n)return a;if(1===n.length)return mi(pi(a,0),[n[0],1,1]);if(2===n.length)return mi(pi(pi(a,0),0),[n[0],n[1],1,1]);if(3===n.length)return mi(pi(pi(pi(a,0),0),0),[n[0],n[1],n[2],1,1]);throw new Error(`eye() currently supports only 1D and 2D batchShapes, but received ${n.length}D.`)}});function bi(e,t,n){const r={shape:e,value:t,dtype:n};return Nr.runKernel("Fill",{},r)}const yi=Or({floor_:function(e){const t={x:Pr(e,"x","floor")};return Nr.runKernel("Floor",t)}});const wi=Or({gather_:function(e,t,n=0,r=0){const s={x:Pr(e,"x","gather"),indices:Pr(t,"indices","gather","int32")},o={axis:n,batchDims:r};return Nr.runKernel("GatherV2",s,o)}});const ki=Or({greater_:function(e,t){let n=Pr(e,"a","greater"),r=Pr(t,"b","greater");[n,r]=xr(n,r),ri(n.shape,r.shape);const s={a:n,b:r};return Nr.runKernel("Greater",s)}});const vi=Or({greaterEqual_:function(e,t){let n=Pr(e,"a","greaterEqual"),r=Pr(t,"b","greaterEqual");[n,r]=xr(n,r),ri(n.shape,r.shape);const s={a:n,b:r};return Nr.runKernel("GreaterEqual",s)}});const xi=Or({imag_:function(e){const t={input:Pr(e,"input","imag")};return Nr.runKernel("Imag",t)}});const Ei=Or({isFinite_:function(e){const t={x:Pr(e,"x","isFinite")};return Nr.runKernel("IsFinite",t)}});const Si=Or({isInf_:function(e){const t={x:Pr(e,"x","isInf")};return Nr.runKernel("IsInf",t)}});const Ai=Or({isNaN_:function(e){const t={x:Pr(e,"x","isNaN")};return Nr.runKernel("IsNan",t)}});const Ii=Or({leakyRelu_:function(e,t=.2){const n={x:Pr(e,"x","leakyRelu")},r={alpha:t};return Nr.runKernel("LeakyRelu",n,r)}});const $i=Or({less_:function(e,t){let n=Pr(e,"a","less"),r=Pr(t,"b","less");[n,r]=xr(n,r),ri(n.shape,r.shape);const s={a:n,b:r};return Nr.runKernel("Less",s)}});const _i=Or({lessEqual_:function(e,t){let n=Pr(e,"a","lessEqual"),r=Pr(t,"b","lessEqual");[n,r]=xr(n,r),ri(n.shape,r.shape);const s={a:n,b:r};return Nr.runKernel("LessEqual",s)}});function Mi(e,t,n){if(n<=0)throw new Error("The number of values should be positive.");const r={start:e,stop:t,num:n};return Nr.runKernel("LinSpace",{},r)}const Ni=Or({localResponseNormalization_:function(e,t=5,n=1,r=1,s=.5){const a=Pr(e,"x","localResponseNormalization");o(4===a.rank||3===a.rank,()=>`Error in localResponseNormalization: x must be rank 3 or 4 but got\n               rank ${a.rank}.`),o(h(t),()=>`Error in localResponseNormalization: depthRadius must be an integer but got depthRadius ${t}.`);let i=a,l=!1;3===a.rank&&(l=!0,i=ka(a,[1,a.shape[0],a.shape[1],a.shape[2]]));const u={x:i},c={depthRadius:t,bias:n,alpha:r,beta:s},d=Nr.runKernel("LRN",u,c);return l?ka(d,[d.shape[1],d.shape[2],d.shape[3]]):d}});const Ti=Or({log_:function(e){const t={x:Pr(e,"x","log")};return Nr.runKernel("Log",t)}});const Di=Or({log1p_:function(e){const t={x:Pr(e,"x","log1p")};return Nr.runKernel("Log1p",t)}});function Ri(e){return o(I(e),()=>"The f passed in grad(f) must be a function"),(t,n)=>{const r=Pr(t,"x","tf.grad","string_or_numeric"),s=null!=n?Pr(n,"dy","tf.grad"):null;return Nr.tidy(()=>{const{value:t,grads:n}=Nr.gradients(()=>e(r),[r],s);return null!=s&&a(t.shape,s.shape,"The shape of dy passed in grad(f)(x, dy) must match the shape returned by f(x)"),Li(n),n[0]})}}function Fi(e){return o(I(e),()=>"The f passed in grads(f) must be a function"),(t,n)=>{o(Array.isArray(t),()=>"The args passed in grads(f)(args) must be an array of `Tensor`s or `TensorLike`s");const r=zr(t,"args","tf.grads","string_or_numeric"),s=null!=n?Pr(n,"dy","tf.grads"):null;return Nr.tidy(()=>{const{value:t,grads:n}=Nr.gradients(()=>e(...r),r,s);return null!=s&&a(t.shape,s.shape,"The shape of dy passed in grads(f)([x1,...], dy) must match the shape returned by f([x1,...])"),Li(n),n})}}function Ci(e){return o(I(e),()=>"The f passed in valueAndGrad(f) must be a function"),(t,n)=>{o(t instanceof dr,()=>"The x passed in valueAndGrad(f)(x) must be a tensor"),o(null==n||n instanceof dr,()=>"The dy passed in valueAndGrad(f)(x, dy) must be a tensor");const{grads:r,value:s}=Nr.gradients(()=>e(t),[t],n);return Li(r),{grad:r[0],value:s}}}function Bi(e){return o(I(e),()=>"The f passed in valueAndGrads(f) must be a function"),(t,n)=>{o(Array.isArray(t)&&t.every(e=>e instanceof dr),()=>"The args passed in valueAndGrads(f)(args) must be array of tensors"),o(null==n||n instanceof dr,()=>"The dy passed in valueAndGrads(f)(args, dy) must be a tensor");const r=Nr.gradients(()=>e(...t),t,n);return null!=n&&a(r.value.shape,n.shape,"The shape of dy passed in valueAndGrads(f)([x1,...], dy) must match the shape returned by f([x1,...])"),Li(r.grads),r}}function Pi(e,t){o(I(e),()=>"The f passed in variableGrads(f) must be a function"),o(null==t||Array.isArray(t)&&t.every(e=>e instanceof pr),()=>"The varList passed in variableGrads(f, varList) must be an array of variables");const n=null!=t;if(!n){t=[];for(const e in Nr.registeredVariables)t.push(Nr.registeredVariables[e])}const r=n?t.filter(e=>!e.trainable):null,s=t.length;o((t=t.filter(e=>e.trainable)).length>0,()=>`variableGrads() expects at least one of the input variables to be trainable, but none of the ${s} variables is trainable.`);const{value:a,grads:i}=Nr.gradients(e,t,null,!0);o(i.some(e=>null!=e),()=>"Cannot find a connection between any variable and the result of the loss function y=f(x). Please make sure the operations that use variables are inside the function f passed to minimize()."),o(0===a.rank,()=>`The f passed in variableGrads(f) must return a scalar, but it returned a rank-${a.rank} tensor`);const l={};return t.forEach((e,t)=>{null!=i[t]&&(l[e.name]=i[t])}),null!=r&&r.forEach(e=>l[e.name]=null),{value:a,grads:l}}function zi(e){return Nr.customGrad(e)}function Li(e){if(e.filter(e=>null==e).length>0)throw new Error("Cannot compute gradient of y=f(x) with respect to x. Make sure that\n    the f you passed encloses all operations that lead from x to y.")}const Oi=Or({neg_:function(e){const t={x:Pr(e,"x","neg")};return Nr.runKernel("Neg",t)}});const Ki=Or({softplus_:function(e){const t={x:Pr(e,"x","softplus")};return Nr.runKernel("Softplus",t)}});const Wi=Or({logSigmoid_:function(e){const t=Pr(e,"x","logSigmoid");return zi(e=>({value:Oi(Ki(Oi(e))),gradFunc:t=>Jo(t,Sa(Oi(e)))}))(t)}});const Ui=Or({max_:function(e,t=null,n=!1){const r={x:Pr(e,"x","max")},s={reductionIndices:t,keepDims:n};return Nr.runKernel("Max",r,s)}});const qi=Or({sub_:function(e,t){let n=Pr(e,"a","sub"),r=Pr(t,"b","sub");[n,r]=xr(n,r);const s={a:n,b:r};return Nr.runKernel("Sub",s)}});const Gi=Or({sum_:function(e,t=null,n=!1){let r=Pr(e,"x","sum");"bool"===r.dtype&&(r=Ss(r,"int32"));const s={x:r},o={axis:t,keepDims:n};return Nr.runKernel("Sum",s,o)}});const Hi=Or({logSoftmax_:function(e,t=-1){const n=Pr(e,"logits","logSoftmax");if(-1===t&&(t=n.rank-1),t!==n.rank-1)throw Error(`Log Softmax along a non-last dimension is not yet supported. Logits was rank ${n.rank} and axis was ${t}`);return zi((e,n)=>{const r=Ui(e,t,!0),s=qi(e,r),o=qi(Ss(s,"float32"),Ti(Gi(di(s),t,!0)));n([o]);return{value:o,gradFunc:(e,n)=>{const[r]=n,s=di(r);return qi(e,Jo(Gi(e,t,!0),s))}}})(n)}});function Vi(e,t){for(let n=0;n<e.length;++n)if(e[e.length-n-1]!==t-1-n)return!1;return!0}function ji(e,t,n){const r=e.length+t.length,s=[];let o=0,a=0;for(let i=0;i<r;i++)-1===n.indexOf(i)?s.push(e[o++]):s.push(t[a++]);return s}function Ji(e,t){return ji(e,t.map(e=>1),t)}const Yi=Or({logSumExp_:function(e,t=null,n=!1){const r=Pr(e,"x","logSumExp"),s=p(t,r.shape),o=Ui(r,s,!0),a=qi(r,o),i=di(a),l=Gi(i,s),u=Ti(l),c=Ho(ka(o,u.shape),u);if(n){const e=Ji(c.shape,s);return ka(c,e)}return c}});const Zi=Or({logicalAnd_:function(e,t){const n=Pr(e,"a","logicalAnd","bool"),r=Pr(t,"b","logicalAnd","bool");ri(n.shape,r.shape);const s={a:n,b:r};return Nr.runKernel("LogicalAnd",s)}});const Xi=Or({logicalNot_:function(e){const t={x:Pr(e,"x","logicalNot","bool")};return Nr.runKernel("LogicalNot",t)}});const Qi=Or({logicalOr_:function(e,t){const n=Pr(e,"a","logicalOr","bool"),r=Pr(t,"b","logicalOr","bool");ri(n.shape,r.shape);const s={a:n,b:r};return Nr.runKernel("LogicalOr",s)}});const el=Or({logicalXor_:function(e,t){const n=Pr(e,"a","logicalXor","bool"),r=Pr(t,"b","logicalXor","bool");return ri(n.shape,r.shape),Zi(Qi(e,t),Xi(Zi(e,t)))}});const tl=Or({maxPool_:function(e,t,n,r,s){const a=Pr(e,"x","maxPool");let i=a,l=!1;3===a.rank&&(l=!0,i=ka(a,[1,a.shape[0],a.shape[1],a.shape[2]])),o(4===i.rank,()=>`Error in maxPool: input must be rank 4 but got rank ${i.rank}.`),o(ya(n,1),()=>`Error in maxPool: Either strides or dilations must be 1. Got strides ${n} and dilations '1'`),null!=s&&o(h(r),()=>`Error in maxPool: pad must be an integer when using, dimRoundingMode ${s} but got pad ${r}.`);const u={x:i},c={filterSize:t,strides:n,pad:r,dimRoundingMode:s},d=Nr.runKernel("MaxPool",u,c);return l?ka(d,[d.shape[1],d.shape[2],d.shape[3]]):d}});const nl=Or({maxPool3d_:function(e,t=[1,1,1],n,r,s,a="NDHWC"){const i=Pr(e,"x","maxPool3d");let l=i,u=!1;4===i.rank&&(u=!0,l=ka(i,[1,i.shape[0],i.shape[1],i.shape[2],i.shape[3]])),o(5===l.rank,()=>`Error in maxPool3d: x must be rank 5 but got rank ${l.rank}.`),o("NDHWC"===a,()=>"Error in maxPool3d: Only NDHWC is currently supported, but got dataFormat of "+a),null!=s&&o(h(r),()=>`Error in maxPool3d: pad must be an integer when using, dimRoundingMode ${s} but got pad ${r}.`);const c={x:l},d={filterSize:t,strides:n,pad:r,dimRoundingMode:s,dataFormat:a},p=Nr.runKernel("MaxPool3D",c,d);return u?ka(p,[p.shape[1],p.shape[2],p.shape[3],p.shape[4]]):p}});const rl=Or({maxPoolWithArgmax_:function(e,t,n,r,s=!1){const o={x:Pr(e,"x","maxPoolWithArgmax")},a={filterSize:t,strides:n,pad:r,includeBatchInIndex:s},i=Nr.runKernel("MaxPoolWithArgmax",o,a);return{result:i[0],indexes:i[1]}}});const sl=Or({maximum_:function(e,t){let n=Pr(e,"a","maximum"),r=Pr(t,"b","maximum");[n,r]=xr(n,r),"bool"===n.dtype&&(n=Ss(n,"int32"),r=Ss(r,"int32")),ri(n.shape,r.shape);const s={a:n,b:r};return Nr.runKernel("Maximum",s)}});const ol=Or({mean_:function(e,t=null,n=!1){const r={x:Pr(e,"x","mean")},s={axis:t,keepDims:n};return Nr.runKernel("Mean",r,s)}});function al(e,t="float32"){if("complex64"===t){const t=al(e,"float32"),n=al(e,"float32");return Kr(t,n)}const n=T(u(e),t);return Nr.makeTensor(n,e,t)}function il(e,t="float32"){if("complex64"===t){const t=il(e,"float32"),n=al(e,"float32");return Kr(t,n)}const n=N(u(e),t);return Nr.makeTensor(n,e,t)}function ll(e,t,{indexing:n="xy"}={}){if("xy"!==n&&"ij"!==n)throw new TypeError(n+" is not a valid third argument to meshgrid");if(void 0===e)return[];let r=Pr(e,"x","meshgrid",e instanceof dr?e.dtype:"float32");if(void 0===t)return[r];let s=Pr(t,"y","meshgrid",t instanceof dr?t.dtype:"float32");const o=u(r.shape),a=u(s.shape);return"xy"===n?(r=ka(r,[1,-1]),s=ka(s,[-1,1]),[Os(il([a,1],r.dtype),r),Os(s,il([1,o],s.dtype))]):(r=ka(r,[-1,1]),s=ka(s,[1,-1]),[Os(r,il([1,a],r.dtype)),Os(il([o,1],s.dtype),s)])}const ul=Or({min_:function(e,t=null,n=!1){const r={x:Pr(e,"x","min")},s={axis:t,keepDims:n};return Nr.runKernel("Min",r,s)}});const cl=Or({minimum_:function(e,t){let n=Pr(e,"a","minimum"),r=Pr(t,"b","minimum");[n,r]=xr(n,r),"bool"===n.dtype&&(n=Ss(n,"int32"),r=Ss(r,"int32")),ri(n.shape,r.shape);const s={a:n,b:r};return Nr.runKernel("Minimum",s)}});const hl=Or({mirrorPad_:function(e,t,n){o("reflect"===n||"symmetric"===n,()=>`Invalid mode. Mode must be either reflect or symmetric. Got ${n}.`);const r=Pr(e,"x","mirrorPad");if(0===r.rank)throw new Error("mirrorPad(scalar) is not defined. Pass non-scalar to mirrorPad");o(t.length===r.rank,()=>`Padding doesn't match input. Must be ${r.rank}. Got ${t.length}.`);const s="reflect"===n?1:0;for(let e=0;e<r.rank;e++)o(2===t[e].length,()=>"Invalid number of paddings. Must be length of 2 each."),o(t[e][0]>=0&&t[e][0]<=r.shape[e]-s&&t[e][1]>=0&&t[e][1]<=r.shape[e]-s,()=>`Padding in dimension ${e} cannot be greater than or equal to ${r.shape[e]-s} or less than 0 for input of shape `+r.shape);const a={paddings:t,mode:n},i={x:r};return Nr.runKernel("MirrorPad",i,a)}});const dl=Or({mod_:function(e,t){let n=Pr(e,"a","mod"),r=Pr(t,"b","mod");[n,r]=xr(n,r);const s={a:n,b:r};return Nr.runKernel("Mod",s)}});const pl=Or({square_:function(e){const t=Pr(e,"x","square");return Nr.runKernel("Square",{x:t},{})}});const fl=Or({moments_:function(e,t=null,n=!1){const r=p(t,(e=Pr(e,"x","moments")).shape),s=ol(e,r,n);let o=s.shape;n||(o=Ji(s.shape,r));const a=pl(qi(Ss(e,"float32"),ka(s,o)));return{mean:s,variance:ol(a,r,n)}}});const ml=Or({multiRNNCell_:function(e,t,n,r){const s=Pr(t,"data","multiRNNCell"),o=zr(n,"c","multiRNNCell"),a=zr(r,"h","multiRNNCell");let i=s;const l=[];for(let t=0;t<e.length;t++){const n=e[t](i,o[t],a[t]);l.push(n[0]),l.push(n[1]),i=n[1]}const u=[],c=[];for(let e=0;e<l.length;e+=2)u.push(l[e]),c.push(l[e+1]);return[u,c]}});const gl=Or({multinomial_:function(e,t,n,r=!1){const s=Pr(e,"logits","multinomial"),o=s.size,a=s.rank;if(o<2)throw new Error("Error in multinomial: you need at least 2 outcomes, but got "+o+".");if(a>2)throw new Error("Rank of probabilities must be 1 or 2, but is "+a);n=n||Math.random();const i={logits:1===a?ka(s,[1,-1]):s},l={numSamples:t,seed:n,normalized:r},u=Nr.runKernel("Multinomial",i,l);return 1===a?ka(u,[u.size]):u}});const bl=Or({notEqual_:function(e,t){let n=Pr(e,"a","notEqual"),r=Pr(t,"b","notEqual");[n,r]=xr(n,r),ri(n.shape,r.shape);const s={a:n,b:r};return Nr.runKernel("NotEqual",s)}});const yl=Or({onesLike_:function(e){const t={x:Pr(e,"x","onesLike")};return Nr.runKernel("OnesLike",t)}});const wl=Or({outerProduct_:function(e,t){const n=Pr(e,"v1","outerProduct"),r=Pr(t,"v2","outerProduct");o(1===n.rank&&1===r.rank,()=>`Error in outerProduct: inputs must be rank 1, but got ranks ${n.rank} and ${r.rank}.`);const s=ka(n,[-1,1]),a=ka(r,[1,-1]);return Os(s,a)}});const kl=Or({pad_:function(e,t,n=0){const r=Pr(e,"x","pad");if(0===r.rank)throw new Error("pad(scalar) is not defined. Pass non-scalar to pad");const s={paddings:t,constantValue:n},o={x:r};return Nr.runKernel("PadV2",o,s)}});const vl=Or({pad1d_:function(e,t,n=0){return o(2===t.length,()=>"Invalid number of paddings. Must be length of 2."),kl(e,[t],n)}});const xl=Or({pad2d_:function(e,t,n=0){return o(2===t.length&&2===t[0].length&&2===t[1].length,()=>"Invalid number of paddings. Must be length of 2 each."),kl(e,t,n)}});const El=Or({pad3d_:function(e,t,n=0){return o(3===t.length&&2===t[0].length&&2===t[1].length&&2===t[2].length,()=>"Invalid number of paddings. Must be length of 2 each."),kl(e,t,n)}});const Sl=Or({pad4d_:function(e,t,n=0){return o(4===t.length&&2===t[0].length&&2===t[1].length&&2===t[2].length&&2===t[3].length,()=>"Invalid number of paddings. Must be length of 2 each."),kl(e,t,n)}});const Al=Or({spaceToBatchND_:function(e,t,n){const r=Pr(e,"x","spaceToBatchND");o(r.rank>=1+t.length,()=>`input rank ${r.rank} should be > than [blockShape] ${t.length}`),o(n.length===t.length,()=>`paddings.shape[0] ${n.length} must be equal to [blockShape] ${t.length}`),o(r.shape.reduce((e,r,s)=>s>0&&s<=t.length?e&&(r+n[s-1][0]+n[s-1][1])%t[s-1]==0:e,!0),()=>`input spatial dimensions ${r.shape.slice(1)} with paddings ${n.toString()} must be divisible by blockShapes ${t.toString()}`);const s={x:r},a={blockShape:t,paddings:n};return Nr.runKernel("SpaceToBatchND",s,a)}});const Il=Or({pool_:function(e,t,n,r,s,a){null==s&&(s=[1,1]),null==a&&(a=1),0===r&&(r="valid");const i=Pr(e,"x","maxPool");let l=i,u=!1;3===i.rank&&(u=!0,l=ka(i,[1,i.shape[0],i.shape[1],i.shape[2]])),o(ya(a,s),()=>`Error in pool: Either strides or dilations must be 1. Got strides ${a} and dilations '${s}'`);const c=ua(l.shape,t,a,s,r),h=[c.dilationHeight,c.dilationWidth];let d;d="same"===r?function(e,t){const n=e.map((e,n)=>e+(e-1)*(t[n]-1)).map(e=>e-1),r=n.map(e=>Math.floor(e/2)),s=n.map((e,t)=>e-r[t]);return n.map((e,t)=>[r[t],s[t]])}([c.filterHeight,c.filterWidth],h):[[0,0],[0,0]];const p=1===h[0]&&1===h[1],[f,m]=function(e,t,n){const r=n.map(e=>e[0]),s=n.map(e=>e[1]),o=e.concat(r,s),a=t.map((e,t)=>(e-o[t]%e)%e),i=s.map((e,t)=>e+a[t]),l=t.map((e,t)=>[r[t],i[t]]),u=t.map((e,t)=>[0,a[t]]);return[l,u]}([c.inHeight,c.inWidth],h,d),g=p?r:"valid",b=p?l:Al(l,h,f),y=("avg"===n?()=>va(b,t,a,g):()=>tl(b,t,a,g))(),w=p?y:_a(y,h,m);return u?ka(w,[w.shape[1],w.shape[2],w.shape[3]]):w}});const $l=Or({pow_:function(e,t){let n=Pr(e,"base","pow"),r=Pr(t,"exp","pow");[n,r]=xr(n,r);const s={a:n,b:r};return Nr.runKernel("Pow",s)}});const _l=Or({prelu_:function(e,t){const n={x:Pr(e,"x","prelu"),alpha:Pr(t,"alpha","prelu")};return Nr.runKernel("Prelu",n)}});const Ml=Or({prod_:function(e,t=null,n=!1){let r=Pr(e,"x","prod");"bool"===r.dtype&&(r=Ss(r,"int32"));const s={x:r},o={axis:t,keepDims:n};return Nr.runKernel("Prod",s,o)}});const Nl=Or({rand_:function(e,t,n){const r=u(e);let s=null;if(null==n||"float32"===n)s=new Float32Array(r);else if("int32"===n)s=new Int32Array(r);else{if("bool"!==n)throw new Error("Unknown data type "+n);s=new Uint8Array(r)}for(let e=0;e<r;e++)s[e]=t();return Nr.makeTensor(s,e,n)}});"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self&&self;function Tl(e,t){return e(t={exports:{}},t.exports),t.exports}var Dl=Tl((function(e){!function(e,t,n){function r(e){var t,n=this,r=(t=4022871197,function(e){e=e.toString();for(var n=0;n<e.length;n++){var r=.02519603282416938*(t+=e.charCodeAt(n));r-=t=r>>>0,t=(r*=t)>>>0,t+=4294967296*(r-=t)}return 2.3283064365386963e-10*(t>>>0)});n.next=function(){var e=2091639*n.s0+2.3283064365386963e-10*n.c;return n.s0=n.s1,n.s1=n.s2,n.s2=e-(n.c=0|e)},n.c=1,n.s0=r(" "),n.s1=r(" "),n.s2=r(" "),n.s0-=r(e),n.s0<0&&(n.s0+=1),n.s1-=r(e),n.s1<0&&(n.s1+=1),n.s2-=r(e),n.s2<0&&(n.s2+=1),r=null}function s(e,t){return t.c=e.c,t.s0=e.s0,t.s1=e.s1,t.s2=e.s2,t}function o(e,t){var n=new r(e),o=t&&t.state,a=n.next;return a.int32=function(){return 4294967296*n.next()|0},a.double=function(){return a()+11102230246251565e-32*(2097152*a()|0)},a.quick=a,o&&("object"==typeof o&&s(o,n),a.state=function(){return s(n,{})}),a}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.alea=o}(0,e,!1)})),Rl=Tl((function(e){!function(e,t,n){function r(e){var t=this,n="";t.x=0,t.y=0,t.z=0,t.w=0,t.next=function(){var e=t.x^t.x<<11;return t.x=t.y,t.y=t.z,t.z=t.w,t.w^=t.w>>>19^e^e>>>8},e===(0|e)?t.x=e:n+=e;for(var r=0;r<n.length+64;r++)t.x^=0|n.charCodeAt(r),t.next()}function s(e,t){return t.x=e.x,t.y=e.y,t.z=e.z,t.w=e.w,t}function o(e,t){var n=new r(e),o=t&&t.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},a.int32=n.next,a.quick=a,o&&("object"==typeof o&&s(o,n),a.state=function(){return s(n,{})}),a}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.xor128=o}(0,e,!1)})),Fl=Tl((function(e){!function(e,t,n){function r(e){var t=this,n="";t.next=function(){var e=t.x^t.x>>>2;return t.x=t.y,t.y=t.z,t.z=t.w,t.w=t.v,(t.d=t.d+362437|0)+(t.v=t.v^t.v<<4^e^e<<1)|0},t.x=0,t.y=0,t.z=0,t.w=0,t.v=0,e===(0|e)?t.x=e:n+=e;for(var r=0;r<n.length+64;r++)t.x^=0|n.charCodeAt(r),r==n.length&&(t.d=t.x<<10^t.x>>>4),t.next()}function s(e,t){return t.x=e.x,t.y=e.y,t.z=e.z,t.w=e.w,t.v=e.v,t.d=e.d,t}function o(e,t){var n=new r(e),o=t&&t.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},a.int32=n.next,a.quick=a,o&&("object"==typeof o&&s(o,n),a.state=function(){return s(n,{})}),a}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.xorwow=o}(0,e,!1)})),Cl=Tl((function(e){!function(e,t,n){function r(e){var t=this;t.next=function(){var e,n,r=t.x,s=t.i;return e=r[s],n=(e^=e>>>7)^e<<24,n^=(e=r[s+1&7])^e>>>10,n^=(e=r[s+3&7])^e>>>3,n^=(e=r[s+4&7])^e<<7,e=r[s+7&7],n^=(e^=e<<13)^e<<9,r[s]=n,t.i=s+1&7,n},function(e,t){var n,r=[];if(t===(0|t))r[0]=t;else for(t=""+t,n=0;n<t.length;++n)r[7&n]=r[7&n]<<15^t.charCodeAt(n)+r[n+1&7]<<13;for(;r.length<8;)r.push(0);for(n=0;n<8&&0===r[n];++n);for(8==n?r[7]=-1:r[n],e.x=r,e.i=0,n=256;n>0;--n)e.next()}(t,e)}function s(e,t){return t.x=e.x.slice(),t.i=e.i,t}function o(e,t){null==e&&(e=+new Date);var n=new r(e),o=t&&t.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},a.int32=n.next,a.quick=a,o&&(o.x&&s(o,n),a.state=function(){return s(n,{})}),a}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.xorshift7=o}(0,e,!1)})),Bl=Tl((function(e){!function(e,t,n){function r(e){var t=this;t.next=function(){var e,n,r=t.w,s=t.X,o=t.i;return t.w=r=r+1640531527|0,n=s[o+34&127],e=s[o=o+1&127],n^=n<<13,e^=e<<17,n^=n>>>15,e^=e>>>12,n=s[o]=n^e,t.i=o,n+(r^r>>>16)|0},function(e,t){var n,r,s,o,a,i=[],l=128;for(t===(0|t)?(r=t,t=null):(t+="\0",r=0,l=Math.max(l,t.length)),s=0,o=-32;o<l;++o)t&&(r^=t.charCodeAt((o+32)%t.length)),0===o&&(a=r),r^=r<<10,r^=r>>>15,r^=r<<4,r^=r>>>13,o>=0&&(a=a+1640531527|0,s=0==(n=i[127&o]^=r+a)?s+1:0);for(s>=128&&(i[127&(t&&t.length||0)]=-1),s=127,o=512;o>0;--o)r=i[s+34&127],n=i[s=s+1&127],r^=r<<13,n^=n<<17,r^=r>>>15,n^=n>>>12,i[s]=r^n;e.w=a,e.X=i,e.i=s}(t,e)}function s(e,t){return t.i=e.i,t.w=e.w,t.X=e.X.slice(),t}function o(e,t){null==e&&(e=+new Date);var n=new r(e),o=t&&t.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},a.int32=n.next,a.quick=a,o&&(o.X&&s(o,n),a.state=function(){return s(n,{})}),a}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.xor4096=o}(0,e,!1)})),Pl=Tl((function(e){!function(e,t,n){function r(e){var t=this,n="";t.next=function(){var e=t.b,n=t.c,r=t.d,s=t.a;return e=e<<25^e>>>7^n,n=n-r|0,r=r<<24^r>>>8^s,s=s-e|0,t.b=e=e<<20^e>>>12^n,t.c=n=n-r|0,t.d=r<<16^n>>>16^s,t.a=s-e|0},t.a=0,t.b=0,t.c=-1640531527,t.d=1367130551,e===Math.floor(e)?(t.a=e/4294967296|0,t.b=0|e):n+=e;for(var r=0;r<n.length+20;r++)t.b^=0|n.charCodeAt(r),t.next()}function s(e,t){return t.a=e.a,t.b=e.b,t.c=e.c,t.d=e.d,t}function o(e,t){var n=new r(e),o=t&&t.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},a.int32=n.next,a.quick=a,o&&("object"==typeof o&&s(o,n),a.state=function(){return s(n,{})}),a}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.tychei=o}(0,e,!1)})),zl=Tl((function(e){!function(t,n){var r,s=this,o=n.pow(256,6),a=n.pow(2,52),i=2*a;function l(e,l,p){var f=[],m=h(function e(t,n){var r,s=[],o=typeof t;if(n&&"object"==o)for(r in t)try{s.push(e(t[r],n-1))}catch(e){}return s.length?s:"string"==o?t:t+"\0"}((l=1==l?{entropy:!0}:l||{}).entropy?[e,d(t)]:null==e?function(){try{var e;return r&&(e=r.randomBytes)?e=e(256):(e=new Uint8Array(256),(s.crypto||s.msCrypto).getRandomValues(e)),d(e)}catch(e){var n=s.navigator,o=n&&n.plugins;return[+new Date,s,o,s.screen,d(t)]}}():e,3),f),g=new u(f),b=function(){for(var e=g.g(6),t=o,n=0;e<a;)e=256*(e+n),t*=256,n=g.g(1);for(;e>=i;)e/=2,t/=2,n>>>=1;return(e+n)/t};return b.int32=function(){return 0|g.g(4)},b.quick=function(){return g.g(4)/4294967296},b.double=b,h(d(g.S),t),(l.pass||p||function(e,t,r,s){return s&&(s.S&&c(s,g),e.state=function(){return c(g,{})}),r?(n.random=e,t):e})(b,m,"global"in l?l.global:this==n,l.state)}function u(e){var t,n=e.length,r=this,s=0,o=r.i=r.j=0,a=r.S=[];for(n||(e=[n++]);s<256;)a[s]=s++;for(s=0;s<256;s++)a[s]=a[o=255&o+e[s%n]+(t=a[s])],a[o]=t;(r.g=function(e){for(var t,n=0,s=r.i,o=r.j,a=r.S;e--;)t=a[s=255&s+1],n=256*n+a[255&(a[s]=a[o=255&o+t])+(a[o]=t)];return r.i=s,r.j=o,n})(256)}function c(e,t){return t.i=e.i,t.j=e.j,t.S=e.S.slice(),t}function h(e,t){for(var n,r=e+"",s=0;s<r.length;)t[255&s]=255&(n^=19*t[255&s])+r.charCodeAt(s++);return d(t)}function d(e){return String.fromCharCode.apply(0,e)}if(n.seedrandom=l,h(n.random(),t),e.exports){e.exports=l;try{r=require("crypto")}catch(e){}}}([],Math)}));zl.alea=Dl,zl.xor128=Rl,zl.xorwow=Fl,zl.xorshift7=Cl,zl.xor4096=Bl,zl.tychei=Pl;var Ll=zl.alea;class Ol{constructor(e,t,n,r,s){this.mean=e,this.stdDev=t,this.dtype=n,this.nextVal=NaN,this.truncated=r,this.truncated&&(this.upper=this.mean+2*this.stdDev,this.lower=this.mean-2*this.stdDev);const o=s||Math.random();this.random=Ll(o.toString())}nextValue(){if(!isNaN(this.nextVal)){const e=this.nextVal;return this.nextVal=NaN,e}let e,t,n=!1;for(;!n;){let r,s,o;do{r=2*this.random()-1,s=2*this.random()-1,o=r*r+s*s}while(o>=1||0===o);const a=Math.sqrt(-2*Math.log(o)/o);e=this.mean+this.stdDev*r*a,t=this.mean+this.stdDev*s*a,this.truncated&&!this.isValidTruncated(e)||(n=!0)}return this.truncated&&!this.isValidTruncated(t)||(this.nextVal=this.convertValue(t)),this.convertValue(e)}convertValue(e){return null==this.dtype||"float32"===this.dtype?e:Math.round(e)}isValidTruncated(e){return e<=this.upper&&e>=this.lower}}class Kl{constructor(e,t,n,r){this.alpha=e,this.beta=1/t,this.dtype=n;const s=r||Math.random();this.randu=Ll(s.toString()),this.randn=new Ol(0,1,n,!1,this.randu()),this.d=e<1?e+2/3:e-1/3,this.c=1/Math.sqrt(9*this.d)}nextValue(){let e,t,n,r,s,o;for(;;){do{r=this.randn.nextValue(),o=1+this.c*r}while(o<=0);if(o*=o*o,e=r*r,t=1-.331*e*e,n=.5*e+this.d*(1-o+Math.log(o)),s=this.randu(),s<t||Math.log(s)<n)break}return o=1/this.beta*this.d*o,this.alpha<1&&(o*=Math.pow(this.randu(),1/this.alpha)),this.convertValue(o)}convertValue(e){return"float32"===this.dtype?e:Math.round(e)}}class Wl{constructor(e=0,t=1,n,r){if(this.canReturnFloat=()=>null==this.dtype||"float32"===this.dtype,this.min=e,this.range=t-e,this.dtype=n,null==r&&(r=Math.random()),"number"==typeof r&&(r=r.toString()),!this.canReturnFloat()&&this.range<=1)throw new Error(`The difference between ${e} - ${t} <= 1 and dtype is not float`);this.random=Ll(r)}convertValue(e){return this.canReturnFloat()?e:Math.round(e)}nextValue(){return this.convertValue(this.min+this.range*this.random())}}const Ul=Or({randomGamma_:function(e,t,n=1,r="float32",s){if(null==n&&(n=1),null==r&&(r="float32"),"float32"!==r&&"int32"!==r)throw new Error("Unsupported data type "+r);const o=new Kl(t,n,r,s),a=Es(e,r);for(let e=0;e<a.values.length;e++)a.values[e]=o.nextValue();return a.toTensor()}});const ql=Or({randomNormal_:function(e,t=0,n=1,r,s){if(null!=r&&"bool"===r)throw new Error("Unsupported data type "+r);const o=new Ol(t,n,r,!1,s),a=Es(e,r);for(let e=0;e<a.values.length;e++)a.values[e]=o.nextValue();return a.toTensor()}});const Gl=Or({randomUniform_:function(e,t=0,n=1,r="float32",s){const o=Es(e,r),a=new Wl(t,n,null,s);for(let e=0;e<o.values.length;e++)o.values[e]=a.nextValue();return o.toTensor()}});function Hl(e,t,n=1,r="float32"){if(0===n)throw new Error("Cannot have a step of zero");const s={start:e,stop:t,step:n,dtype:r};return Nr.runKernel("Range",{},s)}const Vl=Or({real_:function(e){const t={input:Pr(e,"input","real")};return Nr.runKernel("Real",t)}});const jl=Or({reciprocal_:function(e){const t={x:Pr(e,"x","reciprocal")};return Nr.runKernel("Reciprocal",t)}});const Jl=Or({relu_:function(e){const t={x:Pr(e,"x","relu")};return Nr.runKernel("Relu",t)}});const Yl=Or({relu6_:function(e){const t={x:Pr(e,"x","relu6")};return Nr.runKernel("Relu6",t)}});const Zl=Or({reverse_:function(e,t){const n={x:Pr(e,"x","reverse")},r={dims:t};return Nr.runKernel("Reverse",n,r)}});const Xl=Or({reverse1d_:function(e){const t=Pr(e,"x","reverse");return o(1===t.rank,()=>`Error in reverse1D: x must be rank 1 but got rank ${t.rank}.`),Zl(t,0)}});const Ql=Or({reverse2d_:function(e,t){const n=Pr(e,"x","reverse");return o(2===n.rank,()=>`Error in reverse2D: x must be rank 2 but got rank ${n.rank}.`),Zl(n,t)}});const eu=Or({reverse3d_:function(e,t){const n=Pr(e,"x","reverse");return o(3===n.rank,()=>`Error in reverse3D: x must be rank 3 but got rank ${n.rank}.`),Zl(n,t)}});const tu=Or({reverse4d_:function(e,t){const n=Pr(e,"x","reverse");return o(4===n.rank,()=>`Error in reverse4D: x must be rank 4 but got rank ${n.rank}.`),Zl(n,t)}});const nu=Or({round_:function(e){const t={x:Pr(e,"x","round")};return Nr.runKernel("Round",t)}});const ru=Or({rsqrt_:function(e){const t={x:Pr(e,"x","rsqrt")};return Nr.runKernel("Rsqrt",t)}});function su(e,t){if((w(e)&&"string"!==t||Array.isArray(e))&&"complex64"!==t)throw new Error("Error creating a new Scalar: value must be a primitive (number|boolean|string)");if("string"===t&&w(e)&&!(e instanceof Uint8Array))throw new Error("When making a scalar from encoded string, the value must be `Uint8Array`.");return Wr(e,[],[],t)}const ou=Or({selu_:function(e){const t={x:Pr(e,"x","selu")};return Nr.runKernel("Selu",t)}});const au=Or({separableConv2d_:function(e,t,n,r,s,a=[1,1],i="NHWC"){const l=Pr(e,"x","separableConv2d"),u=Pr(t,"depthwiseFilter","separableConv2d"),c=Pr(n,"pointwiseFilter","separableConv2d");let h=l,d=!1;if(3===l.rank&&(d=!0,h=ka(l,[1,l.shape[0],l.shape[1],l.shape[2]])),"NCHW"===i)throw new Error("separableConv2d currently does not support dataFormat NCHW; only NHWC is supported");o(4===h.rank,()=>`Error in separableConv2d: input must be rank 4, but got rank ${h.rank}.`),o(4===u.rank,()=>`Error in separableConv2d: depthwise filter must be rank 4, but got rank ${u.rank}.`),o(4===c.rank,()=>`Error in separableConv2d: pointwise filter must be rank 4, but got rank ${u.rank}.`),o(1===c.shape[0],()=>`Error in separableConv2d: the first dimension of pointwise filter  must be 1, but got ${c.shape[0]}.`),o(1===c.shape[1],()=>`Error in separableConv2d: the second dimension of pointwise filter must be 1, but got ${c.shape[1]}.`);const p=u.shape[2],f=u.shape[3];o(c.shape[2]===p*f,()=>`Error in separableConv2d: the third dimension of pointwise filter must be ${p*f}, but got ${c.shape[2]}.`);const m=Qa(h,u,r,s,i,a),g=Ka(m,c,1,"valid",i);return d?ka(g,[g.shape[1],g.shape[2],g.shape[3]]):g}});const iu=async function(e,t){const n=Pr(e,"x","setdiff1d"),r=Pr(t,"y","setdiff1d");o(n.dtype===r.dtype,()=>`x and y should have the same dtype, but got x (${n.dtype}) and y (${r.dtype}).`),o(1===n.rank,()=>`x should be 1D tensor, but got x (${n.shape}).`),o(1===r.rank,()=>`y should be 1D tensor, but got y (${r.shape}).`);const s=await n.data(),a=await r.data(),i=new Set(a);let l=0;for(let e=0;e<s.length;e++)i.has(s[e])||l++;const u=new ur([l],n.dtype),c=new ur([l],"int32");for(let e=0,t=0;e<s.length;e++)i.has(s[e])||(u.values[t]=s[e],c.values[t]=e,t++);return[u.toTensor(),c.toTensor()]};const lu=Or({sign_:function(e){const t={x:Pr(e,"x","sign")};return Nr.runKernel("Sign",t)}});const uu=Or({sin_:function(e){const t={x:Pr(e,"x","sin")};return Nr.runKernel("Sin",t)}});const cu=Or({sinh_:function(e){const t={x:Pr(e,"x","sinh")};return Nr.runKernel("Sinh",t)}});const hu=Or({slice1d_:function(e,t,n){const r=Pr(e,"x","slice1d");return o(1===r.rank,()=>`slice1d expects a rank-1 tensor, but got a rank-${r.rank} tensor`),Aa(r,[t],[n])}});const du=Or({slice2d_:function(e,t,n){const r=Pr(e,"x","slice2d");return o(2===r.rank,()=>`slice2d expects a rank-2 tensor, but got a rank-${r.rank} tensor`),Aa(r,t,n)}});const pu=Or({slice3d_:function(e,t,n){const r=Pr(e,"x","slice3d");return o(3===r.rank,()=>`slice3d expects a rank-3 tensor, but got a rank-${r.rank} tensor`),Aa(r,t,n)}});const fu=Or({slice4d_:function(e,t,n){const r=Pr(e,"x","slice4d");return o(4===r.rank,()=>`slice4d expects a rank-4 tensor, but got a rank-${r.rank} tensor`),Aa(r,t,n)}});const mu=Or({softmax_:function(e,t=-1){const n=Pr(e,"logits","softmax","float32");if(-1===t&&(t=n.rank-1),t!==n.rank-1)throw Error(`Softmax along a non-last dimension is not yet supported. Logits was rank ${n.rank} and dim was ${t}`);const r={logits:n},s={dim:t};return Nr.runKernel("Softmax",r,s)}});const gu=Or({fft_:function(e){o("complex64"===e.dtype,()=>`The dtype for tf.spectral.fft() must be complex64 but got ${e.dtype}.`);const t={input:e};return Nr.runKernel("FFT",t)}});const bu=Or({ifft_:function(e){o("complex64"===e.dtype,()=>`The dtype for tf.spectral.ifft() must be complex64 but got ${e.dtype}.`);const t={input:e};return Nr.runKernel("IFFT",t)}});const yu=Or({irfft_:function(e){const t=e.shape[e.shape.length-1],n=e.size/t;let r;if(t<=2){const s=ka(e,[n,t]);r=bu(s)}else{const s=[n,2*(t-1)],o=ka(Vl(e),[n,t]),a=ka(xi(e),[n,t]),i=Zl(Aa(o,[0,1],[n,t-2]),1),l=Jo(Zl(Aa(a,[0,1],[n,t-2]),1),su(-1)),u=Ea([o,i],1),c=Ea([a,l],1),h=ka(Kr(u,c),[s[0],s[1]]);r=bu(h)}if(r=Vl(r),3===e.rank&&0!==e.shape[0]){const t=r,n=e.shape[0];r=ka(r,[n,r.shape[0]/n,r.shape[1]]),t.dispose()}return r}});const wu=Or({split_:function(e,t,n=0){const r={x:Pr(e,"x","split")},s={numOrSizeSplits:t,axis:n};return Nr.runKernel("SplitV",r,s)}});const ku=Or({rfft_:function(e,t){o("float32"===e.dtype,()=>"The dtype for rfft() must be real value but got "+e.dtype);let n=e.shape[e.shape.length-1];const r=e.size/n;let s;if(null!=t&&t<n){const r=e.shape.map(e=>0),o=e.shape.map(e=>e);o[e.shape.length-1]=t,s=Aa(e,r,o),n=t}else if(null!=t&&t>n){const r=e.shape.map(e=>e);r[e.shape.length-1]=t-n,s=Ea([e,al(r)],e.shape.length-1),n=t}else s=e;const a=ai(s),i=ka(Kr(s,a),[r,n]),l=gu(i),u=Math.floor(n/2)+1,c=Vl(l),h=xi(l),d=wu(c,[u,n-u],c.shape.length-1),p=wu(h,[u,n-u],h.shape.length-1),f=s.shape.slice();return f[s.shape.length-1]=u,ka(Kr(d[0],p[0]),f)}});const vu=Or({sqrt_:function(e){const t={x:Pr(e,"x","sqrt")};return Nr.runKernel("Sqrt",t)}});const xu=Or({squaredDifference_:function(e,t){let n=Pr(e,"a","squaredDifference"),r=Pr(t,"b","squaredDifference");[n,r]=xr(n,r),ri(n.shape,r.shape);const s={a:n,b:r};return Nr.runKernel("SquaredDifference",s,{})}});const Eu=Or({squeeze_:function(e,t){const n=Pr(e,"x","squeeze");return ka(n,f(n.shape,t).newShape)}});const Su=Or({stack_:function(e,t=0){const n=zr(e,"tensors","stack","string_or_numeric");o(n.length>=1,()=>"Pass at least one tensor to tf.stack"),n.length>0&&o(t<=n[0].rank,()=>"Axis must be <= rank of the tensor");const r=n,s={axis:t};return Nr.runKernel("Pack",r,s)}});const Au=Or({step_:function(e,t=0){const n={x:Pr(e,"x","step")},r={alpha:t};return Nr.runKernel("Step",n,r)}});const Iu=Or({stridedSlice_:function(e,t,n,r,s=0,o=0,a=0,i=0,l=0){const u={x:Pr(e,"x","stridedSlice")},c={begin:t,end:n,strides:r,beginMask:s,endMask:o,ellipsisMask:a,newAxisMask:i,shrinkAxisMask:l};return Nr.runKernel("StridedSlice",u,c)}});const $u=Or({tan_:function(e){const t={x:Pr(e,"x","tan")};return Nr.runKernel("Tan",t)}});function _u(e,t){i(e);const n=Cr(e,t);if(1!==n.length)throw new Error("tensor1d() requires values to be a flat/TypedArray");return Wr(e,null,n,t)}function Mu(e,t,n){if(i(e),null!=t&&2!==t.length)throw new Error("tensor2d() requires shape to have two numbers");const r=Cr(e,n);if(2!==r.length&&1!==r.length)throw new Error("tensor2d() requires values to be number[][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor2d() requires shape to be provided when `values` are a flat/TypedArray");return Wr(e,t,r,n)}function Nu(e,t,n){if(i(e),null!=t&&4!==t.length)throw new Error("tensor4d() requires shape to have four numbers");const r=Cr(e,n);if(4!==r.length&&1!==r.length)throw new Error("tensor4d() requires values to be number[][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor4d() requires shape to be provided when `values` are a flat array");return Wr(e,t,r,n)}function Tu(e,t,n){if(i(e),null!=t&&5!==t.length)throw new Error("tensor5d() requires shape to have five numbers");const r=Cr(e,n);if(5!==r.length&&1!==r.length)throw new Error("tensor5d() requires values to be number[][][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor5d() requires shape to be provided when `values` are a flat array");return Wr(e,t,r,n)}function Du(e,t,n){if(i(e),null!=t&&6!==t.length)throw new Error("tensor6d() requires shape to have six numbers");const r=Cr(e,n);if(6!==r.length&&1!==r.length)throw new Error("tensor6d() requires values to be number[][][][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor6d() requires shape to be provided when `values` are a flat array");return Wr(e,t=t||r,r,n)}const Ru=Or({topk_:function(e,t=1,n=!0){const r=Pr(e,"x","topk");if(0===r.rank)throw new Error("topk() expects the input to be of rank 1 or higher");const s=r.shape[r.shape.length-1];if(t>s)throw new Error(`'k' passed to topk() must be <= the last dimension (${s}) but got `+t);const o={x:r},a={k:t,sorted:n},[i,l]=Nr.runKernel("TopK",o,a);return{values:i,indices:l}}});const Fu=Or({truncatedNormal_:function(e,t=0,n=1,r,s){if(null!=r&&"bool"===r)throw new Error("Unsupported data type $ { dtype }");const o=new Ol(t,n,r,!0,s),a=Es(e,r);for(let e=0;e<a.values.length;e++)a.values[e]=o.nextValue();return a.toTensor()}});const Cu=Or({unique_:function(e,t=0){const n=Pr(e,"x","unique","string_or_numeric");o(n.rank>0,()=>"The input tensor must be at least 1D");const r={x:n},s={axis:t},[a,i]=Nr.runKernel("Unique",r,s);return{values:a,indices:i}}});const Bu=Or({unsortedSegmentSum_:function(e,t,n){const r=Pr(e,"x","unsortedSegmentSum"),s=Pr(t,"segmentIds","unsortedSegmentSum","int32");o(h(n),()=>"numSegments must be of dtype int");const a={x:r,segmentIds:s},i={numSegments:n};return Nr.runKernel("UnsortedSegmentSum",a,i)}});const Pu=Or({unstack_:function(e,t=0){const n=Pr(e,"x","unstack","string_or_numeric");o(t>=-n.shape.length&&t<n.shape.length,()=>`Axis = ${t} is not in [-${n.shape.length}, ${n.shape.length})`);const r={value:n},s={axis:t};return Nr.runKernel("Unpack",r,s)}});function zu(e,t=!0,n,r){return Nr.makeVariable(e,t,n,r)}function Lu(e,t){const n=[];for(let e=0;e<t.length;e++)t[e]&&n.push(e);const r=Es(e,"int32"),s=Es([n.length,e.length],"int32");for(let t=0;t<n.length;t++){const o=r.indexToLoc(n[t]),a=t*e.length;s.values.set(o,a)}return s.toTensor()}const Ou=async function(e){const t=Pr(e,"condition","whereAsync","bool"),n=await t.data(),r=Lu(t.shape,n);return e!==t&&t.dispose(),r};const Ku=async function(e,t,n){const r=Pr(e,"tensor","boolMask"),s=Pr(t,"mask","boolMask","bool"),i=null==n?0:n,l=s.rank,u=r.shape;o(l>0,()=>"mask cannot be scalar"),a(u.slice(i,i+l),s.shape,"mask's shape must match the first K dimensions of tensor's shape,");let c=1;for(let e=i;e<i+l;e++)c*=u[e];const h=u.slice(0,i).concat([c],u.slice(i+l)),d=ka(r,h),p=ka(s,[-1]),f=await Ou(p),m=Eu(f,[1]),g=wi(d,m,i);return e!==r&&r.dispose(),t!==s&&s.dispose(),m.dispose(),d.dispose(),p.dispose(),f.dispose(),g};const Wu=Or({norm_:function(e,t="euclidean",n=null,r=!1){const s=function e(t,n,r=null){if(0===t.rank)return Yo(t);if(1!==t.rank&&null===r)return e(ka(t,[-1]),n,r);if(1===t.rank||"number"==typeof r||Array.isArray(r)&&1===r.length){if(1===n)return Gi(Yo(t),r);if(n===1/0)return Ui(Yo(t),r);if(n===-1/0)return ul(Yo(t),r);if("euclidean"===n||2===n)return vu(Gi($l(Yo(t),su(2,"int32")),r));throw new Error("Error in norm: invalid ord value: "+n)}if(Array.isArray(r)&&2===r.length){if(1===n)return Ui(Gi(Yo(t),r[0]),r[1]-1);if(n===1/0)return Ui(Gi(Yo(t),r[1]),r[0]);if(n===-1/0)return ul(Gi(Yo(t),r[1]),r[0]);if("fro"===n||"euclidean"===n)return vu(Gi(pl(t),r));throw new Error("Error in norm: invalid ord value: "+n)}throw new Error("Error in norm: invalid axis: "+r)}(e=Pr(e,"x","norm"),t,n);let o=s.shape;if(r){const t=p(n,e.shape);o=Ji(s.shape,t)}return ka(s,o)}});const Uu=Or({movingAverage_:function(e,t,n,r,s=!0){const a=Pr(e,"v","movingAverage"),i=Pr(t,"x","movingAverage"),l=Pr(n,"decay","movingAverage");Er(a,i),o(c(a.shape,i.shape),()=>"Shape mismatch in v and x");const u=su(1),h=qi(u,l);let d=Jo(qi(i,a),h);if(s){o(null!=r,()=>"When using zeroDebias: true, step is required.");const e=Pr(r,"step","movingAverage");d=jo(d,qi(u,$l(l,e)))}return Ho(a,d)}});const qu=Or({scatterND_:function(e,t,n){const r=Pr(e,"indices","scatterND","int32"),s=Pr(t,"updates","scatterND");eo(s,r,n);const o={indices:r,updates:s},a={shape:n};return Nr.runKernel("ScatterNd",o,a)}});const Gu=Or({sparseToDense_:function(e,t,n,r=0){const s=Pr(e,"sparseIndices","sparseToDense","int32"),o=Pr(t,"sparseValues","sparseToDense"),a=Pr(r,"defaultValue","sparseToDense",o.dtype);!function(e,t,n,r){if("int32"!==e.dtype)throw new Error(`tf.sparseToDense() expects the indices to be int32 type, but the dtype was ${e.dtype}.`);if(e.rank>2)throw new Error(`sparseIndices should be a scalar, vector, or matrix, but got shape ${e.shape}.`);const s=e.rank>0?e.shape[0]:1,o=e.rank>1?e.shape[1]:1;if(n.length!==o)throw new Error(`outputShape has incorrect number of elements:, ${n.length}, should be: ${o}.`);const a=t.size;if(0!==t.rank&&(1!==t.rank||a!==s))throw new Error(`sparseValues has incorrect shape ${t.shape}, should be [] or [${s}]`);if(t.dtype!==r.dtype)throw new Error("sparseValues.dtype must match defaultValues.dtype")}(s,o,n,a);const i={sparseIndices:s,sparseValues:o,defaultValue:a},l={outputShape:n};return Nr.runKernel("SparseToDense",i,l)}});const Hu=Or({gatherND_:function(e,t){const n=Pr(t,"indices","gatherND","int32"),r={params:Pr(e,"x","gatherND"),indices:n};return Nr.runKernel("GatherNd",r)}});const Vu=Or({dropout_:function(e,t,n,r){const s=Pr(e,"x","dropout");if(o("float32"===s.dtype,()=>`x has to be a floating point tensor since it's going to be scaled, but got a ${s.dtype} tensor instead.`),o(t>=0&&t<1,()=>`rate must be a float in the range [0, 1), but got ${t}.`),0===t)return e instanceof dr?s.clone():s;const a=function(e,t){if(null==t)return e.shape.slice();if(c(e.shape,t))return t;if(e.shape.length===t.length){const n=[];for(let r=0;r<e.shape.length;r++)null==t[r]&&null!=e.shape[r]?n.push(e.shape[r]):n.push(t[r]);return n}return t}(s,n),i=1-t,l=jo(yi(Ho(Gl(a,0,1,"float32",r),i)),i);return Jo(s,l)}});function ju(e){return Math.floor(Math.pow(2,Math.ceil(Math.log(e)/Math.log(2))))}function Ju(e,t,n){const r=1-e%2,s=new Float32Array(e);for(let o=0;o<e;++o){const a=2*Math.PI*o/(e+r-1);s[o]=t-n*Math.cos(a)}return _u(s,"float32")}const Yu=async function(e,t,n=1){const r=Pr(e,"predictions","inTopK"),s=Pr(t,"targets","inTopK");o(r.rank>1,()=>"inTopK() expects the predictions to be of rank 2 or higher, but got "+r.rank),o(r.rank-1===s.rank,()=>`predictions rank should be 1 larger than targets rank, but got predictions rank ${r.rank} and targets rank ${s.rank}`),a(r.shape.slice(0,r.shape.length-1),s.shape,"predictions's shape should be align with the targets' shape, except the last dimension.");const i=r.shape[r.shape.length-1];o(n>0&&n<=i,()=>`'k' passed to inTopK() must be > 0 && <= the predictions last dimension (${i}), but got ${n}`);const l=await r.data(),u=await s.data(),[c,h]=[l.length/i,i],d=m("bool",c);for(let e=0;e<c;e++){const t=e*h,r=l.subarray(t,t+h),s=[];for(let e=0;e<r.length;e++)s.push({value:r[e],index:e});s.sort((e,t)=>t.value-e.value),d[e]=0;for(let t=0;t<n;t++)if(s[t].index===u[e]){d[e]=1;break}}return e!==r&&r.dispose(),t!==s&&s.dispose(),Ur(d,s.shape,"bool")};const Zu=Or({conv2DBackpropFilter_:function(e,t,n,r,s,a="NHWC",i){let l=e;3===e.rank&&(l=ka(e,[1,e.shape[0],e.shape[1],e.shape[2]]));let u=t;3===u.rank&&(u=ka(t,[1,t.shape[0],t.shape[1],t.shape[2]])),o(4===l.rank,()=>"Error in conv2dDerFilter: input must be rank 4, but got shape "+l.shape+"."),o(4===u.rank,()=>"Error in conv2dDerFilter: dy must be rank 4, but got shape "+u.shape+"."),o(4===n.length,()=>"Error in conv2dDerFilter: filterShape must be length 4, but got "+n+".");const c="NHWC"===a?l.shape[3]:l.shape[1],d="NHWC"===a?u.shape[3]:u.shape[1];o(c===n[2],()=>`Error in conv2dDerFilter: depth of input ${c}) must match input depth in filter (${n[2]}.`),o(d===n[3],()=>`Error in conv2dDerFilter: depth of dy (${d}) must match output depth for filter (${n[3]}).`),null!=i&&o(h(s),()=>`Error in conv2dDerFilter: pad must be an integer when using, dimRoundingMode ${i} but got pad ${s}.`);const p={x:l,dy:u},f={strides:r,pad:s,dataFormat:a,dimRoundingMode:i,filterShape:n};return Nr.runKernel("Conv2DBackpropFilter",p,f)}});function Xu(e,t,n){if(null==n||"linear"===n)return e;if("relu"===n)return Jo(e,Au(t));throw new Error(`Cannot compute gradient for fused activation ${n}.`)}function Qu(e,t){let n=t;const r=ni(e.shape,t.shape);return r.length>0&&(n=Gi(n,r)),ka(n,e.shape)}function ec(e,t,n,r){if("linear"===t)return e;if("relu"===t)return Jl(e);if("elu"===t)return ci(e);if("relu6"===t)return Yl(e);if("prelu"===t)return _l(e,n);if("leakyrelu"===t)return Ii(e,r);if("sigmoid"===t)return Sa(e);throw new Error(`Unknown fused activation ${t}.`)}const tc=(e,t)=>!(e>0)||"linear"===t;const nc=Or({fusedConv2d_:function({x:e,filter:t,strides:n,pad:r,dataFormat:s="NHWC",dilations:a=[1,1],dimRoundingMode:i,bias:l,activation:u="linear",preluActivationWeights:c,leakyreluAlpha:d}){if(u=u||"linear",!1===tc(Nr.state.gradientDepth,u)){let o=Ka(e,t,n,r,s,a,i);return null!=l&&(o=Ho(o,l)),ec(o,u,c,d)}const p=Pr(e,"x","conv2d"),f=Pr(t,"filter","conv2d");let m=p,g=!1;3===p.rank&&(g=!0,m=ka(p,[1,p.shape[0],p.shape[1],p.shape[2]])),o(4===m.rank,()=>"Error in fused conv2d: input must be rank 4, but got rank "+m.rank+"."),o(4===f.rank,()=>"Error in fused conv2d: filter must be rank 4, but got rank "+f.rank+"."),null!=i&&o(h(r),()=>`Error in fused conv2d: pad must be an integer when using, dimRoundingMode ${i} but got pad ${r}.`),o(m.shape[3]===f.shape[2],()=>`Error in conv2d: depth of input (${m.shape[3]}) must match input depth for filter ${f.shape[2]}.`),o(ya(n,a),()=>`Error in conv2D: Either strides or dilations must be 1. Got strides ${n} and dilations '${a}'`),o("NHWC"===s,()=>`Error in conv2d: got dataFormat of ${s} but only NHWC is currently supported.`);const b=ca(m.shape,f.shape,n,a,r,i);let y,w;null!=l&&(y=Pr(l,"bias","fused conv2d"),[y]=xr(y,p),ri(b.outShape,y.shape)),null!=c&&(w=Pr(c,"prelu weights","fused conv2d"));const k=(e,t)=>{const[s,i,l,c]=t,h=Xu(e,l,u);o(ba(a),()=>`Error in gradient of fused conv2D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '${a}'`);const d=[Ua(i.shape,h,s,n,r),Zu(i,h,s.shape,n,r)];if(null!=c){const e=Qu(c,h);d.push(e)}return d},v={x:m,filter:f,bias:y,preluActivationWeights:w},x={strides:n,pad:r,dataFormat:s,dilations:a,dimRoundingMode:i,activation:u,leakyreluAlpha:d};if(null==l){return zi((e,t,n)=>{let r=Nr.runKernel("FusedConv2D",v,x);return n([t,e,r]),g&&(r=ka(r,[r.shape[1],r.shape[2],r.shape[3]])),{value:r,gradFunc:k}})(m,f)}return zi((e,t,n,r)=>{let s=Nr.runKernel("FusedConv2D",v,x);return r([t,e,s,n]),g&&(s=ka(s,[s.shape[1],s.shape[2],s.shape[3]])),{value:s,gradFunc:k}})(m,f,y)}});const rc=Or({depthwiseConv2dNativeBackpropFilter_:function(e,t,n,r,s,o=[1,1],a){let i=e;3===e.rank&&(i=ka(e,[1,e.shape[0],e.shape[1],e.shape[2]]));let l=t;3===l.rank&&(l=ka(t,[1,t.shape[0],t.shape[1],t.shape[2]]));const u={x:i,dy:l},c={strides:r,pad:s,dimRoundingMode:a,dilations:o,filterShape:n};return Nr.runKernel("DepthwiseConv2dNativeBackpropFilter",u,c)}});const sc=Or({depthwiseConv2dNativeBackpropInput_:function(e,t,n,r,s,o=[1,1],a){let i=t,l=!1;3===t.rank&&(l=!0,i=ka(t,[1,t.shape[0],t.shape[1],t.shape[2]]));const u={dy:i,filter:n},c={strides:r,pad:s,dimRoundingMode:a,dilations:o,inputShape:e},h=Nr.runKernel("DepthwiseConv2dNativeBackpropInput",u,c);return l?ka(h,[h.shape[1],h.shape[2],h.shape[3]]):h}});const oc=Or({fusedDepthwiseConv2d_:function({x:e,filter:t,strides:n,pad:r,dataFormat:s="NHWC",dilations:a=[1,1],dimRoundingMode:i,bias:l,activation:u="linear",preluActivationWeights:c,leakyreluAlpha:d}){if(!1===tc(Nr.state.gradientDepth,u)){let o=Qa(e,t,n,r,s,a,i);return null!=l&&(o=Ho(o,l)),ec(o,u,c,d)}const p=Pr(e,"x","depthwiseConv2d"),f=Pr(t,"filter","depthwiseConv2d");let m=p,g=!1;3===p.rank&&(g=!0,m=ka(p,[1,p.shape[0],p.shape[1],p.shape[2]])),o(4===m.rank,()=>`Error in fused depthwiseConv2d: input must be rank 4, but got rank ${m.rank}.`),o(4===f.rank,()=>`Error in fused depthwiseConv2d: filter must be rank 4, but got rank ${f.rank}.`),o(m.shape[3]===f.shape[2],()=>`Error in fused depthwiseConv2d: number of input channels (${m.shape[3]}) must match the inChannels dimension in filter ${f.shape[2]}.`),null==a&&(a=[1,1]),o(ya(n,a),()=>`Error in fused depthwiseConv2d: Either strides or dilations must be 1. Got strides ${n} and dilations '${a}'`),null!=i&&o(h(r),()=>`Error in fused depthwiseConv2d: pad must be an integer when using dimRoundingMode ${i} but got pad ${r}.`);const b=ca(m.shape,f.shape,n,a,r,i,!0);let y,w;null!=l&&(y=Pr(l,"bias","fused conv2d"),[y]=xr(y,p),ri(b.outShape,y.shape)),null!=c&&(w=Pr(c,"prelu weights","fused depthwiseConv2d"));const k=(e,t)=>{o(ba(a),()=>`Error in gradient of fused depthwiseConv2d: dilation rates greater than 1 are not yet supported. Got dilations '${a}'`);const[s,l,c,h]=t,d=Xu(e,c,u),p=sc(l.shape,d,s,n,r,a,i),f=rc(l,d,s.shape,n,r,a,i);if(null!=h){return[p,f,Qu(y,d)]}return[p,f]},v={x:m,filter:f,bias:y,preluActivationWeights:w},x={strides:n,pad:r,dataFormat:s,dilations:a,dimRoundingMode:i,activation:u,leakyreluAlpha:d};if(null==l){return zi((e,t,n)=>{let r=Nr.runKernel("FusedDepthwiseConv2D",v,x);return n([t,e,r]),g&&(r=ka(r,[r.shape[1],r.shape[2],r.shape[3]])),{value:r,gradFunc:k}})(m,f)}return zi((e,t,n,r)=>{let s=Nr.runKernel("FusedDepthwiseConv2D",v,x);return r([t,e,s,n]),g&&(s=ka(s,[s.shape[1],s.shape[2],s.shape[3]])),{value:s,gradFunc:k}})(m,f,y)}});const ac=Or({fusedMatMul_:function({a:e,b:t,transposeA:n=!1,transposeB:r=!1,bias:s,activation:a="linear",preluActivationWeights:i,leakyreluAlpha:l}){if(!1===tc(Nr.state.gradientDepth,a)){let o=Os(e,t,n,r);return null!=s&&(o=Ho(o,s)),ec(o,a,i,l)}let h=Pr(e,"a","fused matMul"),d=Pr(t,"b","fused matMul");[h,d]=xr(h,d);const p=n?h.shape[h.rank-2]:h.shape[h.rank-1],f=r?d.shape[d.rank-1]:d.shape[d.rank-2],m=n?h.shape[h.rank-1]:h.shape[h.rank-2],g=r?d.shape[d.rank-2]:d.shape[d.rank-1],b=h.shape.slice(0,-2),y=d.shape.slice(0,-2),w=u(b),k=u(y);o(h.rank>=2&&d.rank>=2&&h.rank===d.rank,()=>`Error in fused matMul: inputs must have the same rank of at least 2, got ranks ${h.rank} and ${d.rank}.`),o(c(b,y),()=>`Error in fused matMul: outer dimensions (${b}) and (${y}) of Tensors with shapes ${h.shape} and `+d.shape+" must match."),o(p===f,()=>`Error in fused matMul: inner shapes (${p}) and (${f}) of Tensors with shapes ${h.shape} and ${d.shape} and transposeA=${n} and transposeB=${r} must match.`);const v=h.shape.slice(0,-2).concat([m,g]),x=ka(h,n?[w,p,m]:[w,m,p]),E=ka(d,r?[k,g,f]:[k,f,g]);let S,A;null!=s&&(S=Pr(s,"bias","fused matMul"),[S]=xr(S,h),ri(v,S.shape)),null!=i&&(A=Pr(i,"prelu weights","fused matMul"));const I=(e,t)=>{const[o,i,l,u]=t,c=Xu(ka(e,l.shape),l,a);let h,d;if(n||r?!n&&r?(h=Os(c,i,!1,!1),d=Os(c,o,!0,!1)):n&&!r?(h=Os(i,c,!1,!0),d=Os(o,c,!1,!1)):(h=Os(i,c,!0,!0),d=Os(c,o,!0,!0)):(h=Os(c,i,!1,!0),d=Os(o,c,!0,!1)),null!=s){return[h,d,Qu(u,c)]}return[h,d]},$={a:x,b:E,bias:S,preluActivationWeights:A},_={transposeA:n,transposeB:r,activation:a,leakyreluAlpha:l};if(null==s){return zi((e,t,n)=>{const r=Nr.runKernel("_FusedMatMul",$,_);return n([e,t,r]),{value:ka(r,v),gradFunc:I}})(x,E)}return zi((e,t,n,r)=>{const s=Nr.runKernel("_FusedMatMul",$,_);return r([e,t,s,n]),{value:ka(s,v),gradFunc:I}})(x,E,S)}});var ic=Object.freeze({__proto__:null,conv2d:nc,depthwiseConv2d:oc,matMul:ac});const lc=Or({hammingWindow_:function(e){return Ju(e,.54,.46)}});const uc=Or({hannWindow_:function(e){return Ju(e,.5,.5)}});const cc=Or({frame_:function(e,t,n,r=!1,s=0){let o=0;const a=[];for(;o+t<=e.size;)a.push(Aa(e,o,t)),o+=n;if(r)for(;o<e.size;){const r=o+t-e.size,i=Ea([Aa(e,o,t-r),bi([r],s)]);a.push(i),o+=n}return 0===a.length?Mu([],[0,t]):ka(Ea(a),[a.length,t])}});const hc=Or({stft_:function(e,t,n,r,s=uc){null==r&&(r=ju(t));const o=cc(e,t,n),a=Jo(o,s(t));return ku(a,r)}});const dc=Or({cropAndResize_:function(e,t,n,r,s="bilinear",a=0){const i=Pr(e,"image","cropAndResize"),l=Pr(t,"boxes","cropAndResize","float32"),u=Pr(n,"boxInd","cropAndResize","int32"),c=l.shape[0];o(4===i.rank,()=>`Error in cropAndResize: image must be rank 4,but got rank ${i.rank}.`),o(2===l.rank&&4===l.shape[1],()=>`Error in cropAndResize: boxes must be have size [${c},4] but had shape ${l.shape}.`),o(1===u.rank&&u.shape[0]===c,()=>`Error in cropAndResize: boxInd must be have size [${c}] but had shape ${l.shape}.`),o(2===r.length,()=>`Error in cropAndResize: cropSize must be of length 2, but got length ${r.length}.`),o(r[0]>=1&&r[1]>=1,()=>"cropSize must be atleast [1,1], but was "+r),o("bilinear"===s||"nearest"===s,()=>"method must be bilinear or nearest, but was "+s);const h={image:i,boxes:l,boxInd:u},d={method:s,extrapolationValue:a,cropSize:r};return Nr.runKernel("CropAndResize",h,d)}});const pc=Or({flipLeftRight_:function(e){const t=Pr(e,"image","flipLeftRight","float32");o(4===t.rank,()=>`Error in flipLeftRight: image must be rank 4,but got rank ${t.rank}.`);const n={image:t};return Nr.runKernel("FlipLeftRight",n,{})}});const fc=Or({rotateWithOffset_:function(e,t,n=0,r=.5){const s=Pr(e,"image","rotateWithOffset","float32");o(4===s.rank,()=>`Error in rotateWithOffset: image must be rank 4,but got rank ${s.rank}.`);const a={image:s},i={radians:t,fillValue:n,center:r};return Nr.runKernel("RotateWithOffset",a,i)}});function mc(e,t,n,r,s,a){null==r&&(r=.5),null==s&&(s=Number.NEGATIVE_INFINITY),null==a&&(a=0);const i=e.shape[0];return n=Math.min(n,i),o(0<=r&&r<=1,()=>`iouThreshold must be in [0, 1], but was '${r}'`),o(2===e.rank,()=>`boxes must be a 2D tensor, but was of rank '${e.rank}'`),o(4===e.shape[1],()=>"boxes must have 4 columns, but 2nd dimension was "+e.shape[1]),o(1===t.rank,()=>"scores must be a 1D tensor"),o(t.shape[0]===i,()=>`scores has incompatible shape with boxes. Expected ${i}, but was `+t.shape[0]),o(0<=a&&a<=1,()=>`softNmsSigma must be in [0, 1], but was '${a}'`),{maxOutputSize:n,iouThreshold:r,scoreThreshold:s,softNmsSigma:a}}const gc=Or({nonMaxSuppression_:function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY){const o=Pr(e,"boxes","nonMaxSuppression"),a=Pr(t,"scores","nonMaxSuppression"),i=mc(o,a,n,r,s),l={maxOutputSize:n=i.maxOutputSize,iouThreshold:r=i.iouThreshold,scoreThreshold:s=i.scoreThreshold};return Nr.runKernel("NonMaxSuppressionV3",{boxes:o,scores:a},l)}});function bc(e,t,n){const r=function(e,t,n){return function(e,t,n){let r=0,s=e.length,o=0,a=!1;for(;r<s;){o=r+(s-r>>>1);const i=n(t,e[o]);i>0?r=o+1:(s=o,a=!i)}return a?r:-r-1}(e,t,n||yc)}(e,t,n),s=r<0?-(r+1):r;e.splice(s,0,t)}function yc(e,t){return e>t?1:e<t?-1:0}function wc(e,t,n,r,s){return xc(e,t,n,r,s,0)}function kc(e,t,n,r,s,o){return xc(e,t,n,r,s,0,!1,o,!0)}function vc(e,t,n,r,s,o){return xc(e,t,n,r,s,o,!0)}function xc(e,t,n,r,s,o,a=!1,i=!1,l=!1){const u=[];for(let e=0;e<t.length;e++)t[e]>s&&u.push({score:t[e],boxIndex:e,suppressBeginIndex:0});u.sort(Ac);const c=o>0?-.5/o:0,h=[],d=[];for(;h.length<n&&u.length>0;){const t=u.pop(),{score:n,boxIndex:o,suppressBeginIndex:a}=t;if(n<s)break;let i=!1;for(let n=h.length-1;n>=a;--n){const a=Ec(e,o,h[n]);if(a>=r){i=!0;break}if(t.score=t.score*Sc(r,c,a),t.score<=s)break}t.suppressBeginIndex=h.length,i||(t.score===n?(h.push(o),d.push(t.score)):t.score>s&&bc(u,t,Ac))}const p=h.length,f=n-p;i&&f>0&&(h.push(...new Array(f).fill(0)),d.push(...new Array(f).fill(0)));const m={selectedIndices:h};return a&&(m.selectedScores=d),l&&(m.validOutputs=p),m}function Ec(e,t,n){const r=e.subarray(4*t,4*t+4),s=e.subarray(4*n,4*n+4),o=Math.min(r[0],r[2]),a=Math.min(r[1],r[3]),i=Math.max(r[0],r[2]),l=Math.max(r[1],r[3]),u=Math.min(s[0],s[2]),c=Math.min(s[1],s[3]),h=Math.max(s[0],s[2]),d=Math.max(s[1],s[3]),p=(i-o)*(l-a),f=(h-u)*(d-c);if(p<=0||f<=0)return 0;const m=Math.max(o,u),g=Math.max(a,c),b=Math.min(i,h),y=Math.min(l,d),w=Math.max(b-m,0)*Math.max(y-g,0);return w/(p+f-w)}function Sc(e,t,n){const r=Math.exp(t*n*n);return n<=e?r:0}function Ac(e,t){return e.score-t.score||e.score===t.score&&t.boxIndex-e.boxIndex}const Ic=async function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY){const o=Pr(e,"boxes","nonMaxSuppressionAsync"),a=Pr(t,"scores","nonMaxSuppressionAsync"),i=mc(o,a,n,r,s);n=i.maxOutputSize,r=i.iouThreshold,s=i.scoreThreshold;const l=await Promise.all([o.data(),a.data()]),u=l[0],c=l[1],{selectedIndices:h}=wc(u,c,n,r,s);return o!==e&&o.dispose(),a!==t&&a.dispose(),_u(h,"int32")};const $c=Or({nonMaxSuppressionWithScore_:function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY,o=0){const a=Pr(e,"boxes","nonMaxSuppression"),i=Pr(t,"scores","nonMaxSuppression"),l=mc(a,i,n,r,s,o),u={boxes:a,scores:i},c={maxOutputSize:n=l.maxOutputSize,iouThreshold:r=l.iouThreshold,scoreThreshold:s=l.scoreThreshold,softNmsSigma:o=l.softNmsSigma},h=Nr.runKernel("NonMaxSuppressionV5",u,c);return{selectedIndices:h[0],selectedScores:h[1]}}});const _c=async function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY,o=0){const a=Pr(e,"boxes","nonMaxSuppressionAsync"),i=Pr(t,"scores","nonMaxSuppressionAsync"),l=mc(a,i,n,r,s,o);n=l.maxOutputSize,r=l.iouThreshold,s=l.scoreThreshold,o=l.softNmsSigma;const u=await Promise.all([a.data(),i.data()]),c=u[0],h=u[1],{selectedIndices:d,selectedScores:p}=vc(c,h,n,r,s,o);return a!==e&&a.dispose(),i!==t&&i.dispose(),{selectedIndices:_u(d,"int32"),selectedScores:_u(p)}};const Mc=Or({nonMaxSuppressionPadded_:function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY,o=!1){const a=Pr(e,"boxes","nonMaxSuppression"),i=Pr(t,"scores","nonMaxSuppression"),l=mc(a,i,n,r,s,null),u={boxes:a,scores:i},c={maxOutputSize:l.maxOutputSize,iouThreshold:l.iouThreshold,scoreThreshold:l.scoreThreshold,padToMaxOutputSize:o},h=Nr.runKernel("NonMaxSuppressionV4",u,c);return{selectedIndices:h[0],validOutputs:h[1]}}});const Nc=async function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY,o=!1){const a=Pr(e,"boxes","nonMaxSuppressionAsync"),i=Pr(t,"scores","nonMaxSuppressionAsync"),l=mc(a,i,n,r,s,null),u=l.maxOutputSize,c=l.iouThreshold,h=l.scoreThreshold,[d,p]=await Promise.all([a.data(),i.data()]),{selectedIndices:f,validOutputs:m}=kc(d,p,u,c,h,o);return a!==e&&a.dispose(),i!==t&&i.dispose(),{selectedIndices:_u(f,"int32"),validOutputs:su(m,"int32")}};const Tc=Or({resizeBilinear_:function(e,t,n=!1,r=!1){const s=Pr(e,"images","resizeBilinear");o(3===s.rank||4===s.rank,()=>`Error in resizeBilinear: x must be rank 3 or 4, but got rank ${s.rank}.`),o(2===t.length,()=>"Error in resizeBilinear: new shape must 2D, but got shape "+t+"."),o(!1===r||!1===n,()=>"Error in resizeBilinear: If halfPixelCenters is true, alignCorners must be false.");let a=s,i=!1;3===s.rank&&(i=!0,a=ka(s,[1,s.shape[0],s.shape[1],s.shape[2]]));const l={images:a},u={alignCorners:n,halfPixelCenters:r,size:t},c=Nr.runKernel("ResizeBilinear",l,u);return i?ka(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});const Dc=Or({resizeNearestNeighbor_:function(e,t,n=!1,r=!1){const s=Pr(e,"images","resizeNearestNeighbor");o(3===s.rank||4===s.rank,()=>`Error in resizeNearestNeighbor: x must be rank 3 or 4, but got rank ${s.rank}.`),o(2===t.length,()=>"Error in resizeNearestNeighbor: new shape must 2D, but got shape "+t+"."),o("float32"===s.dtype||"int32"===s.dtype,()=>"`images` must have `int32` or `float32` as dtype"),o(!1===r||!1===n,()=>"Error in resizeNearestNeighbor: If halfPixelCenters is true, alignCorners must be false.");let a=s,i=!1;3===s.rank&&(i=!0,a=ka(s,[1,s.shape[0],s.shape[1],s.shape[2]]));const l={images:a},u={alignCorners:n,halfPixelCenters:r,size:t},c=Nr.runKernel("ResizeNearestNeighbor",l,u);return i?ka(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});const Rc=Or({transform_:function(e,t,n="nearest",r="constant",s=0,a){const i=Pr(e,"image","transform","float32"),l=Pr(t,"transforms","transform","float32");o(4===i.rank,()=>`Error in transform: image must be rank 4,but got rank ${i.rank}.`),o(2===l.rank&&(l.shape[0]===i.shape[0]||1===l.shape[0])&&8===l.shape[1],()=>"Error in transform: Input transform should be batch x 8 or 1 x 8"),o(null==a||2===a.length,()=>`Error in transform: outputShape must be [height, width] or null, but got ${a}.`);const u={image:i,transforms:l},c={interpolation:n,fillMode:r,fillValue:s,outputShape:a};return Nr.runKernel("Transform",u,c)}});const Fc=Or({bandPart_:function(e,t,n){o(t%1==0,()=>`bandPart(): numLower must be an integer, got ${t}.`),o(n%1==0,()=>`bandPart(): numUpper must be an integer, got ${n}.`);const r=Pr(e,"a","bandPart");o(r.rank>=2,()=>`bandPart(): Rank must be at least 2, got ${r.rank}.`);const s=r.shape,[a,i]=r.shape.slice(-2);if(!(t<=a))throw new Error(`bandPart(): numLower (${t}) must not be greater than the number of rows (${a}).`);if(!(n<=i))throw new Error(`bandPart(): numUpper (${n}) must not be greater than the number of columns (${i}).`);t<0&&(t=a),n<0&&(n=i);const l=ka(Hl(0,a,1,"int32"),[-1,1]),u=Hl(0,i,1,"int32"),c=qi(l,u),h=Zi(_i(c,su(+t,"int32")),vi(c,su(-n,"int32"))),d=al([a,i],r.dtype);return ka(Su(Pu(ka(r,[-1,a,i])).map(e=>oi(h,e,d))),s)}});const Cc=Or({gramSchmidt_:function(e){let t;if(Array.isArray(e)){t=!1,o(null!=e&&e.length>0,()=>"Gram-Schmidt process: input must not be null, undefined, or empty");const n=e[0].shape[0];for(let t=1;t<e.length;++t)o(e[t].shape[0]===n,()=>`Gram-Schmidt: Non-unique lengths found in the input vectors: (${e[t].shape[0]} vs. ${n})`)}else t=!0,e=wu(e,e.shape[0],0).map(e=>Eu(e,[0]));o(e.length<=e[0].shape[0],()=>`Gram-Schmidt: Number of vectors (${e.length}) exceeds number of dimensions (${e[0].shape[0]}).`);const n=[],r=e;for(let t=0;t<e.length;++t)n.push(Nr.tidy(()=>{let e=r[t];if(t>0)for(let r=0;r<t;++r){const t=Jo(Gi(Jo(n[r],e)),n[r]);e=qi(e,t)}return jo(e,Wu(e,"euclidean"))}));return t?Su(n,0):n}});function Bc(e,t=!1){return Nr.tidy(()=>{o(2===e.shape.length,()=>`qr2d() requires a 2D Tensor, but got a ${e.shape.length}D Tensor.`);const n=e.shape[0],r=e.shape[1];let s=gi(n),a=As(e);const i=Mu([[1]],[1,1]);let l=As(i);const u=n>=r?r:n;for(let e=0;e<u;++e){const t=a,o=l,u=s;[l,a,s]=Nr.tidy(()=>{const t=Aa(a,[e,e],[n-e,1]),o=Wu(t),u=Aa(a,[e,e],[1,1]),c=oi(ki(u,0),Mu([[-1]]),Mu([[1]])),h=qi(u,Jo(c,o)),d=jo(t,h);l=1===d.shape[0]?As(i):Ea([i,Aa(d,[1,0],[d.shape[0]-1,d.shape[1]])],0);const p=Oi(jo(Os(c,h),o)),f=Aa(a,[e,0],[n-e,r]),m=Jo(p,l),g=Ws(l);if(0===e)a=qi(f,Os(m,Os(g,f)));else{const t=qi(f,Os(m,Os(g,f)));a=Ea([Aa(a,[0,0],[e,r]),t],0)}const b=Ws(m),y=Aa(s,[0,e],[n,s.shape[1]-e]);if(0===e)s=qi(y,Os(Os(y,l),b));else{const t=qi(y,Os(Os(y,l),b));s=Ea([Aa(s,[0,0],[n,e]),t],1)}return[l,a,s]}),Fo([t,o,u])}return!t&&n>r&&(s=Aa(s,[0,0],[n,r]),a=Aa(a,[0,0],[r,r])),[s,a]})}const Pc=Or({qr_:function(e,t=!1){if(o(e.rank>=2,()=>"qr() requires input tensor to have a rank >= 2, but got rank "+e.rank),2===e.rank)return Bc(e,t);{const n=e.shape.slice(0,e.shape.length-2).reduce((e,t)=>e*t),r=Pu(ka(e,[n,e.shape[e.shape.length-2],e.shape[e.shape.length-1]]),0),s=[],o=[];r.forEach(e=>{const[n,r]=Bc(e,t);s.push(n),o.push(r)});return[ka(Su(s,0),e.shape),ka(Su(o,0),e.shape)]}}});var zc;!function(e){e[e.NONE=0]="NONE",e[e.MEAN=1]="MEAN",e[e.SUM=2]="SUM",e[e.SUM_BY_NONZERO_WEIGHTS=3]="SUM_BY_NONZERO_WEIGHTS"}(zc||(zc={}));const Lc=Or({computeWeightedLoss_:function(e,t,n=zc.SUM_BY_NONZERO_WEIGHTS){const r=Pr(e,"losses","computeWeightedLoss");let s=null;null!=t&&(s=Pr(t,"weights","computeWeightedLoss"));const o=null==s?r:Jo(r,s);if(n===zc.NONE)return o;if(n===zc.SUM)return Gi(o);if(n===zc.MEAN){if(null==s)return ol(o);{const e=r.size/s.size,t=jo(Gi(o),Gi(s));return e>1?jo(t,su(e)):t}}if(n===zc.SUM_BY_NONZERO_WEIGHTS){if(null==s)return jo(Gi(o),su(r.size));{const e=Jo(s,il(r.shape)),t=Ss(Gi(bl(e,su(0))),"float32");return jo(Gi(o),t)}}throw Error("Unknown reduction: "+n)}});const Oc=Or({absoluteDifference_:function(e,t,n,r=zc.SUM_BY_NONZERO_WEIGHTS){const s=Pr(e,"labels","absoluteDifference"),o=Pr(t,"predictions","absoluteDifference");let i=null;null!=n&&(i=Pr(n,"weights","absoluteDifference")),a(s.shape,o.shape,"Error in absoluteDifference: ");const l=Yo(qi(s,o));return Lc(l,i,r)}});const Kc=Or({cosineDistance_:function(e,t,n,r,s=zc.SUM_BY_NONZERO_WEIGHTS){const o=Pr(e,"labels","cosineDistance"),i=Pr(t,"predictions","cosineDistance");let l=null;null!=r&&(l=Pr(r,"weights","cosineDistance")),a(o.shape,i.shape,"Error in cosineDistance: ");const u=su(1),c=qi(u,Gi(Jo(o,i),n,!0));return Lc(c,l,s)}});const Wc=Or({hingeLoss_:function(e,t,n,r=zc.SUM_BY_NONZERO_WEIGHTS){let s=Pr(e,"labels","hingeLoss");const o=Pr(t,"predictions","hingeLoss");let i=null;null!=n&&(i=Pr(n,"weights","hingeLoss")),a(s.shape,o.shape,"Error in hingeLoss: ");const l=su(1);s=qi(Jo(su(2),s),l);const u=Jl(qi(l,Jo(s,o)));return Lc(u,i,r)}});const Uc=Or({huberLoss_:function(e,t,n,r=1,s=zc.SUM_BY_NONZERO_WEIGHTS){const o=Pr(e,"labels","huberLoss"),i=Pr(t,"predictions","huberLoss");let l=null;null!=n&&(l=Pr(n,"weights","huberLoss")),a(o.shape,i.shape,"Error in huberLoss: ");const u=su(r),c=Yo(qi(i,o)),h=cl(c,u),d=qi(c,h),p=Ho(Jo(su(.5),pl(h)),Jo(u,d));return Lc(p,l,s)}});const qc=Or({logLoss_:function(e,t,n,r=1e-7,s=zc.SUM_BY_NONZERO_WEIGHTS){const o=Pr(e,"labels","logLoss"),i=Pr(t,"predictions","logLoss");let l=null;null!=n&&(l=Pr(n,"weights","logLoss")),a(o.shape,i.shape,"Error in logLoss: ");const u=su(1),c=su(r),h=Oi(Jo(o,Ti(Ho(i,c)))),d=Jo(qi(u,o),Ti(Ho(qi(u,i),c))),p=qi(h,d);return Lc(p,l,s)}});const Gc=Or({meanSquaredError_:function(e,t,n,r=zc.SUM_BY_NONZERO_WEIGHTS){const s=Pr(e,"labels","meanSquaredError"),o=Pr(t,"predictions","meanSquaredError");let i=null;null!=n&&(i=Pr(n,"weights","meanSquaredError")),a(s.shape,o.shape,"Error in meanSquaredError: ");const l=xu(s,o);return Lc(l,i,r)}});const Hc=Or({sigmoidCrossEntropy_:function(e,t,n,r=0,s=zc.SUM_BY_NONZERO_WEIGHTS){let o=Pr(e,"multiClassLabels","sigmoidCrossEntropy");const i=Pr(t,"logits","sigmoidCrossEntropy");let l=null;if(null!=n&&(l=Pr(n,"weights","sigmoidCrossEntropy")),a(o.shape,i.shape,"Error in sigmoidCrossEntropy: "),r>0){const e=su(r),t=su(1),n=su(.5);o=Ho(Jo(o,qi(t,e)),Jo(n,e))}const u=function(e,t){const n=Pr(e,"labels","sigmoidCrossEntropyWithLogits"),r=Pr(t,"logits","sigmoidCrossEntropyWithLogits");a(n.shape,r.shape,"Error in sigmoidCrossEntropyWithLogits: ");const s=Jl(r),o=Jo(r,n),i=Di(di(Oi(Yo(r))));return Ho(qi(s,o),i)}(o,i);return Lc(u,l,s)}});const Vc=Or({softmaxCrossEntropy_:function(e,t,n,r=0,s=zc.SUM_BY_NONZERO_WEIGHTS){let o=Pr(e,"onehotLabels","softmaxCrossEntropy");const i=Pr(t,"logits","softmaxCrossEntropy");let l=null;if(null!=n&&(l=Pr(n,"weights","softmaxCrossEntropy")),a(o.shape,i.shape,"Error in softmaxCrossEntropy: "),r>0){const e=su(r),t=su(1),n=su(o.shape[1]);o=Ho(Jo(o,qi(t,e)),jo(e,n))}const u=function(e,t,n=-1){if(-1===n&&(n=t.rank-1),n!==t.rank-1)throw Error(`Softmax cross entropy along a non-last dimension is not yet supported. Labels / logits was rank ${t.rank} and dim was `+n);return zi((e,t,r)=>{const s=Yi(t,[n],!0),o=qi(Ss(t,"float32"),s);r([e,o]);const a=Oi(Jo(o,e));return{value:Gi(a,[n]),gradFunc:(e,t)=>{const[r,s]=t,o=Ji(e.shape,[n]);return[Jo(ka(e,o),qi(Ss(r,"float32"),di(s))),Jo(ka(e,o),qi(di(s),Ss(r,"float32")))]}}})(e,t)}(o,i);return Lc(u,l,s)}});const jc=Or({sparseReshape_:function(e,t,n){const r=Pr(e,"inputIndices","sparseReshape"),s=Pr(t,"inputShape","sparseReshape"),o=Pr(n,"newShape","sparseReshape");if(2!==r.rank)throw new Error("Input indices should be Tensor2D but received shape\n        "+r.shape);if(1!==s.rank)throw new Error("Input shape should be Tensor1D but received shape "+s.shape);if(1!==o.rank)throw new Error("New shape should be Tensor1D but received shape "+o.shape);const a={inputIndices:r,inputShape:s,newShape:o},i=Nr.runKernel("SparseReshape",a);return{outputIndices:i[0],outputShape:i[1]}}}),Jc={fft:gu,ifft:bu,rfft:ku,irfft:yu},Yc={hammingWindow:lc,hannWindow:uc,frame:cc,stft:hc},Zc={flipLeftRight:pc,resizeNearestNeighbor:Dc,resizeBilinear:Tc,rotateWithOffset:fc,cropAndResize:dc,nonMaxSuppression:gc,nonMaxSuppressionAsync:Ic,nonMaxSuppressionWithScore:$c,nonMaxSuppressionWithScoreAsync:_c,nonMaxSuppressionPadded:Mc,nonMaxSuppressionPaddedAsync:Nc,transform:Rc},Xc={bandPart:Fc,gramSchmidt:Cc,qr:Pc},Qc={absoluteDifference:Oc,computeWeightedLoss:Lc,cosineDistance:Kc,hingeLoss:Wc,huberLoss:Uc,logLoss:qc,meanSquaredError:Gc,sigmoidCrossEntropy:Hc,softmaxCrossEntropy:Vc},eh={sparseReshape:jc};class th extends go{minimize(e,t=!1,n){const{value:r,grads:s}=this.computeGradients(e,n);if(null!=n){const e=n.map(e=>({name:e.name,tensor:s[e.name]}));this.applyGradients(e)}else this.applyGradients(s);return Fo(s),t?r:(r.dispose(),null)}get iterations(){return null==this.iterations_&&(this.iterations_=0),this.iterations_}incrementIterations(){this.iterations_=this.iterations+1}computeGradients(e,t){return Pi(e,t)}dispose(){null!=this.iterations_&&Fo(this.iterations_)}async saveIterations(){return null==this.iterations_&&(this.iterations_=0),{name:"iter",tensor:su(this.iterations_,"int32")}}async getWeights(){throw new Error("getWeights() is not implemented for this optimizer yet.")}async setWeights(e){throw new Error("setWeights() is not implemented for this optimizer class "+this.getClassName())}async extractIterations(e){return this.iterations_=(await e[0].tensor.data())[0],e.slice(1)}}Object.defineProperty(th,Symbol.hasInstance,{value:e=>null!=e.minimize&&null!=e.computeGradients&&null!=e.applyGradients});class nh extends th{constructor(e,t,n=null){super(),this.learningRate=e,this.rho=t,this.epsilon=n,this.accumulatedGrads=[],this.accumulatedUpdates=[],null==n&&(this.epsilon=Nr.backend.epsilon())}applyGradients(e){(Array.isArray(e)?e.map(e=>e.name):Object.keys(e)).forEach((t,n)=>{const r=Nr.registeredVariables[t];null==this.accumulatedGrads[n]&&(this.accumulatedGrads[n]={originalName:t+"/accum_grad",variable:Ro(()=>ai(r).variable(!1))}),null==this.accumulatedUpdates[n]&&(this.accumulatedUpdates[n]={originalName:t+"/accum_var",variable:Ro(()=>ai(r).variable(!1))});const s=Array.isArray(e)?e[n].tensor:e[t];if(null==s)return;const o=this.accumulatedGrads[n].variable,a=this.accumulatedUpdates[n].variable;Ro(()=>{const e=Ho(Jo(o,this.rho),Jo(pl(s),1-this.rho)),t=Jo(jo(vu(Ho(a,this.epsilon)),vu(Ho(o,this.epsilon))),s),n=Ho(Jo(a,this.rho),Jo(pl(t),1-this.rho));o.assign(e),a.assign(n);const i=Ho(Jo(t,-this.learningRate),r);r.assign(i)})}),this.incrementIterations()}dispose(){null!=this.accumulatedUpdates&&(Fo(this.accumulatedGrads.map(e=>e.variable)),Fo(this.accumulatedUpdates.map(e=>e.variable)))}async getWeights(){const e=[...this.accumulatedGrads,...this.accumulatedUpdates];return[await this.saveIterations()].concat(e.map(e=>({name:e.originalName,tensor:e.variable})))}async setWeights(e){const t=(e=await this.extractIterations(e)).length/2;this.accumulatedGrads=e.slice(0,t).map(e=>({originalName:e.name,variable:e.tensor.variable(!1)})),this.accumulatedUpdates=e.slice(t,2*t).map(e=>({originalName:e.name,variable:e.tensor.variable(!1)}))}getConfig(){return{learningRate:this.learningRate,rho:this.rho,epsilon:this.epsilon}}static fromConfig(e,t){return new e(t.learningRate,t.rho,t.epsilon)}}nh.className="Adadelta",yo(nh);class rh extends th{constructor(e,t=.1){super(),this.learningRate=e,this.initialAccumulatorValue=t,this.accumulatedGrads=[]}applyGradients(e){(Array.isArray(e)?e.map(e=>e.name):Object.keys(e)).forEach((t,n)=>{const r=Nr.registeredVariables[t];if(null==this.accumulatedGrads[n]){const e=!1;this.accumulatedGrads[n]={originalName:t+"/accumulator",variable:Ro(()=>bi(r.shape,this.initialAccumulatorValue).variable(e))}}const s=Array.isArray(e)?e[n].tensor:e[t];if(null==s)return;const o=this.accumulatedGrads[n].variable;Ro(()=>{const e=Ho(o,pl(s));o.assign(e);const t=Ho(Jo(jo(s,vu(Ho(e,Nr.backend.epsilon()))),-this.learningRate),r);r.assign(t)})}),this.incrementIterations()}dispose(){null!=this.accumulatedGrads&&Fo(this.accumulatedGrads.map(e=>e.variable))}async getWeights(){return[await this.saveIterations()].concat(this.accumulatedGrads.map(e=>({name:e.originalName,tensor:e.variable})))}async setWeights(e){e=await this.extractIterations(e);this.accumulatedGrads=e.map(e=>({originalName:e.name,variable:e.tensor.variable(!1)}))}getConfig(){return{learningRate:this.learningRate,initialAccumulatorValue:this.initialAccumulatorValue}}static fromConfig(e,t){return new e(t.learningRate,t.initialAccumulatorValue)}}rh.className="Adagrad",yo(rh);class sh extends th{constructor(e,t,n,r=null){super(),this.learningRate=e,this.beta1=t,this.beta2=n,this.epsilon=r,this.accumulatedFirstMoment=[],this.accumulatedSecondMoment=[],Ro(()=>{this.accBeta1=su(t).variable(),this.accBeta2=su(n).variable()}),null==r&&(this.epsilon=Nr.backend.epsilon())}applyGradients(e){const t=Array.isArray(e)?e.map(e=>e.name):Object.keys(e);Ro(()=>{const n=qi(1,this.accBeta1),r=qi(1,this.accBeta2);t.forEach((t,s)=>{const o=Nr.registeredVariables[t];null==this.accumulatedFirstMoment[s]&&(this.accumulatedFirstMoment[s]={originalName:t+"/m",variable:Ro(()=>ai(o).variable(!1))}),null==this.accumulatedSecondMoment[s]&&(this.accumulatedSecondMoment[s]={originalName:t+"/v",variable:Ro(()=>ai(o).variable(!1))});const a=Array.isArray(e)?e[s].tensor:e[t];if(null==a)return;const i=this.accumulatedFirstMoment[s].variable,l=this.accumulatedSecondMoment[s].variable,u=Ho(Jo(i,this.beta1),Jo(a,1-this.beta1)),c=Ho(Jo(l,this.beta2),Jo(pl(a),1-this.beta2)),h=jo(u,n),d=jo(c,r);i.assign(u),l.assign(c);const p=Ho(Jo(jo(h,Ho(vu(d),this.epsilon)),-this.learningRate),o);o.assign(p)}),this.accBeta1.assign(Jo(this.accBeta1,this.beta1)),this.accBeta2.assign(Jo(this.accBeta2,this.beta2))}),this.incrementIterations()}dispose(){this.accBeta1.dispose(),this.accBeta2.dispose(),null!=this.accumulatedFirstMoment&&Fo(this.accumulatedFirstMoment.map(e=>e.variable)),null!=this.accumulatedSecondMoment&&Fo(this.accumulatedSecondMoment.map(e=>e.variable))}async getWeights(){const e=[...this.accumulatedFirstMoment,...this.accumulatedSecondMoment];return[await this.saveIterations()].concat(e.map(e=>({name:e.originalName,tensor:e.variable})))}async setWeights(e){e=await this.extractIterations(e),Ro(()=>{this.accBeta1.assign($l(this.beta1,this.iterations_+1)),this.accBeta2.assign($l(this.beta2,this.iterations_+1))});const t=e.length/2;this.accumulatedFirstMoment=e.slice(0,t).map(e=>({originalName:e.name,variable:e.tensor.variable(!1)})),this.accumulatedSecondMoment=e.slice(t,2*t).map(e=>({originalName:e.name,variable:e.tensor.variable(!1)}))}getConfig(){return{learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon}}static fromConfig(e,t){return new e(t.learningRate,t.beta1,t.beta2,t.epsilon)}}sh.className="Adam",yo(sh);class oh extends th{constructor(e,t,n,r=null,s=0){super(),this.learningRate=e,this.beta1=t,this.beta2=n,this.epsilon=r,this.decay=s,this.accumulatedFirstMoment=[],this.accumulatedWeightedInfNorm=[],Ro(()=>{this.iteration=su(0).variable(),this.accBeta1=su(t).variable()}),null==r&&(this.epsilon=Nr.backend.epsilon())}applyGradients(e){const t=Array.isArray(e)?e.map(e=>e.name):Object.keys(e);Ro(()=>{const n=qi(1,this.accBeta1),r=jo(-this.learningRate,Ho(Jo(this.iteration,this.decay),1));t.forEach((t,s)=>{const o=Nr.registeredVariables[t];null==this.accumulatedFirstMoment[s]&&(this.accumulatedFirstMoment[s]={originalName:t+"/m",variable:ai(o).variable(!1)}),null==this.accumulatedWeightedInfNorm[s]&&(this.accumulatedWeightedInfNorm[s]={originalName:t+"/v",variable:ai(o).variable(!1)});const a=Array.isArray(e)?e[s].tensor:e[t];if(null==a)return;const i=this.accumulatedFirstMoment[s].variable,l=this.accumulatedWeightedInfNorm[s].variable,u=Ho(Jo(i,this.beta1),Jo(a,1-this.beta1)),c=Jo(l,this.beta2),h=Yo(a),d=sl(c,h);i.assign(u),l.assign(d);const p=Ho(Jo(jo(r,n),jo(u,Ho(d,this.epsilon))),o);o.assign(p)}),this.iteration.assign(Ho(this.iteration,1)),this.accBeta1.assign(Jo(this.accBeta1,this.beta1))}),this.incrementIterations()}dispose(){this.accBeta1.dispose(),this.iteration.dispose(),null!=this.accumulatedFirstMoment&&Fo(this.accumulatedFirstMoment.map(e=>e.variable)),null!=this.accumulatedWeightedInfNorm&&Fo(this.accumulatedWeightedInfNorm.map(e=>e.variable))}async getWeights(){throw new Error("getWeights() is not implemented for Adamax yet.")}async setWeights(e){throw new Error("setWeights() is not implemented for Adamax yet.")}getConfig(){return{learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon,decay:this.decay}}static fromConfig(e,t){return new e(t.learningRate,t.beta1,t.beta2,t.epsilon,t.decay)}}oh.className="Adamax",yo(oh);class ah extends th{constructor(e){super(),this.learningRate=e,this.setLearningRate(e)}applyGradients(e){(Array.isArray(e)?e.map(e=>e.name):Object.keys(e)).forEach((t,n)=>{const r=Array.isArray(e)?e[n].tensor:e[t];if(null==r)return;const s=Nr.registeredVariables[t];Ro(()=>{const e=Ho(Jo(this.c,r),s);s.assign(e)})}),this.incrementIterations()}setLearningRate(e){this.learningRate=e,null!=this.c&&this.c.dispose(),this.c=Co(su(-e))}dispose(){this.c.dispose()}async getWeights(){return[await this.saveIterations()]}async setWeights(e){if(0!==(e=await this.extractIterations(e)).length)throw new Error("SGD optimizer does not have settable weights.")}getConfig(){return{learningRate:this.learningRate}}static fromConfig(e,t){return new e(t.learningRate)}}ah.className="SGD",yo(ah);class ih extends ah{constructor(e,t,n=!1){super(e),this.learningRate=e,this.momentum=t,this.useNesterov=n,this.accumulations=[],this.m=su(this.momentum)}applyGradients(e){(Array.isArray(e)?e.map(e=>e.name):Object.keys(e)).forEach((t,n)=>{const r=Nr.registeredVariables[t];if(null==this.accumulations[n]){const e=!1;this.accumulations[n]={originalName:t+"/momentum",variable:Ro(()=>ai(r).variable(e))}}const s=this.accumulations[n].variable,o=Array.isArray(e)?e[n].tensor:e[t];null!=o&&Ro(()=>{let e;const t=Ho(Jo(this.m,s),o);e=this.useNesterov?Ho(Jo(this.c,Ho(o,Jo(t,this.m))),r):Ho(Jo(this.c,t),r),s.assign(t),r.assign(e)})}),this.incrementIterations()}dispose(){this.m.dispose(),null!=this.accumulations&&Fo(this.accumulations.map(e=>e.variable))}setMomentum(e){this.momentum=e}async getWeights(){return[await this.saveIterations()].concat(this.accumulations.map(e=>({name:e.originalName,tensor:e.variable})))}async setWeights(e){e=await this.extractIterations(e);this.accumulations=e.map(e=>({originalName:e.name,variable:e.tensor.variable(!1)}))}getConfig(){return{learningRate:this.learningRate,momentum:this.momentum,useNesterov:this.useNesterov}}static fromConfig(e,t){return new e(t.learningRate,t.momentum,t.useNesterov)}}ih.className="Momentum",yo(ih);class lh extends th{constructor(e,t=.9,n=0,r=null,s=!1){if(super(),this.learningRate=e,this.decay=t,this.momentum=n,this.epsilon=r,this.accumulatedMeanSquares=[],this.accumulatedMoments=[],this.accumulatedMeanGrads=[],this.centered=s,null==r&&(this.epsilon=Nr.backend.epsilon()),null==e)throw new Error("learningRate for RMSPropOptimizer must be defined.")}applyGradients(e){(Array.isArray(e)?e.map(e=>e.name):Object.keys(e)).forEach((t,n)=>{const r=Nr.registeredVariables[t];null==this.accumulatedMeanSquares[n]&&(this.accumulatedMeanSquares[n]={originalName:t+"/rms",variable:Ro(()=>ai(r).variable(!1))}),null==this.accumulatedMoments[n]&&(this.accumulatedMoments[n]={originalName:t+"/momentum",variable:Ro(()=>ai(r).variable(!1))}),null==this.accumulatedMeanGrads[n]&&this.centered&&(this.accumulatedMeanGrads[n]={originalName:t+"/mg",variable:Ro(()=>ai(r).variable(!1))});const s=Array.isArray(e)?e[n].tensor:e[t];if(null==s)return;const o=this.accumulatedMeanSquares[n].variable,a=this.accumulatedMoments[n].variable;Ro(()=>{const e=Ho(Jo(o,this.decay),Jo(pl(s),1-this.decay));if(this.centered){const t=this.accumulatedMeanGrads[n].variable,i=Ho(Jo(t,this.decay),Jo(s,1-this.decay)),l=jo(Jo(s,this.learningRate),vu(qi(e,Ho(pl(i),this.epsilon)))),u=Ho(Jo(a,this.momentum),l);o.assign(e),t.assign(i),a.assign(u);const c=qi(r,u);r.assign(c)}else{const e=Ho(Jo(o,this.decay),Jo(pl(s),1-this.decay)),t=Ho(Jo(a,this.momentum),jo(Jo(s,this.learningRate),vu(Ho(e,this.epsilon))));o.assign(e),a.assign(t);const n=qi(r,t);r.assign(n)}})}),this.incrementIterations()}dispose(){null!=this.accumulatedMeanSquares&&Fo(this.accumulatedMeanSquares.map(e=>e.variable)),null!=this.accumulatedMeanGrads&&this.centered&&Fo(this.accumulatedMeanGrads.map(e=>e.variable)),null!=this.accumulatedMoments&&Fo(this.accumulatedMoments.map(e=>e.variable))}async getWeights(){const e=[...this.accumulatedMeanSquares,...this.accumulatedMoments];return this.centered&&e.push(...this.accumulatedMeanGrads),[await this.saveIterations()].concat(e.map(e=>({name:e.originalName,tensor:e.variable})))}async setWeights(e){e=await this.extractIterations(e);const t=this.centered?e.length/3:e.length/2;this.accumulatedMeanSquares=e.slice(0,t).map(e=>({originalName:e.name,variable:e.tensor.variable(!1)})),this.accumulatedMoments=e.slice(t,2*t).map(e=>({originalName:e.name,variable:e.tensor.variable(!1)})),this.centered&&(this.accumulatedMeanGrads=e.slice(2*t,3*t).map(e=>({originalName:e.name,variable:e.tensor.variable(!1)})))}getConfig(){return{learningRate:this.learningRate,decay:this.decay,momentum:this.momentum,epsilon:this.epsilon,centered:this.centered}}static fromConfig(e,t){return new e(t.learningRate,t.decay,t.momentum,t.epsilon,t.centered)}}lh.className="RMSProp",yo(lh);class uh{static sgd(e){return new ah(e)}static momentum(e,t,n=!1){return new ih(e,t,n)}static rmsprop(e,t=.9,n=0,r=null,s=!1){return new lh(e,t,n,r,s)}static adam(e=.001,t=.9,n=.999,r=null){return new sh(e,t,n,r)}static adadelta(e=.001,t=.95,n=null){return new nh(e,t,n)}static adamax(e=.002,t=.9,n=.999,r=null,s=0){return new oh(e,t,n,r,s)}static adagrad(e,t=.1){return new rh(e,t)}}const ch={sgd:uh.sgd,momentum:uh.momentum,adadelta:uh.adadelta,adagrad:uh.adagrad,rmsprop:uh.rmsprop,adamax:uh.adamax,adam:uh.adam},hh="undefined"!=typeof requestAnimationFrame?requestAnimationFrame:"undefined"!=typeof setImmediate?setImmediate:e=>e();function dh(){return new Promise(e=>hh(()=>e()))}const ph=/->/g;function fh(e,t){const n=[];for(let r=0;r<e.length;++r)0!==e[r].length&&-1===e[r].indexOf(t)&&-1!==t||n.push(r);return n}var mh=Object.freeze({__proto__:null,segOpComputeOptimalWindowSize:function(e,t){let n,r=!1;for(e<=30?(n=e,r=!0):n=$(e,Math.floor(Math.sqrt(e)));!r;)n>t||n===e?r=!0:n=$(e,n+1);return n},computeOutShape:function(e,t,n){const r=[],s=e.length;for(let o=0;o<s;o++)o!==t?r.push(e[o]):r.push(n);return r},collectGatherOpShapeInfo:function(e,t,n,r){const s=t.shape.length,o=e.shape.length;if(0!==r&&(r<-s||r>s))throw new Error(`Expect batchDims in the range of [-${s}, ${s}], but got ${r}`);if(r<0&&(r+=s),r>o)throw new Error(`batchDims (${r}) must be less than rank(x) (\n    ${o}).`);if(n<r)throw new Error(`batchDims (${r}) must be less than or equal to axis (${n}).`);for(let n=0;n<r;++n)if(e.shape[n]!==t.shape[n])throw new Error(`x.shape[${n}]: ${e.shape[n]} should be equal to indices.shape[${n}]: ${t.shape[n]}.`);const a=e.shape[n],i=[];let l=1,u=1,c=1;for(let t=0;t<r;++t)i.push(e.shape[t]),l*=e.shape[t];for(let t=r;t<n;t++)i.push(e.shape[t]),u*=e.shape[t];for(let e=r;e<s;e++)i.push(t.shape[e]);for(let t=n+1;t<o;t++)i.push(e.shape[t]),c*=e.shape[t];return{batchSize:l,sliceSize:c,outerSize:u,dimSize:a,outputShape:i}}});var gh=Object.freeze({__proto__:null,slice_util:mo,segment_util:mh,fromUint8ToStringArray:function(e){try{return e.map(e=>er(e))}catch(e){throw new Error("Failed to decode encoded string bytes into utf-8, error: "+e)}},fromStringArrayToUint8:function(e){return e.map(e=>Qn(e))},upcastType:kr,axesAreInnerMostDims:Vi,combineLocations:ji,computeOutAndReduceShapes:function(e,t){const n=[],r=e.length;for(let s=0;s<r;s++)-1===t.indexOf(s)&&n.push(e[s]);return[n,t.map(t=>e[t])]},expandShapeToKeepDim:Ji,assertAxesAreInnerMostDims:function(e,t,n){o(Vi(t,n),()=>e+" supports only inner-most axes for now. "+`Got axes ${t} and rank-${n} input.`)},getAxesPermutation:function(e,t){if(Vi(e,t))return null;const n=[];for(let r=0;r<t;++r)-1===e.indexOf(r)&&n.push(r);return e.forEach(e=>n.push(e)),n},getUndoAxesPermutation:function(e){return e.map((e,t)=>[t,e]).sort((e,t)=>e[1]-t[1]).map(e=>e[0])},getInnerMostAxes:function(e,t){const n=[];for(let r=t-e;r<t;++r)n.push(r);return n},getBroadcastDims:function(e,t){const n=e.length,r=[];for(let s=0;s<n;s++){const o=n-1-s,a=e[o]||1;(t[t.length-1-s]||1)>1&&1===a&&r.unshift(o)}return r},getReductionAxes:ni,assertAndGetBroadcastShape:ri,assertParamsConsistent:function(e,t){const n=e[0].length;e.forEach((e,t)=>{o(e.length===n,()=>`Error in concat${n}D: rank of tensors[${t}] must be the same as the rank of the rest (${n})`)}),o(t>=0&&t<n,()=>`Error in concat${n}D: axis must be between 0 and ${n-1}.`);const r=e[0];e.forEach((e,s)=>{for(let a=0;a<n;a++)o(a===t||e[a]===r[a],()=>`Error in concat${n}D: Shape of tensors[${s}] (${e}) does not match the shape of the rest (${r}) along the non-concatenated axis ${s}.`)})},computeOutShape:function(e,t){const n=e[0].slice();for(let r=1;r<e.length;r++)n[t]+=e[r][t];return n},computeDilation2DInfo:function(e,t,n,r,s="NHWC",o){return ca(e,[...t,e[3]],n,o,r,null,null,wa(s))},computePool2DInfo:ua,computePool3DInfo:function(e,t,n,r,s,o,a="NDHWC"){const[i,l,u]=fa(t);let c,h;if("NDHWC"===a)h="channelsLast",c=[i,l,u,e[4],e[4]];else{if("NCDHW"!==a)throw new Error("Unknown dataFormat "+a);h="channelsFirst",c=[i,l,u,e[1],e[1]]}return ha(e,c,n,r,s,!1,h,o)},computeConv2DInfo:ca,computeConv3DInfo:ha,computeDefaultPad:da,tupleValuesAreOne:ba,eitherStridesOrDilationsAreOne:ya,convertConv2DDataFormat:wa,getFusedDyActivation:Xu,getFusedBiasGradient:Qu,applyActivation:ec,shouldFuse:tc,PARALLELIZE_THRESHOLD:30,computeOptimalWindowSize:function(e){return e<=30?e:$(e,Math.floor(Math.sqrt(e)))},getImageCenter:function(e,t,n){return[n*("number"==typeof e?e:e[0]),t*("number"==typeof e?e:e[1])]},getReshaped:function(e,t,n,r=!0){let s=[];if(r)s=s.concat(t.slice(0)),s.push(e[0]/n),s=s.concat(e.slice(1));else{s=s.concat(e[0]);const n=t.length;for(let r=0;r<n;++r)s=s.concat([e[r+1]/t[r],t[r]]);s=s.concat(e.slice(n+1))}return s},getPermuted:function(e,t,n=!0){const r=[];if(n){r.push(t);for(let n=t+1;n<e;++n)n<=2*t?(r.push(n),r.push(n-(t+1))):r.push(n)}else{const n=[],s=[];for(let r=1;r<e;++r)r>=2*t+1||r%2==1?s.push(r):n.push(r);r.push(...n),r.push(0),r.push(...s)}return r},getReshapedPermuted:function(e,t,n,r=!0){const s=[];r?s.push(e[0]/n):s.push(e[0]*n);for(let n=1;n<e.length;++n)n<=t.length?r?s.push(t[n-1]*e[n]):s.push(e[n]/t[n-1]):s.push(e[n]);return s},getSliceBeginCoords:function(e,t){const n=[0];for(let r=0;r<t;++r)n.push(e[r][0]);return n},getSliceSize:function(e,t,n){const r=e.slice(0,1);for(let s=0;s<n;++s)r.push(e[s+1]-t[s][0]-t[s][1]);return r},prepareAndValidate:Zs,validateUpdateShape:Qs,validateInput:eo,calculateShapes:to,SELU_SCALEALPHA:1.7580993408473768,SELU_SCALE:1.0507009873554805,ERF_P:.3275911,ERF_A1:.254829592,ERF_A2:-.284496736,ERF_A3:1.421413741,ERF_A4:-1.453152027,ERF_A5:1.061405429,warn:function(...e){B().getBool("IS_TEST")||console.warn(...e)},log:function(...e){B().getBool("IS_TEST")||console.log(...e)},mergeRealAndImagArrays:function(e,t){if(e.length!==t.length)throw new Error(`Cannot merge real and imag arrays of different lengths. real:${e.length}, imag: ${t.length}.`);const n=new Float32Array(2*e.length);for(let r=0;r<n.length;r+=2)n[r]=e[r/2],n[r+1]=t[r/2];return n},splitRealAndImagArrays:function(e){const t=new Float32Array(e.length/2),n=new Float32Array(e.length/2);for(let r=0;r<e.length;r+=2)t[r/2]=e[r],n[r/2]=e[r+1];return{real:t,imag:n}},complexWithEvenIndex:function(e){const t=Math.ceil(e.length/4),n=new Float32Array(t),r=new Float32Array(t);for(let t=0;t<e.length;t+=4)n[Math.floor(t/4)]=e[t],r[Math.floor(t/4)]=e[t+1];return{real:n,imag:r}},complexWithOddIndex:function(e){const t=Math.floor(e.length/4),n=new Float32Array(t),r=new Float32Array(t);for(let t=2;t<e.length;t+=4)n[Math.floor(t/4)]=e[t],r[Math.floor(t/4)]=e[t+1];return{real:n,imag:r}},getComplexWithIndex:function(e,t){return{real:e[2*t],imag:e[2*t+1]}},assignToTypedArray:function(e,t,n,r){e[2*r]=t,e[2*r+1]=n},exponents:function(e,t){const n=new Float32Array(e/2),r=new Float32Array(e/2);for(let s=0;s<Math.ceil(e/2);s++){const o=(t?2:-2)*Math.PI*(s/e);n[s]=Math.cos(o),r[s]=Math.sin(o)}return{real:n,imag:r}},exponent:function(e,t,n){const r=(n?2:-2)*Math.PI*(e/t);return{real:Math.cos(r),imag:Math.sin(r)}},decodeEinsumEquation:function(e,t){const n=((e=e.replace(/\s/g,"")).length-e.replace(ph,"").length)/"->".length;if(n<1)throw new Error("Equations without an arrow are not supported.");if(n>1)throw new Error('Equation must contain exactly one arrow ("->").');const[r,s]=e.split("->");o(-1===r.indexOf("..."),()=>'The ellipsis notation ("...") is not supported yet.');const a=r.split(","),i=a.length;if(t!==i)throw new Error(`Expected ${i} input tensors, received ${t}`);if(i>2)throw new Error("Support for more than 2 input tensors is not implemented yet.");const l=[];for(let e=0;e<s.length;++e){const t=s[e];if(!a.some(e=>-1!==e.indexOf(t)))throw new Error(`Output subscripts contain the label ${t} not present in the input subscripts.`);-1===l.indexOf(t)&&l.push(t)}for(let e=0;e<r.length;++e){const t=r[e];-1===l.indexOf(t)&&","!==t&&l.push(t)}const u=new Array(a.length);for(let e=0;e<i;++e){if(new Set(a[e].split("")).size!==a[e].length)throw new Error(`Found duplicate axes in input component ${a[e]}. Support for duplicate axes in input is not implemented yet.`);u[e]=[];for(let t=0;t<a[e].length;++t)u[e].push(l.indexOf(a[e][t]))}const c=l.length,h=[];for(let e=s.length;e<c;++e)h.push(e);return{allDims:l,summedDims:h,idDims:u}},getEinsumPermutation:function(e,t){let n=new Array(e);n.fill(-1);for(let e=0;e<t.length;++e)n[t[e]]=e;const r=[];for(let t=0;t<e;++t)-1===n[t]&&r.push(t);return n=n.filter(e=>-1!==e),{permutationIndices:n,expandDims:r}},checkEinsumDimSizes:function(e,t,n){const r=new Array(e);for(let e=0;e<n.length;++e){const s=n[e].shape;for(let n=0;n<t[e].length;++n)void 0===r[t[e][n]]?r[t[e][n]]=s[n]:o(r[t[e][n]]===s[n],()=>`Expected dimension ${r[t[e][n]]} at axis ${n} of input shaped ${JSON.stringify(s)}, but got dimension `+s[n])}},getEinsumComputePath:function(e,t){const n=e,r=[];let s=0;0===e.length&&n.push(-1),s=e.length+1;for(let e=0;e<s;++e)r.push([]);const o=[];for(let e=0;e<n.length;++e){const s=fh(t,n[e]);for(const t of s)-1===o.indexOf(t)&&(r[e].push(t),o.push(t))}return{path:n,steps:r}},isIdentityPermutation:function(e){return e.every((e,t)=>e===t)},prepareSplitSize:function(e,t,n=0){let r=[];if("number"==typeof t)o(e.shape[n]%t==0,()=>"Number of splits must evenly divide the axis."),r=new Array(t).fill(e.shape[n]/t);else{o(t.reduce((e,t)=>(-1===t&&(e+=1),e),0)<=1,()=>"There should be only one negative value in split array.");const s=t.indexOf(-1);if(-1!==s){const r=t.reduce((e,t)=>t>0?e+t:e);t[s]=e.shape[n]-r}o(e.shape[n]===t.reduce((e,t)=>e+t),()=>"The sum of sizes must match the size of the axis dimension."),r=t}return r}}),bh=Object.freeze({__proto__:null,nonMaxSuppressionV3Impl:wc,nonMaxSuppressionV4Impl:kc,nonMaxSuppressionV5Impl:vc,whereImpl:Lu});export{K as Abs,W as Acos,U as Acosh,nh as AdadeltaOptimizer,rh as AdagradOptimizer,sh as AdamOptimizer,oh as AdamaxOptimizer,q as Add,G as AddN,H as All,V as Any,j as ArgMax,J as ArgMin,Y as Asin,Z as Asinh,X as Atan,ee as Atan2,Q as Atanh,te as AvgPool,re as AvgPool3D,se as AvgPool3DGrad,ne as AvgPoolGrad,oe as BatchMatMul,ae as BatchToSpaceND,ie as Bincount,le as BroadcastTo,ue as Cast,ce as Ceil,he as ClipByValue,de as Complex,pe as ComplexAbs,fe as Concat,me as Conv2D,ge as Conv2DBackpropFilter,be as Conv2DBackpropInput,ye as Conv3D,we as Conv3DBackpropFilterV2,ke as Conv3DBackpropInputV2,ve as Cos,xe as Cosh,Se as CropAndResize,Ee as Cumsum,e as DataStorage,Ae as DenseBincount,Ie as DepthToSpace,$e as DepthwiseConv2dNative,_e as DepthwiseConv2dNativeBackpropFilter,Me as DepthwiseConv2dNativeBackpropInput,Ne as Diag,Te as Dilation2D,Re as Dilation2DBackpropFilter,De as Dilation2DBackpropInput,z as ENV,Ce as Einsum,Be as Elu,Pe as EluGrad,F as Environment,Le as Equal,ze as Erf,Oe as Exp,Ke as ExpandDims,We as Expm1,Ue as FFT,qe as Fill,Ge as FlipLeftRight,He as Floor,Ve as FloorDiv,Cn as FromPixels,je as FusedBatchNorm,zn as FusedConv2D,Ln as FusedDepthwiseConv2D,Ye as GatherNd,Je as GatherV2,Ze as Greater,Xe as GreaterEqual,et as IFFT,Qe as Identity,tt as Imag,nt as IsFinite,rt as IsInf,st as IsNan,t as KernelBackend,mt as LRN,gt as LRNGrad,ot as LeakyRelu,at as Less,it as LessEqual,lt as LinSpace,ut as Log,ct as Log1p,ft as LogSoftmax,ht as LogicalAnd,dt as LogicalNot,pt as LogicalOr,bt as Max,wt as MaxPool,vt as MaxPool3D,xt as MaxPool3DGrad,kt as MaxPoolGrad,Et as MaxPoolWithArgmax,yt as Maximum,St as Mean,At as Min,It as Minimum,$t as MirrorPad,_t as Mod,ih as MomentumOptimizer,Mt as Multinomial,Nt as Multiply,Tt as Neg,Rt as NonMaxSuppressionV3,Ft as NonMaxSuppressionV4,Ct as NonMaxSuppressionV5,Dt as NotEqual,Lr as OP_SCOPE_SUFFIX,Pt as OneHot,Bt as OnesLike,th as Optimizer,zt as Pack,Lt as PadV2,Ot as Pool,Kt as Pow,Wt as Prelu,Ut as Prod,lh as RMSPropOptimizer,qt as Range,fr as Rank,Gt as Real,Fe as RealDiv,Ht as Reciprocal,zc as Reduction,Vt as Relu,Qt as Relu6,jt as Reshape,Zt as ResizeBilinear,Xt as ResizeBilinearGrad,Jt as ResizeNearestNeighbor,Yt as ResizeNearestNeighborGrad,en as Reverse,Bn as RotateWithOffset,tn as Round,nn as Rsqrt,ah as SGDOptimizer,rn as ScatterNd,sn as Select,on as Selu,hn as Sigmoid,cn as Sign,ln as Sin,un as Sinh,an as Slice,bn as Softmax,dn as Softplus,mn as SpaceToBatchND,yn as SparseReshape,wn as SparseToDense,gn as SplitV,pn as Sqrt,vn as Square,kn as SquaredDifference,Fn as Step,xn as StridedSlice,En as Sub,fn as Sum,Sn as Tan,An as Tanh,dr as Tensor,ur as TensorBuffer,In as Tile,$n as TopK,_n as Transform,Mn as Transpose,Nn as Unique,Tn as Unpack,Dn as UnsortedSegmentSum,pr as Variable,Rn as ZerosLike,Pn as _FusedMatMul,Yo as abs,Zo as acos,Xo as acosh,Ho as add,Qo as addN,ea as all,ta as any,na as argMax,ra as argMin,sa as asin,oa as asinh,aa as atan,ia as atan2,la as atanh,va as avgPool,xa as avgPool3d,qo as backend,gh as backend_util,$a as basicLSTMCell,Ma as batchNorm,Na as batchNorm2d,Ta as batchNorm3d,Da as batchNorm4d,_a as batchToSpaceND,Ra as bincount,Ku as booleanMaskAsync,Fa as broadcastTo,Ys as browser,Es as buffer,Ss as cast,Ca as ceil,Ba as clipByValue,As as clone,Kr as complex,Ea as concat,Pa as concat1d,za as concat2d,La as concat3d,Oa as concat4d,Wa as conv1d,Ka as conv2d,qa as conv2dTranspose,Ga as conv3d,Va as conv3dTranspose,Jn as copyRegisteredKernels,ja as cos,Ja as cosh,Ju as cosineWindow,Ya as cumsum,zi as customGrad,Za as denseBincount,_o as deprecationWarn,Xa as depthToSpace,Qa as depthwiseConv2d,Rr as device_util,ei as diag,ti as dilation2d,$o as disableDeprecationWarnings,Fo as dispose,Mo as disposeVariables,jo as div,ii as divNoNan,li as dot,Vu as dropout,ui as einsum,ci as elu,Io as enableDebugMode,Ao as enableProdMode,ju as enclosingPowerOfTwo,No as engine,B as env,si as equal,hi as erf,di as exp,pi as expandDims,fi as expm1,gi as eye,gu as fft,bi as fill,Ko as findBackend,Wo as findBackendFactory,yi as floor,Vo as floorDiv,ic as fused,wi as gather,Hu as gatherND,Xs as gather_util,Lo as getBackend,Un as getGradient,Wn as getKernel,qn as getKernelsForBackend,Ri as grad,Fi as grads,ki as greater,vi as greaterEqual,bu as ifft,xi as imag,Zc as image,Yu as inTopKAsync,Ls as io,yu as irfft,Ei as isFinite,Si as isInf,Ai as isNaN,Co as keep,bh as kernel_impls,Ii as leakyRelu,$i as less,_i as lessEqual,Xc as linalg,Mi as linspace,Ni as localResponseNormalization,Ti as log,Di as log1p,Wi as logSigmoid,Hi as logSoftmax,Yi as logSumExp,Zi as logicalAnd,Xi as logicalNot,Qi as logicalOr,el as logicalXor,Qc as losses,Os as matMul,qs as math,Ui as max,tl as maxPool,nl as maxPool3d,rl as maxPoolWithArgmax,sl as maximum,ol as mean,To as memory,ll as meshgrid,ul as min,cl as minimum,hl as mirrorPad,dl as mod,fl as moments,Uu as movingAverage,Jo as mul,ml as multiRNNCell,gl as multinomial,Oi as neg,dh as nextFrame,Wu as norm,bl as notEqual,Ks as oneHot,il as ones,yl as onesLike,Or as op,wl as outerProduct,kl as pad,vl as pad1d,xl as pad2d,El as pad3d,Sl as pad4d,Il as pool,$l as pow,_l as prelu,Is as print,Ml as prod,Do as profile,Nl as rand,Ul as randomGamma,ql as randomNormal,Gl as randomUniform,Hl as range,zo as ready,Vl as real,jl as reciprocal,Uo as registerBackend,Hn as registerGradient,Gn as registerKernel,Jl as relu,Yl as relu6,Oo as removeBackend,ka as reshape,Zl as reverse,Xl as reverse1d,Ql as reverse2d,eu as reverse3d,tu as reverse4d,ku as rfft,nu as round,ru as rsqrt,su as scalar,qu as scatterND,no as scatter_util,ou as selu,au as separableConv2d,wo as serialization,Po as setBackend,Go as setPlatform,iu as setdiff1dAsync,Sa as sigmoid,lu as sign,Yc as signal,uu as sin,cu as sinh,Aa as slice,hu as slice1d,du as slice2d,pu as slice3d,fu as slice4d,mo as slice_util,mu as softmax,Ki as softplus,Al as spaceToBatchND,eh as sparse,Gu as sparseToDense,Jc as spectral,wu as split,vu as sqrt,pl as square,xu as squaredDifference,Eu as squeeze,Su as stack,Au as step,Iu as stridedSlice,qi as sub,Gi as sum,vr as sumOutType,$u as tan,Ia as tanh,Ur as tensor,_u as tensor1d,Mu as tensor2d,Gs as tensor3d,Nu as tensor4d,Tu as tensor5d,Du as tensor6d,Ar as tensor_util,Eo as test_util,Ro as tidy,mi as tile,Bo as time,Ru as topk,ch as train,Ws as transpose,Fu as truncatedNormal,Cu as unique,jn as unregisterGradient,Vn as unregisterKernel,Bu as unsortedSegmentSum,Pu as unstack,kr as upcastType,tr as util,Ci as valueAndGrad,Bi as valueAndGrads,zu as variable,Pi as variableGrads,So as version_core,oi as where,Ou as whereAsync,al as zeros,ai as zerosLike};
//# sourceMappingURL=tf-core.fesm.min.js.map
